# SparseMatrixColorings.jl

[![Build Status](https://github.com/juliadiff/SparseMatrixColorings.jl/actions/workflows/Test.yml/badge.svg?branch=main)](https://github.com/juliadiff/SparseMatrixColorings.jl/actions/workflows/Test.yml?query=branch%3Amain)
[![GPU build status](https://badge.buildkite.com/7d8ed289d7bdb5a25ae48b2c778a202ce4990b7ee558cdfef8.svg?branch=main)](https://buildkite.com/julialang/sparsematrixcolorings-dot-jl)
[![Coverage](https://codecov.io/gh/juliadiff/SparseMatrixColorings.jl/branch/main/graph/badge.svg)](https://app.codecov.io/gh/juliadiff/SparseMatrixColorings.jl)

[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliadiff.org/SparseMatrixColorings.jl/stable/)
[![Dev Documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliadiff.org/SparseMatrixColorings.jl/dev/)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/JuliaDiff/BlueStyle)
[![arXiv](https://img.shields.io/badge/arXiv-2505.07308-b31b1b.svg)](https://arxiv.org/abs/2505.07308)
[![DOI](https://zenodo.org/badge/801999408.svg)](https://zenodo.org/doi/10.5281/zenodo.11314275)

Coloring algorithms for sparse Jacobian and Hessian matrices.

## Getting started

To install this package, run the following in a Julia Pkg REPL:

```julia
pkg> add SparseMatrixColorings
```

## Background

The algorithms implemented in this package are described in the following preprint:

- [_Revisiting Sparse Matrix Coloring and Bicoloring_](https://arxiv.org/abs/2505.07308), Montoison et al. (2025)

and inspired by previous works:

- [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
- [_New Acyclic and Star Coloring Algorithms with Application to Computing Hessians_](https://epubs.siam.org/doi/abs/10.1137/050639879), Gebremedhin et al. (2007)
- [_Efficient Computation of Sparse Hessians Using Coloring and Automatic Differentiation_](https://pubsonline.informs.org/doi/abs/10.1287/ijoc.1080.0286), Gebremedhin et al. (2009)
- [_ColPack: Software for graph coloring and related problems in scientific computing_](https://dl.acm.org/doi/10.1145/2513109.2513110), Gebremedhin et al. (2013)

Some parts of the articles (like definitions) are thus copied verbatim in the documentation.

## Alternatives

- [ColPack.jl](https://github.com/michel2323/ColPack.jl): a Julia interface to the C++ library [ColPack](https://github.com/CSCsw/ColPack)
- [SparseDiffTools.jl](https://github.com/JuliaDiff/SparseDiffTools.jl): contains Julia implementations of some coloring algorithms

## Citing

Please cite this software using the provided `CITATION.cff` file or the `.bib` entry below:

```bibtex
@unpublished{montoison2025revisitingsparsematrixcoloring,
      title={Revisiting Sparse Matrix Coloring and Bicoloring}, 
      author={Alexis Montoison and Guillaume Dalle and Assefaw Gebremedhin},
      year={2025},
      eprint={2505.07308},
      archivePrefix={arXiv},
      primaryClass={math.NA},
      url={https://arxiv.org/abs/2505.07308}, 
}
```

The link <https://zenodo.org/doi/10.5281/zenodo.11314275> resolves to the latest version on Zenodo.

using BenchmarkTools
using LinearAlgebra
using SparseMatrixColorings
import SparseMatrixColorings as SMC
using SparseArrays
using StableRNGs

SUITE = BenchmarkGroup()

for structure in [:nonsymmetric, :symmetric],
    partition in (structure == :nonsymmetric ? [:column, :row, :bidirectional] : [:column]),
    decompression in (
        if (structure == :nonsymmetric && partition in [:column, :row])
            [:direct]
        else
            [:direct, :substitution]
        end
    ),
    n in [10^3, 10^5],
    p in [2 / n, 5 / n, 10 / n]

    problem = ColoringProblem(; structure, partition)
    algo = GreedyColoringAlgorithm(
        RandomOrder(StableRNG(0), 0); decompression, postprocessing=true
    )

    # use several random matrices to reduce variance
    nb_samples = 5
    As = [sparse(Symmetric(sprand(StableRNG(i), Bool, n, n, p))) for i in 1:nb_samples]
    results = [coloring(A, problem, algo; decompression_eltype=Float64) for A in As]
    Bs = [compress(Float64.(A), result) for (A, result) in zip(As, results)]

    bench_col = @benchmarkable begin
        for A in $As
            coloring(A, $problem, $algo)
        end
    end

    bench_dec = @benchmarkable begin
        for (B, result) in zip($Bs, $results)
            if B isa AbstractMatrix
                decompress(B, result)
            elseif B isa Tuple
                decompress(B[1], B[2], result)
            end
        end
    end

    SUITE[:coloring][structure][partition][decompression]["n=$n"]["p=$p"] = bench_col
    SUITE[:decompress][structure][partition][decompression]["n=$n"]["p=$p"] = bench_dec
end

for structure in [:nonsymmetric, :symmetric],
    partition in (structure == :nonsymmetric ? [:column, :row] : [:column]),
    order in [LargestFirst(), SmallestLast(), IncidenceDegree(), DynamicLargestFirst()],
    n in [10^3, 10^5],
    p in [2 / n, 5 / n, 10 / n]

    nb_samples = 5
    As = [sparse(Symmetric(sprand(StableRNG(i), Bool, n, n, p))) for i in 1:nb_samples]
    if structure == :symmetric
        gs = [SMC.AdjacencyGraph(A) for A in As]
        bench_ord = @benchmarkable begin
            for g in $gs
                SMC.vertices(g, $order)
            end
        end
    else
        gs = [SMC.BipartiteGraph(A) for A in As]
        valside = partition == :row ? Val(1) : Val(2)
        bench_ord = @benchmarkable begin
            for g in $gs
                SMC.vertices(g, $valside, $order)
            end
        end
    end
    SUITE[:order][structure][partition][string(order)]["n=$n"]["p=$p"] = bench_ord
end

using ADTypes: column_coloring, row_coloring, symmetric_coloring
using LinearAlgebra
using SparseArrays
using SparseMatrixColorings
using StableRNGs
using Test

rng = StableRNG(63)

asymmetric_params = vcat(
    [(10, 20, p) for p in (0.0:0.1:0.5)],
    [(20, 10, p) for p in (0.0:0.1:0.5)],
    [(100, 200, p) for p in (0.01:0.01:0.05)],
    [(200, 100, p) for p in (0.01:0.01:0.05)],
)

symmetric_params = vcat(
    [(10, p) for p in (0.0:0.1:0.5)], #
    [(100, p) for p in (0.01:0.01:0.05)],
)

@testset "Column coloring & decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    @testset "$((; m, n, p))" for (m, n, p) in asymmetric_params
        A0 = sprand(rng, m, n, p)
        color0 = column_coloring(A0, algo)
        test_coloring_decompression(A0, problem, algo; color0)
    end
    @testset "$((; n, p))" for (n, p) in symmetric_params
        A0 = sparse(Symmetric(sprand(rng, n, n, p)))
        color0 = column_coloring(A0, algo)
        test_coloring_decompression(A0, problem, algo; color0)
    end
end;

@testset "Row coloring & decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    @testset "$((; m, n, p))" for (m, n, p) in asymmetric_params
        A0 = sprand(rng, m, n, p)
        color0 = row_coloring(A0, algo)
        test_coloring_decompression(A0, problem, algo; color0)
    end
    @testset "$((; n, p))" for (n, p) in symmetric_params
        A0 = sparse(Symmetric(sprand(rng, n, n, p)))
        color0 = row_coloring(A0, algo)
        test_coloring_decompression(A0, problem, algo; color0)
    end
end;

@testset "Symmetric coloring & direct decompression" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    @testset for algo in (
        GreedyColoringAlgorithm(; postprocessing=false, decompression=:direct),
        GreedyColoringAlgorithm(; postprocessing=true, decompression=:direct),
    )
        @testset "$((; n, p))" for (n, p) in symmetric_params
            A0 = sparse(Symmetric(sprand(rng, n, n, p)))
            color0 = algo.postprocessing ? nothing : symmetric_coloring(A0, algo)
            test_coloring_decompression(A0, problem, algo; color0)
        end
    end
end;

@testset "Symmetric coloring & substitution decompression" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    @testset for algo in (
        GreedyColoringAlgorithm(; postprocessing=false, decompression=:substitution),
        GreedyColoringAlgorithm(; postprocessing=true, decompression=:substitution),
    )
        @testset "$((; n, p))" for (n, p) in symmetric_params
            A0 = sparse(Symmetric(sprand(rng, n, n, p)))
            # TODO: find tests for recoverability
            test_coloring_decompression(A0, problem, algo)
        end
    end
end;

@testset "Bicoloring & direct decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
    @testset for algo in (
        GreedyColoringAlgorithm(
            RandomOrder(StableRNG(0), 0); postprocessing=false, decompression=:direct
        ),
        GreedyColoringAlgorithm(
            RandomOrder(StableRNG(0), 0); postprocessing=true, decompression=:direct
        ),
    )
        @testset "$((; m, n, p))" for (m, n, p) in asymmetric_params
            A0 = sprand(rng, m, n, p)
            test_bicoloring_decompression(A0, problem, algo)
        end
        @testset "$((; n, p))" for (n, p) in symmetric_params
            A0 = sparse(Symmetric(sprand(rng, n, n, p)))
            test_bicoloring_decompression(A0, problem, algo)
        end
    end
end;

@testset "Bicoloring & substitution decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
    @testset for algo in (
        GreedyColoringAlgorithm(
            RandomOrder(StableRNG(0), 0); postprocessing=false, decompression=:substitution
        ),
        GreedyColoringAlgorithm(
            RandomOrder(StableRNG(0), 0); postprocessing=true, decompression=:substitution
        ),
    )
        @testset "$((; m, n, p))" for (m, n, p) in asymmetric_params
            A0 = sprand(rng, m, n, p)
            test_bicoloring_decompression(A0, problem, algo)
        end
        @testset "$((; n, p))" for (n, p) in symmetric_params
            A0 = sparse(Symmetric(sprand(rng, n, n, p)))
            test_bicoloring_decompression(A0, problem, algo)
        end
    end
end;

struct InvalidColoringError <: Exception end

"""
    partial_distance2_coloring(
        bg::BipartiteGraph, ::Val{side}, vertices_in_order::AbstractVector;
        forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing
    )

Compute a distance-2 coloring of the given `side` (`1` or `2`) in the bipartite graph `bg` and return a vector of integer colors.

A _distance-2 coloring_ is such that two vertices have different colors if they are at distance at most 2.

The vertices are colored in a greedy fashion, following the order supplied.

The optional `forced_colors` keyword argument is used to enforce predefined vertex colors (e.g. coming from another optimization algorithm) but still run the distance-2 coloring procedure to verify correctness.

# See also

- [`BipartiteGraph`](@ref)
- [`AbstractOrder`](@ref)

# References

> [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005), Algorithm 3.2
"""
function partial_distance2_coloring(
    bg::BipartiteGraph{T},
    ::Val{side},
    vertices_in_order::AbstractVector{<:Integer};
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
) where {T,side}
    color = Vector{T}(undef, nb_vertices(bg, Val(side)))
    forbidden_colors = Vector{T}(undef, nb_vertices(bg, Val(side)))
    partial_distance2_coloring!(
        color, forbidden_colors, bg, Val(side), vertices_in_order; forced_colors
    )
    return color
end

function partial_distance2_coloring!(
    color::AbstractVector{<:Integer},
    forbidden_colors::AbstractVector{<:Integer},
    bg::BipartiteGraph,
    ::Val{side},
    vertices_in_order::AbstractVector{<:Integer};
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
) where {side}
    color .= 0
    forbidden_colors .= 0
    other_side = 3 - side
    for v in vertices_in_order
        for w in neighbors(bg, Val(side), v)
            for x in neighbors(bg, Val(other_side), w)
                color_x = color[x]
                if !iszero(color_x)
                    forbidden_colors[color_x] = v
                end
            end
        end
        if isnothing(forced_colors)
            for i in eachindex(forbidden_colors)
                if forbidden_colors[i] != v
                    color[v] = i
                    break
                end
            end
        else
            f = forced_colors[v]
            if (
                (f == 0 && length(neighbors(bg, Val(side), v)) > 0) ||
                (f > 0 && forbidden_colors[f] == v)
            )
                throw(InvalidColoringError())
            else
                color[v] = f
            end
        end
    end
end

"""
    star_coloring(
        g::AdjacencyGraph, vertices_in_order::AbstractVector, postprocessing::Bool;
        forced_colors::Union{AbstractVector,Nothing}=nothing
    )

Compute a star coloring of all vertices in the adjacency graph `g` and return a tuple `(color, star_set)`, where

- `color` is the vector of integer colors
- `star_set` is a [`StarSet`](@ref) encoding the set of 2-colored stars

A _star coloring_ is a distance-1 coloring such that every path on 4 vertices uses at least 3 colors.

The vertices are colored in a greedy fashion, following the order supplied.

If `postprocessing=true`, some colors might be replaced with `0` (the "neutral" color) as long as they are not needed during decompression.

The optional `forced_colors` keyword argument is used to enforce predefined vertex colors (e.g. coming from another optimization algorithm) but still run the star coloring procedure to verify correctness and build auxiliary data structures, useful during decompression.

# See also

- [`AdjacencyGraph`](@ref)
- [`AbstractOrder`](@ref)

# References

> [_New Acyclic and Star Coloring Algorithms with Application to Computing Hessians_](https://epubs.siam.org/doi/abs/10.1137/050639879), Gebremedhin et al. (2007), Algorithm 4.1
"""
function star_coloring(
    g::AdjacencyGraph{T},
    vertices_in_order::AbstractVector{<:Integer},
    postprocessing::Bool;
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
) where {T<:Integer}
    # Initialize data structures
    nv = nb_vertices(g)
    ne = nb_edges(g)
    color = zeros(T, nv)
    forbidden_colors = zeros(T, nv)
    first_neighbor = fill((zero(T), zero(T), zero(T)), nv)  # at first no neighbors have been encountered
    treated = zeros(T, nv)
    star = Vector{T}(undef, ne)
    hub = T[]  # one hub for each star, including the trivial ones

    for v in vertices_in_order
        for (w, index_vw) in neighbors_with_edge_indices(g, v)
            augmented_graph(g) || (v == w && continue)
            color_w = color[w]
            iszero(color_w) && continue
            forbidden_colors[color_w] = v
            (p, q, _) = first_neighbor[color_w]
            if p == v  # Case 1
                if treated[q] != v
                    # forbid colors of neighbors of q
                    _treat!(treated, forbidden_colors, g, v, q, color)
                end
                # forbid colors of neighbors of w
                _treat!(treated, forbidden_colors, g, v, w, color)
            else
                first_neighbor[color[w]] = (v, w, index_vw)
                for (x, index_wx) in neighbors_with_edge_indices(g, w)
                    augmented_graph(g) || (w == x && continue)
                    color_x = color[x]
                    (x == v || iszero(color_x)) && continue
                    if x == hub[star[index_wx]]  # potential Case 2 (which is always false for trivial stars with two vertices, since the associated hub is negative)
                        forbidden_colors[color_x] = v
                    end
                end
            end
        end
        if isnothing(forced_colors)
            for i in eachindex(forbidden_colors)
                if forbidden_colors[i] != v
                    color[v] = i
                    break
                end
            end
        else
            if forbidden_colors[forced_colors[v]] == v  # TODO: handle forced_colors[v] == 0
                throw(InvalidColoringError())
            else
                color[v] = forced_colors[v]
            end
        end
        _update_stars!(star, hub, g, v, color, first_neighbor)
    end
    star_set = StarSet(star, hub)
    if postprocessing
        # Reuse the vector forbidden_colors to compute offsets during post-processing
        offsets = forbidden_colors
        postprocess!(color, star_set, g, offsets)
    end
    return color, star_set
end

function _treat!(
    # modified
    treated::AbstractVector{<:Integer},
    forbidden_colors::AbstractVector{<:Integer},
    # not modified
    g::AdjacencyGraph,
    v::Integer,
    w::Integer,
    color::AbstractVector{<:Integer},
)
    for x in neighbors(g, w)
        augmented_graph(g) || (w == x && continue)
        color_x = color[x]
        iszero(color_x) && continue
        forbidden_colors[color_x] = v
    end
    treated[w] = v
    return nothing
end

function _update_stars!(
    # modified
    star::AbstractVector{<:Integer},
    hub::AbstractVector{<:Integer},
    # not modified
    g::AdjacencyGraph,
    v::Integer,
    color::AbstractVector{<:Integer},
    first_neighbor::AbstractVector{<:Tuple},
)
    for (w, index_vw) in neighbors_with_edge_indices(g, v)
        augmented_graph(g) || (v == w && continue)
        color_w = color[w]
        iszero(color_w) && continue
        x_exists = false
        for (x, index_wx) in neighbors_with_edge_indices(g, w)
            augmented_graph(g) || (w == x && continue)
            if x != v && color[x] == color[v]  # vw, wx ∈ E
                star_wx = star[index_wx]
                hub[star_wx] = w  # this may already be true
                star[index_vw] = star_wx
                x_exists = true
                break
            end
        end
        if !x_exists
            (p, q, index_pq) = first_neighbor[color_w]
            if p == v && q != w  # vw, vq ∈ E and color[w] = color[q]
                star_vq = star[index_pq]
                hub[star_vq] = v  # this may already be true
                star[index_vw] = star_vq
            else  # vw forms a new star
                push!(hub, -max(v, w))  # star is trivial (composed only of two vertices) so we set the hub to a negative value, but it allows us to choose one of the two vertices
                star[index_vw] = length(hub)
            end
        end
    end
    return nothing
end

"""
    StarSet

Encode a set of 2-colored stars resulting from the [`star_coloring`](@ref) algorithm.

# Fields

$TYPEDFIELDS
"""
struct StarSet{T}
    "a mapping from edges (pair of vertices) to their star index"
    star::Vector{T}
    "a mapping from star indices to their hub (undefined hubs for single-edge stars are the negative value of one of the vertices, picked arbitrarily)"
    hub::Vector{T}
end

"""
    acyclic_coloring(g::AdjacencyGraph, vertices_in_order::AbstractVector, postprocessing::Bool)

Compute an acyclic coloring of all vertices in the adjacency graph `g` and return a tuple `(color, tree_set)`, where

- `color` is the vector of integer colors
- `tree_set` is a [`TreeSet`](@ref) encoding the set of 2-colored trees

An _acyclic coloring_ is a distance-1 coloring with the further restriction that every cycle uses at least 3 colors.

The vertices are colored in a greedy fashion, following the order supplied.

If `postprocessing=true`, some colors might be replaced with `0` (the "neutral" color) as long as they are not needed during decompression.

# See also

- [`AdjacencyGraph`](@ref)
- [`AbstractOrder`](@ref)

# References

> [_New Acyclic and Star Coloring Algorithms with Application to Computing Hessians_](https://epubs.siam.org/doi/abs/10.1137/050639879), Gebremedhin et al. (2007), Algorithm 3.1
"""
function acyclic_coloring(
    g::AdjacencyGraph{T}, vertices_in_order::AbstractVector{<:Integer}, postprocessing::Bool
) where {T<:Integer}
    # Initialize data structures
    nv = nb_vertices(g)
    ne = nb_edges(g)
    color = zeros(T, nv)
    forbidden_colors = zeros(T, nv)
    first_neighbor = fill((zero(T), zero(T), zero(T)), nv)  # at first no neighbors have been encountered
    first_visit_to_tree = fill((zero(T), zero(T)), ne)
    forest = Forest{T}(ne)

    for v in vertices_in_order
        for w in neighbors(g, v)
            augmented_graph(g) || (v == w && continue)
            color_w = color[w]
            iszero(color_w) && continue
            forbidden_colors[color_w] = v
        end
        for w in neighbors(g, v)
            augmented_graph(g) || (v == w && continue)
            iszero(color[w]) && continue
            for (x, index_wx) in neighbors_with_edge_indices(g, w)
                augmented_graph(g) || (w == x && continue)
                color_x = color[x]
                iszero(color_x) && continue
                if forbidden_colors[color_x] != v
                    _prevent_cycle!(
                        v,
                        w,
                        index_wx,
                        color_x,
                        first_visit_to_tree,
                        forbidden_colors,
                        forest,
                    )
                end
            end
        end
        # TODO: handle forced colors
        for i in eachindex(forbidden_colors)
            if forbidden_colors[i] != v
                color[v] = i
                break
            end
        end
        for (w, index_vw) in neighbors_with_edge_indices(g, v)  # grow two-colored stars around the vertex v
            augmented_graph(g) || (v == w && continue)
            color_w = color[w]
            iszero(color_w) && continue
            _grow_star!(v, w, index_vw, color_w, first_neighbor, forest)
        end
        for (w, index_vw) in neighbors_with_edge_indices(g, v)
            augmented_graph(g) || (v == w && continue)
            iszero(color[w]) && continue
            for (x, index_wx) in neighbors_with_edge_indices(g, w)
                augmented_graph(g) || (w == x && continue)
                color_x = color[x]
                (x == v || iszero(color_x)) && continue
                if color_x == color[v]
                    _merge_trees!(index_vw, index_wx, forest)  # merge trees T₁ ∋ vw and T₂ ∋ wx if T₁ != T₂
                end
            end
        end
    end

    buffer = forbidden_colors
    reverse_bfs_orders = first_visit_to_tree
    tree_set = TreeSet(g, forest, buffer, reverse_bfs_orders, ne)
    if postprocessing
        # Reuse the vector forbidden_colors to compute offsets during post-processing
        offsets = forbidden_colors
        postprocess!(color, tree_set, g, offsets)
    end
    return color, tree_set
end

function _prevent_cycle!(
    # not modified
    v::Integer,
    w::Integer,
    index_wx::Integer,
    color_x::Integer,
    # modified
    first_visit_to_tree::AbstractVector{<:Tuple},
    forbidden_colors::AbstractVector{<:Integer},
    forest::Forest{<:Integer},
)
    root_wx = find_root!(forest, index_wx)  # root of the 2-colored tree T to which the edge wx belongs
    (p, q) = first_visit_to_tree[root_wx]
    if p != v  # T is being visited from vertex v for the first time
        first_visit_to_tree[root_wx] = (v, w)
    elseif q != w  # T is connected to vertex v via at least two edges
        forbidden_colors[color_x] = v
    end
    return nothing
end

function _grow_star!(
    # not modified
    v::Integer,
    w::Integer,
    index_vw::Integer,
    color_w::Integer,
    # modified
    first_neighbor::AbstractVector{<:Tuple},
    forest::Forest{<:Integer},
)
    # Create a new tree T_{vw} consisting only of edge vw
    (p, q, index_pq) = first_neighbor[color_w]
    if p != v  # a neighbor of v with color[w] encountered for the first time
        first_neighbor[color_w] = (v, w, index_vw)
    else  # merge T_{vw} with a two-colored star being grown around v
        root_vw = find_root!(forest, index_vw)
        root_pq = find_root!(forest, index_pq)
        root_union!(forest, root_vw, root_pq)
    end
    return nothing
end

function _merge_trees!(
    # not modified
    index_vw::Integer,
    index_wx::Integer,
    # modified
    forest::Forest{<:Integer},
)
    root_vw = find_root!(forest, index_vw)
    root_wx = find_root!(forest, index_wx)
    if root_vw != root_wx
        root_union!(forest, root_vw, root_wx)
    end
    return nothing
end

"""
    TreeSet

Encode a set of 2-colored trees resulting from the [`acyclic_coloring`](@ref) algorithm.

# Fields

$TYPEDFIELDS
"""
struct TreeSet{T}
    """
    For a tree index `1 <= k <= nt`, the list
    `list = reverse_bfs_order[tree_edge_indices[k]:(tree_edge_indices[k+1]-1)]` is a list of edges
    `list[i] = (leaf, inner)` of the `k`th tree such that `leaf` is a leaf of the tree containing
    the edges `list[i:end]`.
    From an other point of view, `reverse(list)` contains the edges in the order of a breadth first
    (BFS) traversal order of the `k`th tree starting from a depth-minimizing root.
    """
    reverse_bfs_orders::Vector{Tuple{T,T}}
    "For a tree index `1 <= k <= nt`, `is_star[k]` indicates whether the `k`th three is a star."
    is_star::Vector{Bool}
    """
    `tree_edge_indices[1]` is one and `tree_edge_indices[k+1] - tree_edge_indices[k]` is the number of edges in the `k`th tree.
    One can think of it as a kind of fused vector of offsets (similar to the `colptr` field of `SparseMatrixCSC`) of all trees together.
    """
    tree_edge_indices::Vector{T}
    "numbers of 2-colored trees for which trees sharing the same 2 colors have disjoint edges"
    nt::T
end

function TreeSet(
    g::AdjacencyGraph{T},
    forest::Forest{T},
    buffer::AbstractVector{T},
    # The value of `reverse_bfs_orders` is ignored, we just provide the storage for it (or reuse memory allocated during acyclic coloring)
    reverse_bfs_orders::Vector{Tuple{T,T}},
    ne::Integer,
) where {T}
    S = pattern(g)
    edge_to_index = edge_indices(g)
    nv = nb_vertices(g)
    (; nt, ranks, parents) = forest

    # root_to_tree is a vector that maps a tree's root to the index of the tree
    # We can recycle the vector "ranks" because we don't need it anymore to merge trees
    root_to_tree = ranks
    fill!(root_to_tree, zero(T))

    # vector specifying the starting and ending indices of edges for each tree
    tree_edge_indices = zeros(T, nt + 1)

    # number of roots found
    nr = 0

    # determine the number of edges for each tree and map each root to a tree index
    for index_edge in 1:ne
        root = find_root!(forest, index_edge)

        # create a mapping between roots and tree indices
        if iszero(root_to_tree[root])
            nr += 1
            root_to_tree[root] = nr
        end

        # index of the tree that contains this edge
        index_tree = root_to_tree[root]

        # Update the number of edges for the current tree (shifted by 1 to facilitate the final cumsum)
        tree_edge_indices[index_tree + 1] += 1
    end

    # nvmax is the number of vertices in the largest tree of the forest
    # Note: the number of vertices in a tree is equal the number of edges plus one
    nvmax = maximum(tree_edge_indices) + one(T)

    # Vector containing the list of vertices, grouped by tree (each vertex appears once for every tree it belongs to)
    # Note: the total number of edges in the graph is "ne", so there are "ne + nt" vertices across all trees
    tree_vertices = Vector{T}(undef, ne + nt)

    # Provide the positions of the first and last neighbors for each vertex in "tree_vertices", within the tree to which the vertex belongs
    # These positions refer to indices in the vector "tree_neighbors"
    tree_neighbor_indices = zeros(T, ne + nt + 1)

    # Packed representation of the neighbors of each vertex in "tree_vertices"
    tree_neighbors = Vector{T}(undef, 2 * ne)

    # Track the positions for inserting vertices and neighbors per tree
    vertex_position = Vector{T}(undef, nt)
    neighbor_position = Vector{T}(undef, nt)

    # Compute starting positions for vertices and neighbors in each tree
    if nt > 0
        vertex_position[1] = zero(T)
        neighbor_position[1] = zero(T)
    end
    for k in 2:nt
        # Note: tree_edge_indices[k] is the number of edges in the tree k-1
        vertex_position[k] = vertex_position[k - 1] + tree_edge_indices[k] + 1
        neighbor_position[k] = neighbor_position[k - 1] + 2 * tree_edge_indices[k]
    end

    # Record the most recent vertex from which each tree is visited
    visited_trees = zeros(T, nt)

    rvS = rowvals(S)
    for j in axes(S, 2)
        for pos in nzrange(S, j)
            i = rvS[pos]
            if i != j
                index_ij = edge_to_index[pos]

                # No need to call "find_root!" because paths have already been compressed
                root = parents[index_ij]

                # Index of the tree containing edge (i, j)
                index_tree = root_to_tree[root]

                # Position in tree_vertices where vertex j should be found or inserted
                vertex_index = vertex_position[index_tree]

                if visited_trees[index_tree] != j
                    # Mark the current tree as visited from vertex j
                    visited_trees[index_tree] = j

                    # Insert j into tree_vertices
                    vertex_position[index_tree] += 1
                    vertex_index += 1
                    tree_vertices[vertex_index] = j
                end

                # Append neighbor i to the list of neighbors of j in the tree
                neighbor_position[index_tree] += 1
                neighbor_index = neighbor_position[index_tree]
                tree_neighbors[neighbor_index] = i

                # Increment neighbor count for j in the tree (shifted by 1 to facilitate the final cumsum)
                tree_neighbor_indices[vertex_index + 1] += 1
            end
        end
    end

    # Compute a shifted cumulative sum of tree_edge_indices, starting from one
    tree_edge_indices[1] = one(T)
    for k in 2:(nt + 1)
        tree_edge_indices[k] += tree_edge_indices[k - 1]
    end

    # Compute a shifted cumulative sum of tree_neighbor_indices, starting from one
    tree_neighbor_indices[1] = 1
    for k in 2:(ne + nt + 1)
        tree_neighbor_indices[k] += tree_neighbor_indices[k - 1]
    end

    # degrees is a vector of integers that stores the degree of each vertex in a tree
    degrees = buffer

    # For each vertex in the current tree, reverse_mapping will hold its corresponding index in tree_vertices
    reverse_mapping = Vector{T}(undef, nv)

    # Create a queue with a fixed size nvmax
    queue = Vector{T}(undef, nvmax)

    # Determine if each tree in the forest is a star
    # In a star, at most one vertex has a degree strictly greater than one
    is_star = Vector{Bool}(undef, nt)

    # Number of edges treated
    num_edges_treated = zero(T)

    # The `rank` of the `k`th tree encoded in `forest` does not correspond
    # to the depth of the tree rooted as the root encoded in `forest` because
    # `forest.parents[u] = v` only needs a path to exists from `u` to `v` but
    # there may not be an edge `(u, v)`.
    # We also want a root `r` that minimizes the depth of the tree rooted at
    # `r`. To achieve this, we start from each leaf and remove the corresponding
    # edges. We then look at all leaves of the corresponding graphs and repeat
    # the process until there is only one vertex left. This vertex will then be
    # a depth-minimizing root.
    for k in 1:nt
        # Initialize the queue to store the leaves
        queue_start = 1
        queue_end = 0

        # Positions of the first and last vertices in the current tree
        # Note: tree_edge_indices contains the positions of the first and last edges,
        # so we add to add an offset k-1 between edge indices and vertex indices
        first_vertex = tree_edge_indices[k] + (k - 1)
        last_vertex = tree_edge_indices[k + 1] + (k - 1)

        # compute the degree of each vertex in the tree
        for index_vertex in first_vertex:last_vertex
            vertex = tree_vertices[index_vertex]
            degree =
                tree_neighbor_indices[index_vertex + 1] -
                tree_neighbor_indices[index_vertex]
            degrees[vertex] = degree

            # store a reverse mapping to get the position of the vertex in tree_vertices
            reverse_mapping[vertex] = index_vertex

            # the vertex is a leaf
            if degree == 1
                queue_end += 1
                queue[queue_end] = vertex
            end
        end

        # number of vertices in the tree
        nv_tree = tree_edge_indices[k + 1] - tree_edge_indices[k] + 1

        # Check that no more than one vertex has a degree strictly greater than one
        # "queue_end" currently represents the number of vertices considered as leaves in the tree before any pruning
        is_star[k] = queue_end >= nv_tree - 1

        # continue until all leaves are treated
        while queue_start <= queue_end
            leaf = queue[queue_start]
            queue_start += 1

            # Mark the vertex as removed
            degrees[leaf] = 0

            # Position of the leaf in tree_vertices
            index_leaf = reverse_mapping[leaf]

            # Positions of the first and last neighbors of the leaf in the current tree
            first_neighbor = tree_neighbor_indices[index_leaf]
            last_neighbor = tree_neighbor_indices[index_leaf + 1] - 1

            # Iterate over all neighbors of the leaf to be pruned
            for index_neighbor in first_neighbor:last_neighbor
                neighbor = tree_neighbors[index_neighbor]

                # Check if neighbor is the parent of the leaf or if it was a child before the tree was pruned
                if degrees[neighbor] != 0
                    # (leaf, neighbor) represents the next edge to visit during decompression
                    num_edges_treated += 1
                    reverse_bfs_orders[num_edges_treated] = (leaf, neighbor)

                    # reduce the degree of the neighbor
                    degrees[neighbor] -= 1

                    # check if the neighbor is now a leaf
                    if degrees[neighbor] == 1
                        queue_end += 1
                        queue[queue_end] = neighbor
                    end
                end
            end
        end
    end

    return TreeSet(reverse_bfs_orders, is_star, tree_edge_indices, nt)
end

## From ADTypes to SMC

function coloring(
    A::AbstractMatrix,
    problem::ColoringProblem{structure,partition},
    algo::ADTypes.AbstractColoringAlgorithm;
    decompression_eltype::Type{R}=Float64,
    symmetric_pattern::Bool=false,
) where {structure,partition,R}
    symmetric_pattern = symmetric_pattern || A isa Union{Symmetric,Hermitian}
    if structure == :nonsymmetric
        if partition == :column
            forced_colors = ADTypes.column_coloring(A, algo)
        elseif partition == :row
            forced_colors = ADTypes.row_coloring(A, algo)
        else
            # TODO: improve once https://github.com/SciML/ADTypes.jl/issues/69 is done
            A_and_Aᵀ, _ = bidirectional_pattern(A; symmetric_pattern)
            forced_colors = ADTypes.symmetric_coloring(A_and_Aᵀ, algo)
        end
    else
        forced_colors = ADTypes.symmetric_coloring(A, algo)
    end
    return _coloring(
        WithResult(),
        A,
        problem,
        GreedyColoringAlgorithm(),
        R,
        symmetric_pattern;
        forced_colors,
    )
end

using ADTypes: column_coloring, row_coloring, symmetric_coloring
using JET
using LinearAlgebra
using SparseArrays
using SparseMatrixColorings
using SparseMatrixColorings: matrix_versions, respectful_similar, all_orders
using StableRNGs
using Test

rng = StableRNG(63)

@testset "Sparse coloring" begin
    n = 10
    A = sparse(Symmetric(sprand(rng, n, n, 5 / n)))

    # ADTypes
    @testset "ADTypes" begin
        @test_opt column_coloring(A, GreedyColoringAlgorithm())
        @test_opt row_coloring(A, GreedyColoringAlgorithm())
        @test_opt symmetric_coloring(Symmetric(A), GreedyColoringAlgorithm())

        @inferred column_coloring(A, GreedyColoringAlgorithm())
        @inferred row_coloring(A, GreedyColoringAlgorithm())
        @inferred symmetric_coloring(Symmetric(A), GreedyColoringAlgorithm())
    end

    @testset "$structure - $partition - $decompression" for (
        structure, partition, decompression
    ) in [
        (:nonsymmetric, :column, :direct),
        (:nonsymmetric, :row, :direct),
        (:symmetric, :column, :direct),
        (:symmetric, :column, :substitution),
        (:nonsymmetric, :bidirectional, :direct),
        (:nonsymmetric, :bidirectional, :substitution),
    ]
        @testset for order in all_orders()
            @test_opt coloring(
                A,
                ColoringProblem(; structure, partition),
                GreedyColoringAlgorithm(order; decompression),
            )
            @test_opt coloring(
                A,
                ColoringProblem(; structure, partition),
                GreedyColoringAlgorithm((NaturalOrder(), order); decompression),
            )
            @inferred coloring(
                A,
                ColoringProblem(; structure, partition),
                GreedyColoringAlgorithm(order; decompression),
            )
            @inferred coloring(
                A,
                ColoringProblem(; structure, partition),
                GreedyColoringAlgorithm((NaturalOrder(), order); decompression),
            )
        end
    end
end;

@testset "Structured coloring" begin
    n = 10
    @testset "$(nameof(typeof(A))) - $structure - $partition - $decompression" for A in [
            Diagonal(rand(n)),
            Bidiagonal(rand(n), rand(n - 1), 'U'),
            Bidiagonal(rand(n), rand(n - 1), 'L'),
            Tridiagonal(rand(n - 1), rand(n), rand(n - 1)),
        ],
        (structure, partition, decompression) in
        [(:nonsymmetric, :column, :direct), (:nonsymmetric, :row, :direct)]

        @test_opt coloring(
            A,
            ColoringProblem(; structure, partition),
            GreedyColoringAlgorithm(; decompression),
        )
        @inferred coloring(
            A,
            ColoringProblem(; structure, partition),
            GreedyColoringAlgorithm(; decompression),
        )
    end
end;

@testset "Sparse decompression" begin
    n = 10
    A0 = sparse(Symmetric(sprand(rng, n, n, 5 / n)))

    @testset "$structure - $partition - $decompression" for (
        structure, partition, decompression
    ) in [
        (:nonsymmetric, :column, :direct),
        (:nonsymmetric, :row, :direct),
        (:symmetric, :column, :direct),
        (:symmetric, :column, :substitution),
        (:nonsymmetric, :bidirectional, :direct),
        (:nonsymmetric, :bidirectional, :substitution),
    ]
        @testset "A::$(typeof(A))" for A in matrix_versions(A0)
            result = coloring(
                A0,
                ColoringProblem(; structure, partition),
                GreedyColoringAlgorithm(; decompression);
                decompression_eltype=eltype(A),
            )
            if partition == :bidirectional
                Br, Bc = compress(A, result)
                @testset "Full decompression" begin
                    @test_opt compress(A, result)
                    @test_opt decompress(Br, Bc, result)
                    @test_opt decompress!(respectful_similar(A), Br, Bc, result)

                    @inferred compress(A, result)
                    @inferred decompress(Br, Bc, result)
                end
            else
                B = compress(A, result)
                @testset "Full decompression" begin
                    @test_opt compress(A, result)
                    @test_opt decompress(B, result)
                    @test_opt decompress!(respectful_similar(A), B, result)

                    @inferred compress(A, result)
                    @inferred decompress(B, result)
                end
                @testset "Single-color decompression" begin
                    if decompression == :direct
                        b = if partition == :column
                            B[:, 1]
                        else
                            B[1, :]
                        end
                        @test_opt decompress_single_color!(
                            respectful_similar(A), b, 1, result
                        )
                    end
                end
                @testset "Triangle decompression" begin
                    if structure == :symmetric
                        @test_opt decompress!(respectful_similar(triu(A)), B, result, :U)
                    end
                end
                @testset "Single-color triangle decompression" begin
                    if structure == :symmetric && decompression == :direct
                        @test_opt decompress_single_color!(
                            respectful_similar(triu(A)), B[:, 1], 1, result, :U
                        )
                    end
                end
            end
        end
    end
end;

@testset "Structured decompression" begin
    n = 10
    @testset "$(nameof(typeof(A))) - $structure - $partition - $decompression" for A in [
            Diagonal(rand(n)),
            Bidiagonal(rand(n), rand(n - 1), 'U'),
            Bidiagonal(rand(n), rand(n - 1), 'L'),
            Tridiagonal(rand(n - 1), rand(n), rand(n - 1)),
        ],
        (structure, partition, decompression) in
        [(:nonsymmetric, :column, :direct), (:nonsymmetric, :row, :direct)]

        result = coloring(
            A,
            ColoringProblem(; structure, partition),
            GreedyColoringAlgorithm(; decompression);
        )
        B = compress(A, result)
        @test_opt decompress(B, result)
        @inferred decompress(B, result)
    end
end;

@testset "Single precision" begin
    A = convert(
        SparseMatrixCSC{Float32,Int32},
        sparse(Symmetric(sprand(rng, Float32, 100, 100, 0.1))),
    )
    @testset "$structure - $partition - $decompression" for (
        structure, partition, decompression
    ) in [
        (:nonsymmetric, :column, :direct),
        (:nonsymmetric, :row, :direct),
        (:symmetric, :column, :direct),
        (:symmetric, :column, :substitution),
        (:nonsymmetric, :bidirectional, :direct),
        (:nonsymmetric, :bidirectional, :substitution),
    ]
        @testset for order in all_orders()
            result = coloring(
                A,
                ColoringProblem(; structure, partition),
                GreedyColoringAlgorithm(order; decompression);
            )
            if partition in (:column, :bidirectional)
                @test eltype(column_colors(result)) == Int32
                @test eltype(column_groups(result)[1]) == Int32
            end
            if partition in (:row, :bidirectional)
                @test eltype(row_colors(result)) == Int32
                @test eltype(row_groups(result)[1]) == Int32
            end
            if partition == :bidirectional
                Br, Bc = compress(A, result)
                @test decompress(Br, Bc, result) isa SparseMatrixCSC{Float32,Int32}
            else
                B = compress(A, result)
                @test decompress(B, result) isa SparseMatrixCSC{Float32,Int32}
            end
        end
    end
end

## Postprocessing

function postprocess!(
    color::AbstractVector{<:Integer},
    star_or_tree_set::Union{StarSet,TreeSet},
    g::AdjacencyGraph,
    offsets::AbstractVector{<:Integer},
)
    S = pattern(g)
    edge_to_index = edge_indices(g)
    # flag which colors are actually used during decompression
    nb_colors = maximum(color)
    color_used = zeros(Bool, nb_colors)

    # nonzero diagonal coefficients force the use of their respective color (there can be no neutral colors if the diagonal is fully nonzero)
    if !augmented_graph(g)
        for i in axes(S, 1)
            if !iszero(S[i, i])
                color_used[color[i]] = true
            end
        end
    end

    if star_or_tree_set isa StarSet
        # star_or_tree_set is a StarSet
        postprocess_with_star_set!(g, color_used, color, star_or_tree_set)
    else
        # star_or_tree_set is a TreeSet
        postprocess_with_tree_set!(color_used, color, star_or_tree_set)
    end

    # if at least one of the colors is useless, modify the color assignments of vertices
    if any(!, color_used)
        num_colors_useless = 0

        # determine what are the useless colors and compute the offsets
        for ci in 1:nb_colors
            if color_used[ci]
                offsets[ci] = num_colors_useless
            else
                num_colors_useless += 1
            end
        end

        # assign the neutral color to every vertex with a useless color and remap the colors
        for i in eachindex(color)
            ci = color[i]
            if !color_used[ci]
                # assign the neutral color
                color[i] = 0
            else
                # remap the color to not have any gap
                color[i] -= offsets[ci]
            end
        end
    end
    return color
end

function postprocess_with_star_set!(
    g::AdjacencyGraph,
    color_used::Vector{Bool},
    color::AbstractVector{<:Integer},
    star_set::StarSet,
)
    S = pattern(g)
    edge_to_index = edge_indices(g)

    # only the colors of the hubs are used
    (; star, hub) = star_set
    nb_trivial_stars = 0

    # Iterate through all non-trivial stars
    for s in eachindex(hub)
        h = hub[s]
        if h > 0
            color_used[color[h]] = true
        else
            nb_trivial_stars += 1
        end
    end

    # Process the trivial stars (if any)
    if nb_trivial_stars > 0
        rvS = rowvals(S)
        for j in axes(S, 2)
            for k in nzrange(S, j)
                i = rvS[k]
                if i > j
                    index_ij = edge_to_index[k]
                    s = star[index_ij]
                    h = hub[s]
                    if h < 0
                        h = abs(h)
                        spoke = h == j ? i : j
                        if color_used[color[spoke]]
                            # Switch the hub and the spoke to possibly avoid adding one more used color
                            hub[s] = spoke
                        else
                            # Keep the current hub
                            color_used[color[h]] = true
                        end
                    end
                end
            end
        end
    end
    return color_used
end

function postprocess_with_tree_set!(
    color_used::Vector{Bool}, color::AbstractVector{<:Integer}, tree_set::TreeSet
)
    # only the colors of non-leaf vertices are used
    (; reverse_bfs_orders, is_star, tree_edge_indices, nt) = tree_set
    nb_trivial_trees = 0

    # Iterate through all non-trivial trees
    for k in 1:nt
        # Position of the first edge in the tree
        first = tree_edge_indices[k]

        # Total number of edges in the tree
        ne_tree = tree_edge_indices[k + 1] - first

        # Check if we have more than one edge in the tree (non-trivial tree)
        if ne_tree > 1
            # Determine if the tree is a star
            if is_star[k]
                # It is a non-trivial star and only the color of the hub is needed
                (_, hub) = reverse_bfs_orders[first]
                color_used[color[hub]] = true
            else
                # It is not a star and both colors are needed during the decompression
                (i, j) = reverse_bfs_orders[first]
                color_used[color[i]] = true
                color_used[color[j]] = true
            end
        else
            nb_trivial_trees += 1
        end
    end

    # Process the trivial trees (if any)
    if nb_trivial_trees > 0
        for k in 1:nt
            # Position of the first edge in the tree
            first = tree_edge_indices[k]

            # Total number of edges in the tree
            ne_tree = tree_edge_indices[k + 1] - first

            # Check if we have exactly one edge in the tree
            if ne_tree == 1
                (i, j) = reverse_bfs_orders[first]
                if color_used[color[i]]
                    # Make i the root to avoid possibly adding one more used color
                    # Switch it with the (only) leaf
                    reverse_bfs_orders[first] = (j, i)
                else
                    # Keep j as the root
                    color_used[color[j]] = true
                end
            end
        end
    end
    return color_used
end

"""
    compress(A, result::AbstractColoringResult)

Compress `A` given a coloring `result` of the sparsity pattern of `A`.

- If `result` comes from a `:column` (resp. `:row`) partition, the output is a single matrix `B` compressed by column (resp. by row).
- If `result` comes from a `:bidirectional` partition, the output is a tuple of matrices `(Br, Bc)`, where `Br` is compressed by row and `Bc` by column.

Compression means summing either the columns or the rows of `A` which share the same color.
It is undone by calling [`decompress`](@ref) or [`decompress!`](@ref).

# Example

```jldoctest
julia> using SparseMatrixColorings, SparseArrays

julia> A = sparse([
           0 0 4 6 0 9
           1 0 0 0 7 0
           0 2 0 0 8 0
           0 3 5 0 0 0
       ]);

julia> result = coloring(A, ColoringProblem(), GreedyColoringAlgorithm());

julia> collect.(column_groups(result))
3-element Vector{Vector{Int64}}:
 [1, 2, 4]
 [3, 5]
 [6]

julia> B = compress(A, result)
4×3 Matrix{Int64}:
 6  4  9
 1  7  0
 2  8  0
 3  5  0
```

# See also

- [`ColoringProblem`](@ref)
- [`AbstractColoringResult`](@ref)
"""
function compress end

function compress(A, result::AbstractColoringResult{structure,:column}) where {structure}
    group = column_groups(result)
    if isempty(group)
        # ensure we get a Matrix and not a SparseMatrixCSC
        B_model = stack([Int[]]; dims=2) do g
            dropdims(sum(A[:, g]; dims=2); dims=2)
        end
        B = similar(B_model, size(A, 1), 0)
    else
        B = stack(group; dims=2) do g
            dropdims(sum(A[:, g]; dims=2); dims=2)
        end
    end
    return B
end

function compress(A, result::AbstractColoringResult{structure,:row}) where {structure}
    group = row_groups(result)
    if isempty(group)
        # ensure we get a Matrix and not a SparseMatrixCSC
        B_model = stack([Int[]]; dims=1) do g
            dropdims(sum(A[g, :]; dims=1); dims=1)
        end
        B = similar(B_model, 0, size(A, 2))
    else
        B = stack(group; dims=1) do g
            dropdims(sum(A[g, :]; dims=1); dims=1)
        end
    end
    return B
end

function compress(
    A, result::AbstractColoringResult{structure,:bidirectional}
) where {structure}
    row_group = row_groups(result)
    column_group = column_groups(result)
    if isempty(row_group)
        # ensure we get a Matrix and not a SparseMatrixCSC
        Br_model = stack([Int[]]; dims=1) do g
            dropdims(sum(A[g, :]; dims=1); dims=1)
        end
        Br = similar(Br_model, 0, size(A, 2))
    else
        Br = stack(row_group; dims=1) do g
            dropdims(sum(A[g, :]; dims=1); dims=1)
        end
    end
    if isempty(column_group)
        # ensure we get a Matrix and not a SparseMatrixCSC
        Bc_model = stack([Int[]]; dims=2) do g
            dropdims(sum(A[:, g]; dims=2); dims=2)
        end
        Bc = similar(Bc_model, size(A, 1), 0)
    else
        Bc = stack(column_group; dims=2) do g
            dropdims(sum(A[:, g]; dims=2); dims=2)
        end
    end
    return Br, Bc
end

struct UnsupportedDecompressionError <: Exception
    msg::String
end

function Base.showerror(io::IO, err::UnsupportedDecompressionError)
    return print(io, "UnsupportedDecompressionError: $(err.msg)")
end

"""
    decompress(B::AbstractMatrix, result::AbstractColoringResult{_,:column/:row})
    decompress(Br::AbstractMatrix, Bc::AbstractMatrix, result::AbstractColoringResult{_,:bidirectional})

Decompress `B` (or the tuple `(Br,Bc)`) into a new matrix `A`, given a coloring `result` of the sparsity pattern of `A`.
The in-place alternative is [`decompress!`](@ref).

Compression means summing either the columns or the rows of `A` which share the same color.
It is done by calling [`compress`](@ref).

!!! warning
    For some coloring variants, the `result` object is mutated during decompression.

# Example

```jldoctest
julia> using SparseMatrixColorings, SparseArrays

julia> A = sparse([
           0 0 4 6 0 9
           1 0 0 0 7 0
           0 2 0 0 8 0
           0 3 5 0 0 0
       ]);

julia> result = coloring(A, ColoringProblem(), GreedyColoringAlgorithm());

julia> collect.(column_groups(result))
3-element Vector{Vector{Int64}}:
 [1, 2, 4]
 [3, 5]
 [6]

julia> B = compress(A, result)
4×3 Matrix{Int64}:
 6  4  9
 1  7  0
 2  8  0
 3  5  0

julia> decompress(B, result)
4×6 SparseMatrixCSC{Int64, Int64} with 9 stored entries:
 ⋅  ⋅  4  6  ⋅  9
 1  ⋅  ⋅  ⋅  7  ⋅
 ⋅  2  ⋅  ⋅  8  ⋅
 ⋅  3  5  ⋅  ⋅  ⋅

julia> decompress(B, result) == A
true
```

# See also

- [`ColoringProblem`](@ref)
- [`AbstractColoringResult`](@ref)
"""
function decompress(B::AbstractMatrix, result::AbstractColoringResult)
    A = respectful_similar(result.A, eltype(B))
    return decompress!(A, B, result)
end

function decompress(
    Br::AbstractMatrix,
    Bc::AbstractMatrix,
    result::AbstractColoringResult{structure,:bidirectional},
) where {structure}
    A = respectful_similar(result.A, Base.promote_eltype(Br, Bc))
    return decompress!(A, Br, Bc, result)
end

"""
    decompress!(
        A::AbstractMatrix, B::AbstractMatrix,
        result::AbstractColoringResult{_,:column/:row}, [uplo=:F]
    )

    decompress!(
        A::AbstractMatrix, Br::AbstractMatrix, Bc::AbstractMatrix
        result::AbstractColoringResult{_,:bidirectional}
    )

Decompress `B` (or the tuple `(Br,Bc)`) in-place into `A`, given a coloring `result` of the sparsity pattern of `A`.
The out-of-place alternative is [`decompress`](@ref).

!!! note
    In-place decompression is faster when `A isa SparseMatrixCSC`.

Compression means summing either the columns or the rows of `A` which share the same color.
It is done by calling [`compress`](@ref).

For `:symmetric` coloring results (and for those only), an optional positional argument `uplo in (:U, :L, :F)` can be passed to specify which part of the matrix `A` should be updated: the Upper triangle, the Lower triangle, or the Full matrix.
When `A isa SparseMatrixCSC`, using the `uplo` argument requires a target matrix which only stores the relevant triangle(s).

!!! warning
    For some coloring variants, the `result` object is mutated during decompression.

# Example

```jldoctest
julia> using SparseMatrixColorings, SparseArrays

julia> A = sparse([
           0 0 4 6 0 9
           1 0 0 0 7 0
           0 2 0 0 8 0
           0 3 5 0 0 0
       ]);

julia> result = coloring(A, ColoringProblem(), GreedyColoringAlgorithm());

julia> collect.(column_groups(result))
3-element Vector{Vector{Int64}}:
 [1, 2, 4]
 [3, 5]
 [6]

julia> B = compress(A, result)
4×3 Matrix{Int64}:
 6  4  9
 1  7  0
 2  8  0
 3  5  0

julia> A2 = similar(A);

julia> decompress!(A2, B, result)
4×6 SparseMatrixCSC{Int64, Int64} with 9 stored entries:
 ⋅  ⋅  4  6  ⋅  9
 1  ⋅  ⋅  ⋅  7  ⋅
 ⋅  2  ⋅  ⋅  8  ⋅
 ⋅  3  5  ⋅  ⋅  ⋅

julia> A2 == A
true
```

# See also

- [`ColoringProblem`](@ref)
- [`AbstractColoringResult`](@ref)
"""
function decompress! end

"""
    decompress_single_color!(
        A::AbstractMatrix, b::AbstractVector, c::Integer,
        result::AbstractColoringResult, [uplo=:F]
    )

Decompress the vector `b` corresponding to color `c` in-place into `A`, given a `:direct` coloring `result` of the sparsity pattern of `A` (it will not work with a `:substitution` coloring).

- If `result` comes from a `:nonsymmetric` structure with `:column` partition, this will update the columns of `A` that share color `c` (whose sum makes up `b`).
- If `result` comes from a `:nonsymmetric` structure with `:row` partition, this will update the rows of `A` that share color `c` (whose sum makes up `b`).
- If `result` comes from a `:symmetric` structure with `:column` partition, this will update the coefficients of `A` whose value is deduced from color `c`.

!!! warning
    This function will only update some coefficients of `A`, without resetting the rest to zero.

For `:symmetric` coloring results (and for those only), an optional positional argument `uplo in (:U, :L, :F)` can be passed to specify which part of the matrix `A` should be updated: the Upper triangle, the Lower triangle, or the Full matrix.
When `A isa SparseMatrixCSC`, using the `uplo` argument requires a target matrix which only stores the relevant triangle(s).

!!! warning
    For some coloring variants, the `result` object is mutated during decompression.

# Example

```jldoctest
julia> using SparseMatrixColorings, SparseArrays

julia> A = sparse([
           0 0 4 6 0 9
           1 0 0 0 7 0
           0 2 0 0 8 0
           0 3 5 0 0 0
       ]);

julia> result = coloring(A, ColoringProblem(), GreedyColoringAlgorithm());

julia> collect.(column_groups(result))
3-element Vector{Vector{Int64}}:
 [1, 2, 4]
 [3, 5]
 [6]

julia> B = compress(A, result)
4×3 Matrix{Int64}:
 6  4  9
 1  7  0
 2  8  0
 3  5  0

julia> A2 = similar(A); A2 .= 0;

julia> decompress_single_color!(A2, B[:, 2], 2, result)
4×6 SparseMatrixCSC{Int64, Int64} with 9 stored entries:
 ⋅  ⋅  4  0  ⋅  0
 0  ⋅  ⋅  ⋅  7  ⋅
 ⋅  0  ⋅  ⋅  8  ⋅
 ⋅  0  5  ⋅  ⋅  ⋅

julia> A2[:, [3, 5]] == A[:, [3, 5]]
true
```

# See also

- [`ColoringProblem`](@ref)
- [`AbstractColoringResult`](@ref)
- [`decompress!`](@ref)
"""
function decompress_single_color! end

function in_triangle(i::Integer, j::Integer, uplo::Symbol)
    if uplo == :F
        return true
    elseif uplo == :U
        return i <= j
    else  # uplo == :L
        return i >= j
    end
end

## ColumnColoringResult

function decompress!(A::AbstractMatrix, B::AbstractMatrix, result::ColumnColoringResult)
    (; bg, color) = result
    S = bg.S2
    check_compatible_pattern(A, bg)
    fill!(A, zero(eltype(A)))
    rvS = rowvals(S)
    for j in axes(S, 2)
        cj = color[j]
        for k in nzrange(S, j)
            i = rvS[k]
            A[i, j] = B[i, cj]
        end
    end
    return A
end

function decompress_single_color!(
    A::AbstractMatrix, b::AbstractVector, c::Integer, result::ColumnColoringResult
)
    (; bg, group) = result
    S = bg.S2
    check_compatible_pattern(A, bg)
    rvS = rowvals(S)
    for j in group[c]
        for k in nzrange(S, j)
            i = rvS[k]
            A[i, j] = b[i]
        end
    end
    return A
end

function decompress!(A::SparseMatrixCSC, B::AbstractMatrix, result::ColumnColoringResult)
    (; bg, compressed_indices) = result
    S = bg.S2
    check_compatible_pattern(A, bg)
    nzA = nonzeros(A)
    for k in eachindex(nzA, compressed_indices)
        nzA[k] = B[compressed_indices[k]]
    end
    return A
end

function decompress_single_color!(
    A::SparseMatrixCSC, b::AbstractVector, c::Integer, result::ColumnColoringResult
)
    (; bg, group) = result
    S = bg.S2
    check_compatible_pattern(A, bg)
    rvS = rowvals(S)
    nzA = nonzeros(A)
    for j in group[c]
        for k in nzrange(S, j)
            i = rvS[k]
            nzA[k] = b[i]
        end
    end
    return A
end

## RowColoringResult

function decompress!(A::AbstractMatrix, B::AbstractMatrix, result::RowColoringResult)
    (; bg, color) = result
    S = bg.S2
    check_compatible_pattern(A, bg)
    fill!(A, zero(eltype(A)))
    rvS = rowvals(S)
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rvS[k]
            ci = color[i]
            A[i, j] = B[ci, j]
        end
    end
    return A
end

function decompress_single_color!(
    A::AbstractMatrix, b::AbstractVector, c::Integer, result::RowColoringResult
)
    (; bg, group) = result
    S, Sᵀ = bg.S2, bg.S1
    check_compatible_pattern(A, bg)
    rvSᵀ = rowvals(Sᵀ)
    for i in group[c]
        for k in nzrange(Sᵀ, i)
            j = rvSᵀ[k]
            A[i, j] = b[j]
        end
    end
    return A
end

function decompress!(A::SparseMatrixCSC, B::AbstractMatrix, result::RowColoringResult)
    (; bg, compressed_indices) = result
    S = bg.S2
    check_compatible_pattern(A, bg)
    nzA = nonzeros(A)
    for k in eachindex(nzA, compressed_indices)
        nzA[k] = B[compressed_indices[k]]
    end
    return A
end

## StarSetColoringResult

function decompress!(
    A::AbstractMatrix, B::AbstractMatrix, result::StarSetColoringResult, uplo::Symbol=:F
)
    (; ag, compressed_indices) = result
    (; S) = ag
    check_compatible_pattern(A, ag, uplo)
    fill!(A, zero(eltype(A)))

    rvS = rowvals(S)
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rvS[k]
            if in_triangle(i, j, uplo)
                A[i, j] = B[compressed_indices[k]]
            end
        end
    end
    return A
end

function decompress_single_color!(
    A::AbstractMatrix,
    b::AbstractVector,
    c::Integer,
    result::StarSetColoringResult,
    uplo::Symbol=:F,
)
    (; ag, compressed_indices, group) = result
    (; S) = ag
    check_compatible_pattern(A, ag, uplo)

    lower_index = (c - 1) * S.n + 1
    upper_index = c * S.n
    rvS = rowvals(S)
    for j in group[c]
        for k in nzrange(S, j)
            # Check if the color c is used to recover A[i,j] / A[j,i]
            if lower_index <= compressed_indices[k] <= upper_index
                i = rvS[k]
                if i == j
                    # Recover the diagonal coefficients of A
                    A[i, i] = b[i]
                else
                    # Recover the off-diagonal coefficients of A
                    if in_triangle(i, j, uplo)
                        A[i, j] = b[i]
                    end
                    if in_triangle(j, i, uplo)
                        A[j, i] = b[i]
                    end
                end
            end
        end
    end
    return A
end

function decompress!(
    A::SparseMatrixCSC, B::AbstractMatrix, result::StarSetColoringResult, uplo::Symbol=:F
)
    (; ag, compressed_indices) = result
    (; S) = ag
    nzA = nonzeros(A)
    check_compatible_pattern(A, ag, uplo)
    if uplo == :F
        for k in eachindex(nzA, compressed_indices)
            nzA[k] = B[compressed_indices[k]]
        end
    else
        rvS = rowvals(S)
        l = 0  # assume A has the same pattern as the triangle
        for j in axes(S, 2)
            for k in nzrange(S, j)
                i = rvS[k]
                if in_triangle(i, j, uplo)
                    l += 1
                    nzA[l] = B[compressed_indices[k]]
                end
            end
        end
    end
    return A
end

## TreeSetColoringResult

function decompress!(
    A::AbstractMatrix, B::AbstractMatrix, result::TreeSetColoringResult, uplo::Symbol=:F
)
    (; ag, color, reverse_bfs_orders, tree_edge_indices, nt, diagonal_indices, buffer) =
        result
    (; S) = ag
    check_compatible_pattern(A, ag, uplo)
    R = eltype(A)
    fill!(A, zero(R))

    if eltype(buffer) == R
        buffer_right_type = buffer
    else
        buffer_right_type = similar(buffer, R)
    end

    # Recover the diagonal coefficients of A
    if !augmented_graph(ag)
        for i in diagonal_indices
            A[i, i] = B[i, color[i]]
        end
    end

    # Recover the off-diagonal coefficients of A
    for k in 1:nt
        # Positions of the first and last edges of the tree
        first = tree_edge_indices[k]
        last = tree_edge_indices[k + 1] - 1

        # Reset the buffer to zero for all vertices in the tree (except the root)
        for pos in first:last
            (vertex, _) = reverse_bfs_orders[pos]
            buffer_right_type[vertex] = zero(R)
        end
        # Reset the buffer to zero for the root vertex
        (_, root) = reverse_bfs_orders[last]
        buffer_right_type[root] = zero(R)

        for pos in first:last
            (i, j) = reverse_bfs_orders[pos]
            val = B[i, color[j]] - buffer_right_type[i]
            buffer_right_type[j] = buffer_right_type[j] + val

            if in_triangle(i, j, uplo)
                A[i, j] = val
            end
            if in_triangle(j, i, uplo)
                A[j, i] = val
            end
        end
    end
    return A
end

"""
   decompress_csc!(
        nzA::AbstractVector{R},
        A_colptr::AbstractVector,
        B::AbstractMatrix{R},
        result::TreeSetColoringResult,
        uplo::Symbol=:F,
    ) where {R<:Real}

Decompress the values of `B` into the vector of nonzero entries `nzA` of a
sparse matrix with column pointers `colptr`. This function assumes that the
row indices are sorted in increasing order and are the same as those of the
sparse matrix given to the `coloring` function that returned `result`.
"""
function decompress_csc!(
    nzA::AbstractVector{R},
    A_colptr::AbstractVector{<:Integer},
    B::AbstractMatrix{R},
    result::TreeSetColoringResult,
    uplo::Symbol=:F,
) where {R<:Real}
    (;
        ag,
        color,
        reverse_bfs_orders,
        tree_edge_indices,
        nt,
        diagonal_indices,
        diagonal_nzind,
        lower_triangle_offsets,
        upper_triangle_offsets,
        buffer,
    ) = result

    if eltype(buffer) == R
        buffer_right_type = buffer
    else
        buffer_right_type = similar(buffer, R)
    end

    # Recover the diagonal coefficients of A
    if !augmented_graph(ag)
        if uplo == :L
            for i in diagonal_indices
                # A[i, i] is the first element in column i
                nzind = A_colptr[i]
                nzA[nzind] = B[i, color[i]]
            end
        elseif uplo == :U
            for i in diagonal_indices
                # A[i, i] is the last element in column i
                nzind = A_colptr[i + 1] - 1
                nzA[nzind] = B[i, color[i]]
            end
        else  # uplo == :F
            for (k, i) in enumerate(diagonal_indices)
                nzind = diagonal_nzind[k]
                nzA[nzind] = B[i, color[i]]
            end
        end
    end

    # Index of offsets in lower_triangle_offsets and upper_triangle_offsets
    counter = 0

    # Recover the off-diagonal coefficients of A
    for k in 1:nt
        # Positions of the first and last edges of the tree
        first = tree_edge_indices[k]
        last = tree_edge_indices[k + 1] - 1

        # Reset the buffer to zero for all vertices in the tree (except the root)
        for pos in first:last
            (vertex, _) = reverse_bfs_orders[pos]
            buffer_right_type[vertex] = zero(R)
        end
        # Reset the buffer to zero for the root vertex
        (_, root) = reverse_bfs_orders[last]
        buffer_right_type[root] = zero(R)

        for pos in first:last
            (i, j) = reverse_bfs_orders[pos]
            counter += 1
            val = B[i, color[j]] - buffer_right_type[i]
            buffer_right_type[j] = buffer_right_type[j] + val

            #! format: off
            # A[i,j] is in the lower triangular part of A
            if in_triangle(i, j, :L)
                # uplo = :L or uplo = :F
                # A[i,j] is stored at index_ij = (A.colptr[j+1] - offset_L) in A.nzval
                if uplo != :U
                    nzind = A_colptr[j + 1] - lower_triangle_offsets[counter]
                    nzA[nzind] = val
                end

                # uplo = :U or uplo = :F
                # A[j,i] is stored at index_ji = (A.colptr[i] + offset_U) in A.nzval
                if uplo != :L
                    nzind = A_colptr[i] + upper_triangle_offsets[counter]
                    nzA[nzind] = val
                end

            # A[i,j] is in the upper triangular part of A
            else
                # uplo = :U or uplo = :F
                # A[i,j] is stored at index_ij = (A.colptr[j] + offset_U) in A.nzval
                if uplo != :L
                    nzind = A_colptr[j] + upper_triangle_offsets[counter]
                    nzA[nzind] = val
                end

                # uplo = :L or uplo = :F
                # A[j,i] is stored at index_ji = (A.colptr[i+1] - offset_L) in A.nzval
                if uplo != :U
                    nzind = A_colptr[i + 1] - lower_triangle_offsets[counter]
                    nzA[nzind] = val
                end
            end
            #! format: on
        end
    end
    return nothing
end

function decompress!(
    A::SparseMatrixCSC{R},
    B::AbstractMatrix{R},
    result::TreeSetColoringResult,
    uplo::Symbol=:F,
) where {R<:Real}
    check_compatible_pattern(A, result.ag, uplo)
    decompress_csc!(nonzeros(A), A.colptr, B, result, uplo)
    return A
end

## MatrixInverseColoringResult

function decompress!(
    A::AbstractMatrix,
    B::AbstractMatrix,
    result::LinearSystemColoringResult,
    uplo::Symbol=:F,
)
    (; ag, color, strict_upper_nonzero_inds, M_factorization, strict_upper_nonzeros_A) =
        result
    S = ag.S
    check_compatible_pattern(A, ag, uplo)

    # TODO: for some reason I cannot use ldiv! with a sparse QR
    strict_upper_nonzeros_A = M_factorization \ vec(B)
    fill!(A, zero(eltype(A)))
    for i in axes(A, 1)
        if !iszero(S[i, i])
            A[i, i] = B[i, color[i]]
        end
    end
    for (l, (i, j)) in enumerate(strict_upper_nonzero_inds)
        if in_triangle(i, j, uplo)
            A[i, j] = strict_upper_nonzeros_A[l]
        end
        if in_triangle(j, i, uplo)
            A[j, i] = strict_upper_nonzeros_A[l]
        end
    end
    return A
end

## BicoloringResult

function _join_compressed!(result::BicoloringResult, Br::AbstractMatrix, Bc::AbstractMatrix)
    #=
    Say we have an original matrix `A` of size `(n, m)` and we build an augmented matrix `A_and_Aᵀ = [zeros(n, n) Aᵀ; A zeros(m, m)]`.
    Its first `1:n` columns have the form `[zeros(n); A[:, j]]` and its following `n+1:n+m` columns have the form `[A[i, :]; zeros(m)]`.
    The symmetric column coloring is performed on `A_and_Aᵀ` and the column-wise compression of `A_and_Aᵀ` should return a matrix `Br_and_Bc`.
    But in reality, `Br_and_Bc` is computed as two partial compressions: the row-wise compression `Br` (corresponding to `Aᵀ`) and the columnwise compression `Bc` (corresponding to `A`).
    Before symmetric decompression, we must reconstruct `Br_and_Bc` from `Br` and `Bc`, knowing that the symmetric colors (those making up `Br_and_Bc`) are present in either a row of `Br`, a column of `Bc`, or both.
    Therefore, the column indices in `Br_and_Bc` don't necessarily match with the row indices in `Br` or the column indices in `Bc` since some colors may be missing in the partial compressions.
    The columns of the top part of `Br_and_Bc` (rows `1:n`) are the rows of `Br`, interlaced with zero columns whenever the current color hasn't been used to color any row.
    The columns of the bottom part of `Br_and_Bc` (rows `n+1:n+m`) are the columns of `Bc`, interlaced with zero columns whenever the current color hasn't been used to color any column.
    We use the vectors `symmetric_to_row` and `symmetric_to_column` to map from symmetric colors to row and column colors.
    =#
    (; A, symmetric_to_column, symmetric_to_row) = result
    m, n = size(A)
    R = Base.promote_eltype(Br, Bc)
    if eltype(result.Br_and_Bc) == R
        Br_and_Bc = result.Br_and_Bc
    else
        Br_and_Bc = similar(result.Br_and_Bc, R)
    end
    fill!(Br_and_Bc, zero(R))
    for c in axes(Br_and_Bc, 2)
        if symmetric_to_row[c] > 0  # some rows were colored with the symmetric color c
            copyto!(view(Br_and_Bc, 1:n, c), view(Br, symmetric_to_row[c], :))
        end
        if symmetric_to_column[c] > 0  # some columns were colored with the symmetric color c
            copyto!(
                view(Br_and_Bc, (n + 1):(n + m), c), view(Bc, :, symmetric_to_column[c])
            )
        end
    end
    return Br_and_Bc
end

function decompress!(
    A::AbstractMatrix, Br::AbstractMatrix, Bc::AbstractMatrix, result::BicoloringResult
)
    (; large_colptr, large_rowval, symmetric_result) = result
    m, n = size(A)
    R = eltype(A)
    fill!(A, zero(R))
    nzval = Vector{R}(undef, length(large_rowval))
    A_and_noAᵀ = SparseMatrixCSC(m + n, m + n, large_colptr, large_rowval, nzval)
    Br_and_Bc = _join_compressed!(result, Br, Bc)
    decompress!(A_and_noAᵀ, Br_and_Bc, symmetric_result, :L)
    rvA = rowvals(A_and_noAᵀ)
    nzA = nonzeros(A_and_noAᵀ)
    for j in 1:n
        for k in nzrange(A_and_noAᵀ, j)
            i = rvA[k]
            A[i - n, j] = nzA[k]
        end
    end
    return A
end

function decompress!(
    A::SparseMatrixCSC, Br::AbstractMatrix, Bc::AbstractMatrix, result::BicoloringResult
)
    (; large_colptr, large_rowval, symmetric_result) = result
    m, n = size(A)
    # pretend A is larger
    A_and_noAᵀ = SparseMatrixCSC(m + n, m + n, large_colptr, large_rowval, A.nzval)
    # decompress lower triangle only
    Br_and_Bc = _join_compressed!(result, Br, Bc)
    decompress!(A_and_noAᵀ, Br_and_Bc, symmetric_result, :L)
    return A
end

using SparseMatrixColorings
using SparseMatrixColorings: group_by_color, UnsupportedDecompressionError
using Test

@testset "Group by color" begin
    for n in 10 .^ (2, 3, 4), cmax in (1, 2, 10, 100), iteration in 1:10
        color = rand(1:cmax, n)
        group = group_by_color(color)
        @test length(group) == maximum(color)
        @test all(1:maximum(color)) do c
            all(color[group[c]] .== c) && issorted(group[c])
        end

        color = rand(0:cmax, n)
        group = group_by_color(color)
        @test length(group) == maximum(color)
        @test all(1:maximum(color)) do c
            all(color[group[c]] .== c) && issorted(group[c])
        end
    end
end

@testset "Empty compression" begin
    A = zeros(Bool, 10, 10)
    color = zeros(Int, 10)
    problem = ColoringProblem{:nonsymmetric,:column}()
    algo = ConstantColoringAlgorithm(A, color; partition=:column)
    B = compress(A, coloring(A, problem, algo))
    @test size(B, 2) == 0
    problem = ColoringProblem{:nonsymmetric,:row}()
    algo = ConstantColoringAlgorithm(A, color; partition=:row)
    B = compress(A, coloring(A, problem, algo))
    @test size(B, 1) == 0
end

@testset "Errors" begin
    e = SparseMatrixColorings.UnsupportedDecompressionError("hello")
    @test sprint(showerror, e) == "UnsupportedDecompressionError: hello"
end

using ADTypes: ADTypes
using SparseMatrixColorings
using SparseMatrixColorings: InvalidColoringError
using Test

matrix_template = ones(Bool, 10, 20)
sym_matrix_template = ones(Bool, 10, 10)

@testset "Column coloring" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
    color = collect(1:20)
    algo = ConstantColoringAlgorithm(matrix_template, color; partition=:column)
    wrong_algo = ConstantColoringAlgorithm{:row}(matrix_template, color)
    wrong_color = ConstantColoringAlgorithm{:column}(matrix_template, ones(Int, 20))
    @test_throws DimensionMismatch coloring(transpose(matrix_template), problem, algo)
    @test_throws MethodError coloring(matrix_template, problem, wrong_algo)
    @test_throws InvalidColoringError coloring(matrix_template, problem, wrong_color)
    result = coloring(matrix_template, problem, algo)
    @test column_colors(result) == color
    @test ADTypes.column_coloring(matrix_template, algo) == color
    @test_throws MethodError ADTypes.row_coloring(matrix_template, algo)
end

@testset "Row coloring" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    color = collect(1:10)
    algo = ConstantColoringAlgorithm(matrix_template, color; partition=:row)
    wrong_algo = ConstantColoringAlgorithm{:column}(matrix_template, color)
    wrong_color = ConstantColoringAlgorithm{:row}(matrix_template, ones(Int, 10))
    @test_throws DimensionMismatch coloring(transpose(matrix_template), problem, algo)
    @test_throws MethodError coloring(matrix_template, problem, wrong_algo)
    @test_throws InvalidColoringError coloring(matrix_template, problem, wrong_color)
    result = coloring(matrix_template, problem, algo)
    @test row_colors(result) == color
    @test ADTypes.row_coloring(matrix_template, algo) == color
    @test_throws MethodError ADTypes.column_coloring(matrix_template, algo)
end

@testset "Symmetric coloring" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    color = collect(1:10)
    algo = ConstantColoringAlgorithm(
        sym_matrix_template, color; partition=:column, structure=:symmetric
    )
    wrong_algo = ConstantColoringAlgorithm{:column,:nonsymmetric}(
        sym_matrix_template, color
    )
    wrong_color = ConstantColoringAlgorithm{:column,:symmetric}(
        sym_matrix_template, ones(Int, 20)
    )
    @test_throws DimensionMismatch coloring(matrix_template, problem, algo)
    @test_throws MethodError coloring(sym_matrix_template, problem, wrong_algo)
    @test_throws InvalidColoringError coloring(sym_matrix_template, problem, wrong_color)
    result = coloring(sym_matrix_template, problem, algo)
    @test column_colors(result) == color
    @test ADTypes.symmetric_coloring(sym_matrix_template, algo) == color
    @test_throws MethodError ADTypes.column_coloring(sym_matrix_template, algo)
end

using SparseArrays
using SparseMatrixColorings
using Test

## Banded

#=
Per the recovery paper "Efficient computation of sparse Hessians using Coloring and Automatic Differentiation", for a symmetric banded matrix with ρ non-diagonal bands:
- acyclic coloring uses ⌊ρ/2⌋+1 colors
- star coloring uses 2⌊ρ/2⌋+1 colors
=#

problem = ColoringProblem(; structure=:symmetric, partition=:column)

function banded_matrix(n::Integer, ρ::Integer)
    return spdiagm([k => ones(Bool, n - abs(k)) for k in (-(ρ ÷ 2)):(ρ ÷ 2)]...)
end

@testset "Star coloring" begin
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    for n in [5, 10, 20] .* 1000
        S = banded_matrix(n, 10)
        direct_result = coloring(S, problem, algo)
        @test length(column_groups(direct_result)) == 11

        S = banded_matrix(n, 20)
        direct_result = coloring(S, problem, algo)
        @test length(column_groups(direct_result)) == 21
    end
end

@testset "Acyclic coloring" begin
    algo = GreedyColoringAlgorithm(; decompression=:substitution)
    for n in [5, 10, 20] .* 1000
        S = banded_matrix(n, 10)
        substitution_result = coloring(S, problem, algo)
        @test length(column_groups(substitution_result)) == 6

        S = banded_matrix(n, 20)
        substitution_result = coloring(S, problem, algo)
        @test length(column_groups(substitution_result)) == 11
    end
end

using Documenter
using DocumenterInterLinks
using SparseMatrixColorings

links = InterLinks("ADTypes" => "https://sciml.github.io/ADTypes.jl/stable/")

cp(joinpath(@__DIR__, "..", "README.md"), joinpath(@__DIR__, "src", "index.md"); force=true)

makedocs(;
    modules=[SparseMatrixColorings],
    authors="Guillaume Dalle and Alexis Montoison",
    sitename="SparseMatrixColorings.jl",
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
        "tutorial.md",
        "api.md",
        "Developer Documentation" => ["dev.md", "vis.md"],
    ],
    plugins=[links],
)

deploydocs(;
    repo="github.com/JuliaDiff/SparseMatrixColorings.jl",
    push_preview=true,
    devbranch="main",
)

using ADTypes: ADTypes
using SparseArrays
using LinearAlgebra
using SparseMatrixColorings
using Test

@testset "NoColoringAlgorithm" begin
    @testset "Column coloring" begin
        problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
        algo = ADTypes.NoColoringAlgorithm()
        A = sprand(10, 20, 0.3)
        result = coloring(A, problem, algo)
        B = compress(A, result)
        @test size(B) == size(A)
        @test column_colors(result) == ADTypes.column_coloring(A, algo)
        @test decompress(B, result) == A
    end

    @testset "Row coloring" begin
        problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
        algo = ADTypes.NoColoringAlgorithm()
        A = sprand(10, 20, 0.3)
        result = coloring(A, problem, algo)
        B = compress(A, result)
        @test size(B) == size(A)
        @test row_colors(result) == ADTypes.row_coloring(A, algo)
        @test decompress(B, result) == A
    end

    @testset "Symmetric coloring" begin
        problem = ColoringProblem(; structure=:symmetric, partition=:column)
        algo = ADTypes.NoColoringAlgorithm()
        A = Symmetric(sprand(20, 20, 0.3))
        result = coloring(A, problem, algo)
        B = compress(A, result)
        @test size(B) == size(A)
        @test column_colors(result) == ADTypes.column_coloring(A, algo)
        @test decompress(B, result) == A
    end

    @testset "Bicoloring" begin
        problem = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
        algo = ADTypes.NoColoringAlgorithm()
        A = sprand(10, 20, 0.3)
        result = coloring(A, problem, algo)
        Br, Bc = compress(A, result)
        @test decompress(Br, Bc, result) == A
    end
end

using cuSPARSE: CuSparseMatrixCSC, CuSparseMatrixCSR
using LinearAlgebra
using SparseArrays
using SparseMatrixColorings
import SparseMatrixColorings as SMC
using StableRNGs
using Test

rng = StableRNG(63)

asymmetric_params = vcat(
    [(10, 20, p) for p in (0.0:0.2:0.5)],
    [(20, 10, p) for p in (0.0:0.2:0.5)],
    [(100, 200, p) for p in (0.01:0.02:0.05)],
    [(200, 100, p) for p in (0.01:0.02:0.05)],
)

symmetric_params = vcat(
    [(10, p) for p in (0.0:0.2:0.5)], #
    [(100, p) for p in (0.01:0.02:0.05)],
)

@testset verbose = true "Column coloring & decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    @testset for T in (CuSparseMatrixCSC, CuSparseMatrixCSR)
        @testset "$((; m, n, p))" for (m, n, p) in asymmetric_params
            A0 = T(sprand(rng, m, n, p))
            test_coloring_decompression(A0, problem, algo; gpu=true)
        end
    end
end;

@testset verbose = true "Row coloring & decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    @testset for T in (CuSparseMatrixCSC, CuSparseMatrixCSR)
        @testset "$((; m, n, p))" for (m, n, p) in asymmetric_params
            A0 = T(sprand(rng, m, n, p))
            test_coloring_decompression(A0, problem, algo; gpu=true)
        end
    end
end;

@testset verbose = true "Symmetric coloring & direct decompression" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; postprocessing=false, decompression=:direct)
    @testset for T in (CuSparseMatrixCSC, CuSparseMatrixCSR)
        @testset "$((; n, p))" for (n, p) in symmetric_params
            A0 = T(sparse(Symmetric(sprand(rng, n, n, p))))
            test_coloring_decompression(A0, problem, algo; gpu=true)
        end
        A0 = T(sparse(Diagonal(ones(10))))
        result = coloring(A0, problem, algo)
        B = compress(A0, result)
        @test_throws SMC.UnsupportedDecompressionError decompress!(
            similar(A0), B, result, :U
        )
    end
end;

# Stub for Colors.jl extension in ext/SparseMatrixColoringsColorsExt.jl

"""
    show_colors(result; kwargs...)

Create a visualization for an [`AbstractColoringResult`](@ref), with the help of the [JuliaImages](https://juliaimages.org) ecosystem.

- For `:column` or `:row` colorings, it returns a couple `(A_img, B_img)`.
- For `:bidirectional` colorings, it returns a 4-tuple `(Ar_img, Ac_img, Br_img, Bc_img)`.

!!! warning
    This function is implemented in a package extension, using it requires loading [Colors.jl](https://github.com/JuliaGraphics/Colors.jl).

# Keyword arguments

- `colorscheme`: colors used for non-zero matrix entries. This can be a vector of `Colorant`s or a subsampled scheme from [ColorSchemes.jl](https://github.com/JuliaGraphics/ColorSchemes.jl).
- `background_color::Colorant`: color used for zero matrix entries and pad. Defaults to `RGBA(0,0,0,0)`, a transparent background.
- `border_color::Colorant`: color used around matrix entries. Defaults to `RGB(0, 0, 0)`, a black border.
- `scale::Int`: scale the size of matrix entries to `scale × scale` pixels. Defaults to `1`.
- `border::Int`: set border width around matrix entries, in pixles. Defaults to `0`. 
- `pad::Int`: set padding between matrix entries, in pixels. Defaults to `0`. 

For a matrix of size `(m, n)`, the resulting output will be of size `(m * (scale + 2border + pad) + pad, n * (scale + 2border + pad) + pad)`.
"""
function show_colors end

using LinearAlgebra
using SparseArrays
using SparseMatrixColorings:
    structurally_orthogonal_columns,
    symmetrically_orthogonal_columns,
    structurally_biorthogonal,
    directly_recoverable_columns,
    substitutable_columns,
    substitutable_bidirectional,
    what_fig_41,
    efficient_fig_1
using Test

@testset "Structurally orthogonal columns" begin
    A = [
        1 0 0
        0 2 0
        0 3 4
    ]

    # success

    @test structurally_orthogonal_columns(A, [1, 2, 3])
    @test structurally_orthogonal_columns(A, [1, 2, 1])
    @test structurally_orthogonal_columns(A, [1, 1, 2])

    @test directly_recoverable_columns(A, [1, 2, 3])
    @test directly_recoverable_columns(A, [1, 2, 1])
    @test directly_recoverable_columns(A, [1, 1, 2])

    # failure

    @test !structurally_orthogonal_columns(A, [1, 2])
    log = (:warn, "2 colors provided for 3 columns.")
    @test_logs log structurally_orthogonal_columns(A, [1, 2]; verbose=true)

    @test !directly_recoverable_columns(A, [1, 2])
    log = (:warn, "2 colors provided for 3 columns.")
    @test_logs log !directly_recoverable_columns(A, [1, 2]; verbose=true)

    @test !structurally_orthogonal_columns(A, [1, 2, 2])
    log = (:warn, "In color 2, columns [2, 3] all have nonzeros in row 3.")
    @test_logs log structurally_orthogonal_columns(A, [1, 2, 2]; verbose=true)

    @test !directly_recoverable_columns(A, [1, 2, 2])
    log = (:warn, "Coefficients [3, 4] are not directly recoverable.")
end

@testset "Structurally orthogonal rows" begin
    A = [
        1 0 0
        0 2 0
        0 3 4
    ]

    # success

    @test structurally_orthogonal_columns(transpose(A), [1, 2, 3])
    @test structurally_orthogonal_columns(transpose(A), [1, 2, 1])
    @test structurally_orthogonal_columns(transpose(A), [1, 1, 2])

    @test directly_recoverable_columns(transpose(A), [1, 2, 3])
    @test directly_recoverable_columns(transpose(A), [1, 2, 1])
    @test directly_recoverable_columns(transpose(A), [1, 1, 2])

    # failure

    @test !structurally_orthogonal_columns(transpose(A), [1, 2, 2, 3])
    log = (:warn, "4 colors provided for 3 columns.")
    @test_logs log structurally_orthogonal_columns(transpose(A), [1, 2, 2, 3]; verbose=true)

    @test !directly_recoverable_columns(transpose(A), [1, 2, 2, 3])
    log = (:warn, "4 colors provided for 3 columns.")
    @test_logs log directly_recoverable_columns(transpose(A), [1, 2, 2, 3]; verbose=true)

    @test !structurally_orthogonal_columns(transpose(A), [1, 2, 2])
    log = (:warn, "In color 2, columns [2, 3] all have nonzeros in row 2.")
    @test_logs log !structurally_orthogonal_columns(transpose(A), [1, 2, 2]; verbose=true)

    @test !directly_recoverable_columns(transpose(A), [1, 2, 2])
    log = (:warn, "Coefficients [2, 3] are not directly recoverable.")
    @test_logs log directly_recoverable_columns(transpose(A), [1, 2, 2]; verbose=true)
end

@testset "Symmetrically orthogonal" begin
    A = what_fig_41().A
    @test issymmetric(A)

    # success

    @test symmetrically_orthogonal_columns(A, [1, 2, 1, 3, 1, 1])

    @test directly_recoverable_columns(A, [1, 2, 1, 3, 1, 1])

    # failure

    @test !symmetrically_orthogonal_columns(A, [1, 2, 1, 3, 1])
    @test_logs (:warn, "5 colors provided for 6 columns.") symmetrically_orthogonal_columns(
        A, [1, 2, 1, 3, 1]; verbose=true
    )

    @test !symmetrically_orthogonal_columns(A, [1, 3, 1, 3, 1, 1])
    @test_logs (
        :warn,
        """
For coefficient (i=2, j=3) with colors (ci=3, cj=1):
- In row color ci=3, rows [2, 4] all have nonzeros in column j=3.
- In column color cj=1, columns [1, 3, 5, 6] all have nonzeros in row i=2.
""",
    ) symmetrically_orthogonal_columns(A, [1, 3, 1, 3, 1, 1]; verbose=true)

    A = efficient_fig_1().A
    @test issymmetric(A)

    # success

    @test symmetrically_orthogonal_columns(A, [1, 2, 1, 3, 1, 4, 3, 5, 1, 2])

    # failure

    @test !symmetrically_orthogonal_columns(A, [1, 2, 1, 3, 1, 4, 3, 4, 1, 2])
    @test !symmetrically_orthogonal_columns(A, [1, 2, 1, 3, 1, 4, 2, 5, 1, 2])
    @test !symmetrically_orthogonal_columns(A, [1, 2, 1, 4, 1, 4, 3, 5, 1, 2])

    @test !directly_recoverable_columns(A, [1, 2, 1, 3, 1, 4, 3, 4, 1, 2])
    @test !directly_recoverable_columns(A, [1, 2, 1, 3, 1, 4, 2, 5, 1, 2])
    @test !directly_recoverable_columns(A, [1, 2, 1, 4, 1, 4, 3, 5, 1, 2])
end

@testset "Structurally biorthogonal" begin
    A = [
        1 5 7 9 11
        2 0 0 0 12
        3 0 0 0 13
        4 6 8 10 14
    ]

    # success

    @test structurally_biorthogonal(A, [1, 2, 2, 3], [1, 2, 2, 2, 3])

    # failure

    @test !structurally_biorthogonal(A, [1, 2, 2, 3], [1, 2, 2, 2])
    @test !structurally_biorthogonal(A, [1, 2, 2, 3, 4], [1, 2, 2, 2, 3])
    @test !structurally_biorthogonal(A, [1, 1, 1, 2], [1, 1, 1, 1, 2])

    @test_logs (:warn, "4 colors provided for 5 columns.") !structurally_biorthogonal(
        A, [1, 2, 2, 3], [1, 2, 2, 2]; verbose=true
    )
    @test_logs (:warn, "5 colors provided for 4 rows.") !structurally_biorthogonal(
        A, [1, 2, 2, 3, 4], [1, 2, 2, 2, 3]; verbose=true
    )
    @test_logs (
        :warn,
        """
For coefficient (i=1, j=1) with colors (ci=1, cj=1):
- In row color ci=1, rows [1, 2, 3] all have nonzeros in column j=1.
- In column color cj=1, columns [1, 2, 3, 4] all have nonzeros in row i=1.
""",
    ) !structurally_biorthogonal(A, [1, 1, 1, 2], [1, 1, 1, 1, 2]; verbose=true)

    @test_logs (
        :warn,
        """
For coefficient (i=1, j=2) with colors (ci=0, cj=2):
- Row color ci=0 is neutral.
- In column color cj=2, columns [2, 3, 4] all have nonzeros in row i=1.
""",
    ) structurally_biorthogonal(A, [0, 2, 2, 3], [1, 2, 2, 2, 3], verbose=true)

    @test_logs (
        :warn,
        """
For coefficient (i=2, j=1) with colors (ci=2, cj=0):
- In row color ci=2, rows [2, 3] all have nonzeros in column j=1.
- Column color cj=0 is neutral.
""",
    ) structurally_biorthogonal(A, [1, 2, 2, 3], [0, 2, 2, 2, 3], verbose=true)

    @test_logs (
        :warn,
        """
For coefficient (i=1, j=1) with colors (ci=0, cj=0):
- Row color ci=0 is neutral.
- Column color cj=0 is neutral.
""",
    ) structurally_biorthogonal(A, [0, 2, 2, 3], [0, 2, 2, 2, 3], verbose=true)
end

@testset "Substitutable columns" begin
    A1 = [
        1 1 1 1 1
        1 1 0 0 0
        1 0 1 0 0
        1 0 0 1 0
        1 0 0 0 1
    ]
    B1 = [
        1 6 7 8 9
        6 2 0 0 0
        7 0 3 0 0
        8 0 0 4 0
        9 0 0 0 5
    ]
    A2 = [
        1 1 0 0 0
        1 1 1 0 0
        0 1 1 1 0
        0 0 1 1 1
        0 0 0 1 1
    ]
    B2 = [
        5 1 0 0 0
        1 6 2 0 0
        0 2 7 3 0
        0 0 3 8 4
        0 0 0 4 9
    ]
    A3 = [
        0 1 1 1 1
        1 0 1 1 1
        1 1 0 1 1
        1 1 1 0 1
        1 1 1 1 0
    ]
    B3 = [
        0 1 2 3 4
        1 0 5 6 7
        2 5 0 8 9
        3 6 8 0 10
        4 7 9 10 0
    ]

    # success

    @test substitutable_columns(A1, B1, [1, 2, 2, 2, 2])
    @test substitutable_columns(A2, B2, [1, 2, 3, 1, 2])
    @test substitutable_columns(A3, B3, [1, 2, 3, 4, 0])

    # failure

    @test !substitutable_columns(A1, B1, [1, 1, 1, 1])
    log = (:warn, "4 colors provided for 5 columns.")
    @test_logs log substitutable_columns(A1, B1, [1, 1, 1, 1]; verbose=true)

    @test !substitutable_columns(A1, B1, [1, 1, 1, 1, 1])
    @test_logs (
        :warn,
        """
For coefficient (i=1, j=1) with colors (ci=1, cj=1):
- For the row 5 in row color ci=1, A[5, 1] is ordered after A[1, 1].
- For the column 5 in column color cj=1, A[1, 5] is ordered after A[1, 1].
""",
    ) substitutable_columns(A1, B1, [1, 1, 1, 1, 1]; verbose=true)

    @test !substitutable_columns(A2, B2, [1, 2, 0, 1, 2])
    @test_logs (
        :warn,
        """
For coefficient (i=3, j=3) with colors (ci=0, cj=0):
- Row color ci=0 is neutral.
- Column color cj=0 is neutral.
""",
    ) substitutable_columns(A2, B2, [1, 2, 0, 1, 2]; verbose=true)

    @test !substitutable_columns(A3, B3, [0, 1, 2, 3, 3])
    @test_logs (
        :warn,
        """
For coefficient (i=1, j=4) with colors (ci=0, cj=3):
- Row color ci=0 is neutral.
- For the column 5 in column color cj=3, A[1, 5] is ordered after A[1, 4].
""",
    ) substitutable_columns(A3, B3, [0, 1, 2, 3, 3]; verbose=true)

    @test !substitutable_columns(A3, B3, [1, 2, 3, 3, 0])
    @test_logs (
        :warn,
        """
For coefficient (i=3, j=5) with colors (ci=3, cj=0):
- For the row 4 in row color ci=3, A[4, 5] is ordered after A[3, 5].
- Column color cj=0 is neutral.
""",
    ) substitutable_columns(A3, B3, [1, 2, 3, 3, 0]; verbose=true)
end

@testset "Substitutable bidirectional" begin
    A = [
        1 0 0
        0 1 0
        0 0 1
    ]
    B = [
        1 0 0
        0 2 0
        0 0 3
    ]

    # success

    @test substitutable_bidirectional(A, B, [1, 0, 0], [0, 1, 1])

    # failure

    log = (:warn, "2 colors provided for 3 columns.")
    @test_logs log !substitutable_bidirectional(A, B, [1, 0, 0], [0, 1]; verbose=true)

    log = (:warn, "4 colors provided for 3 rows.")
    @test_logs log !substitutable_bidirectional(A, B, [1, 0, 0, 1], [0, 1, 1]; verbose=true)
end

# See https://github.com/JuliaDiff/SparseMatrixColorings.jl/pull/300
@testset "Empty matrix" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; decompression=:substitution)
    S = spzeros(Int, 0, 0)
    result = coloring(S, problem, algo)
    @test isempty(result.color)
    @test isempty(result.group)
end

using LinearAlgebra
using SparseArrays
using SparseMatrixColorings:
    SparsityPatternCSC,
    AdjacencyGraph,
    BipartiteGraph,
    bidirectional_pattern,
    degree,
    degree_dist2,
    nb_vertices,
    nb_edges,
    neighbors
using Test

## SparsityPatternCSC

@testset "SparsityPatternCSC" begin
    @test eltype(SparsityPatternCSC(sprand(10, 10, 0.1))) == Bool
    @test SparseArrays.indtype(SparsityPatternCSC(sprand(10, 10, 0.1))) == Int
    @testset "Transpose" begin
        for _ in 1:1000
            m, n = rand(100:1000), rand(100:1000)
            p = 0.05 * rand()
            A = sprand(m, n, p)
            S = SparsityPatternCSC(A)
            Sᵀ = transpose(S)
            Sᵀ_true = SparsityPatternCSC(sparse(transpose(A)))
            @test Sᵀ.colptr == Sᵀ_true.colptr
            @test Sᵀ.rowval == Sᵀ_true.rowval
        end
    end
    @testset "Bidirectional" begin
        @testset "symmetric_pattern = false" begin
            for _ in 1:1000
                m, n = rand(100:1000), rand(100:1000)
                p = 0.05 * rand()
                A = sprand(Bool, m, n, p)
                A_and_Aᵀ = [spzeros(Bool, n, n) transpose(A); A spzeros(Bool, m, m)]
                S_and_Sᵀ, edge_to_index = bidirectional_pattern(A; symmetric_pattern=false)
                @test S_and_Sᵀ.colptr == A_and_Aᵀ.colptr
                @test S_and_Sᵀ.rowval == A_and_Aᵀ.rowval
                M = SparseMatrixCSC(
                    m + n, m + n, S_and_Sᵀ.colptr, S_and_Sᵀ.rowval, edge_to_index
                )
                @test issymmetric(M)
            end
        end
        @testset "symmetric_pattern = true" begin
            for _ in 1:1000
                m = rand(100:1000)
                p = 0.05 * rand()
                A = sparse(Symmetric(sprand(Bool, m, m, p)))
                A_and_Aᵀ = [spzeros(Bool, m, m) transpose(A); A spzeros(Bool, m, m)]
                S_and_Sᵀ, edge_to_index = bidirectional_pattern(A; symmetric_pattern=true)
                @test S_and_Sᵀ.colptr == A_and_Aᵀ.colptr
                @test S_and_Sᵀ.rowval == A_and_Aᵀ.rowval
                M = SparseMatrixCSC(
                    2 * m, 2 * m, S_and_Sᵀ.colptr, S_and_Sᵀ.rowval, edge_to_index
                )
                @test issymmetric(M)
            end
        end
    end
    @testset "size" begin
        A = spzeros(10, 20)
        S = SparsityPatternCSC(A)
        @test size(A) == size(S)
        @test_throws BoundsError size(A, 0)
        @test size(A, 1) == size(S, 1)
        @test size(A, 2) == size(S, 2)
        @test size(A, 3) == size(S, 3)
        @test axes(A, 1) == axes(S, 1)
        @test axes(A, 2) == axes(S, 2)
    end
    @testset "getindex" begin
        A = sprand(Bool, 100, 100, 0.1)
        S = SparsityPatternCSC(A)
        @test all(zip(axes(S, 1), axes(S, 2))) do (i, j)
            A[i, j] == S[i, j]
        end
    end
end

## Bipartite graph (fig 3.1 of "What color is your Jacobian?")

@testset "BipartiteGraph" begin
    A = sparse([
        1 0 0 0 0 1 1 1
        0 1 0 0 1 0 1 1
        0 0 1 0 1 1 0 1
        0 0 0 1 1 1 1 0
    ])

    bg = BipartiteGraph(A; symmetric_pattern=false)
    @test eltype(bg) == Int
    @test_throws DimensionMismatch BipartiteGraph(A; symmetric_pattern=true)
    @test nb_vertices(bg, Val(1)) == 4
    @test nb_vertices(bg, Val(2)) == 8
    # neighbors of rows
    @test neighbors(bg, Val(1), 1) == [1, 6, 7, 8]
    @test neighbors(bg, Val(1), 2) == [2, 5, 7, 8]
    @test neighbors(bg, Val(1), 3) == [3, 5, 6, 8]
    @test neighbors(bg, Val(1), 4) == [4, 5, 6, 7]
    # neighbors of columns
    @test neighbors(bg, Val(2), 1) == [1]
    @test neighbors(bg, Val(2), 2) == [2]
    @test neighbors(bg, Val(2), 3) == [3]
    @test neighbors(bg, Val(2), 4) == [4]
    @test neighbors(bg, Val(2), 5) == [2, 3, 4]
    @test neighbors(bg, Val(2), 6) == [1, 3, 4]
    @test neighbors(bg, Val(2), 7) == [1, 2, 4]
    @test neighbors(bg, Val(2), 8) == [1, 2, 3]
    @test degree_dist2(bg, Val(2), 1) == 3
    @test degree_dist2(bg, Val(2), 2) == 3
    @test degree_dist2(bg, Val(2), 3) == 3
    @test degree_dist2(bg, Val(2), 4) == 3
    @test degree_dist2(bg, Val(2), 5) == 6
    @test degree_dist2(bg, Val(2), 6) == 6
    @test degree_dist2(bg, Val(2), 7) == 6
    @test degree_dist2(bg, Val(2), 8) == 6

    A = sparse([
        1 0 1 1
        0 1 0 1
        1 0 1 0
        1 1 0 1
    ])
    bg = BipartiteGraph(A; symmetric_pattern=true)
    @test nb_vertices(bg, Val(1)) == 4
    @test nb_vertices(bg, Val(2)) == 4
    # neighbors of rows and columns
    @test neighbors(bg, Val(1), 1) == neighbors(bg, Val(2), 1) == [1, 3, 4]
    @test neighbors(bg, Val(1), 2) == neighbors(bg, Val(2), 2) == [2, 4]
    @test neighbors(bg, Val(1), 3) == neighbors(bg, Val(2), 3) == [1, 3]
    @test neighbors(bg, Val(1), 4) == neighbors(bg, Val(2), 4) == [1, 2, 4]
end;

## Adjacency graph (fig 3.1 of "What color is your Jacobian?")

@testset "AdjacencyGraph" begin
    A = sparse([
        1 0 0 0 0 1 1 1
        0 1 0 0 1 0 1 1
        0 0 1 0 1 1 0 1
        0 0 0 1 1 1 1 0
    ])

    g = AdjacencyGraph(transpose(A) * A)
    @test eltype(g) == Int
    @test nb_vertices(g) == 8
    # wrong neighbors, it's okay they are filtered after
    @test collect(neighbors(g, 1)) == sort(vcat(1, [6, 7, 8]))
    @test collect(neighbors(g, 2)) == sort(vcat(2, [5, 7, 8]))
    @test collect(neighbors(g, 3)) == sort(vcat(3, [5, 6, 8]))
    @test collect(neighbors(g, 4)) == sort(vcat(4, [5, 6, 7]))
    @test collect(neighbors(g, 5)) == sort(vcat(5, [2, 3, 4, 6, 7, 8]))
    @test collect(neighbors(g, 6)) == sort(vcat(6, [1, 3, 4, 5, 7, 8]))
    @test collect(neighbors(g, 7)) == sort(vcat(7, [1, 2, 4, 5, 6, 8]))
    @test collect(neighbors(g, 8)) == sort(vcat(8, [1, 2, 3, 5, 6, 7]))
    # right degree
    @test degree(g, 1) == 3
    @test degree(g, 2) == 3
    @test degree(g, 3) == 3
    @test degree(g, 4) == 3
    @test degree(g, 5) == 6
    @test degree(g, 6) == 6
    @test degree(g, 7) == 6
    @test degree(g, 8) == 6

    g = AdjacencyGraph(transpose(A) * A; augmented_graph=true)
    # wrong degree
    @test degree(g, 1) == 4
    @test degree(g, 2) == 4
    @test degree(g, 3) == 4
    @test degree(g, 4) == 4
    @test degree(g, 5) == 7
    @test degree(g, 6) == 7
    @test degree(g, 7) == 7
    @test degree(g, 8) == 7
end

for (structure, partition, decompression) in [
    (:nonsymmetric, :column, :direct),
    (:nonsymmetric, :row, :direct),
    (:symmetric, :column, :direct),
    (:symmetric, :column, :substitution),
    (:nonsymmetric, :bidirectional, :direct),
    (:nonsymmetric, :bidirectional, :substitution),
]
    A = sparse(Bool[1 0; 0 1])
    problem = ColoringProblem(; structure, partition)
    algo = GreedyColoringAlgorithm(; decompression, postprocessing=true)
    result = coloring(A, problem, algo)
    if partition == :bidirectional
        Br, Bc = compress(A, result)
        decompress(Br, Bc, result)
    else
        B = compress(A, result)
        decompress(B, result)
    end
end

module SparseMatrixColoringsCUDAExt

import SparseMatrixColorings as SMC
using SparseArrays: SparseMatrixCSC, rowvals, nnz, nzrange
using CUDA: CuVector, CuMatrix
using cuSPARSE: AbstractCuSparseMatrix, CuSparseMatrixCSC, CuSparseMatrixCSR

## CSC Result

function SMC.ColumnColoringResult(
    A::CuSparseMatrixCSC, bg::SMC.BipartiteGraph{T}, color::Vector{<:Integer}
) where {T<:Integer}
    group = SMC.group_by_color(T, color)
    compressed_indices = SMC.column_csc_indices(bg, color)
    additional_info = (; compressed_indices_gpu_csc=CuVector(compressed_indices))
    return SMC.ColumnColoringResult(
        A, bg, color, group, compressed_indices, additional_info
    )
end

function SMC.RowColoringResult(
    A::CuSparseMatrixCSC, bg::SMC.BipartiteGraph{T}, color::Vector{<:Integer}
) where {T<:Integer}
    group = SMC.group_by_color(T, color)
    compressed_indices = SMC.row_csc_indices(bg, color)
    additional_info = (; compressed_indices_gpu_csc=CuVector(compressed_indices))
    return SMC.RowColoringResult(A, bg, color, group, compressed_indices, additional_info)
end

function SMC.StarSetColoringResult(
    A::CuSparseMatrixCSC,
    ag::SMC.AdjacencyGraph{T},
    color::Vector{<:Integer},
    star_set::SMC.StarSet{<:Integer},
) where {T<:Integer}
    group = SMC.group_by_color(T, color)
    compressed_indices = SMC.star_csc_indices(ag, color, star_set)
    additional_info = (; compressed_indices_gpu_csc=CuVector(compressed_indices))
    return SMC.StarSetColoringResult(
        A, ag, color, group, compressed_indices, additional_info
    )
end

## CSR Result

function SMC.ColumnColoringResult(
    A::CuSparseMatrixCSR, bg::SMC.BipartiteGraph{T}, color::Vector{<:Integer}
) where {T<:Integer}
    group = SMC.group_by_color(T, color)
    compressed_indices = SMC.column_csc_indices(bg, color)
    compressed_indices_csr = SMC.column_csr_indices(bg, color)
    additional_info = (; compressed_indices_gpu_csr=CuVector(compressed_indices_csr))
    return SMC.ColumnColoringResult(
        A, bg, color, group, compressed_indices, additional_info
    )
end

function SMC.RowColoringResult(
    A::CuSparseMatrixCSR, bg::SMC.BipartiteGraph{T}, color::Vector{<:Integer}
) where {T<:Integer}
    group = SMC.group_by_color(T, color)
    compressed_indices = SMC.row_csc_indices(bg, color)
    compressed_indices_csr = SMC.row_csr_indices(bg, color)
    additional_info = (; compressed_indices_gpu_csr=CuVector(compressed_indices_csr))
    return SMC.RowColoringResult(A, bg, color, group, compressed_indices, additional_info)
end

function SMC.StarSetColoringResult(
    A::CuSparseMatrixCSR,
    ag::SMC.AdjacencyGraph{T},
    color::Vector{<:Integer},
    star_set::SMC.StarSet{<:Integer},
) where {T<:Integer}
    group = SMC.group_by_color(T, color)
    compressed_indices = SMC.star_csc_indices(ag, color, star_set)
    additional_info = (; compressed_indices_gpu_csr=CuVector(compressed_indices))
    return SMC.StarSetColoringResult(
        A, ag, color, group, compressed_indices, additional_info
    )
end

## Decompression

for R in (:ColumnColoringResult, :RowColoringResult)
    # loop to avoid method ambiguity
    @eval function SMC.decompress!(
        A::CuSparseMatrixCSC, B::CuMatrix, result::SMC.$R{<:CuSparseMatrixCSC}
    )
        compressed_indices = result.additional_info.compressed_indices_gpu_csc
        copyto!(A.nzVal, view(B, compressed_indices))
        return A
    end

    @eval function SMC.decompress!(
        A::CuSparseMatrixCSR, B::CuMatrix, result::SMC.$R{<:CuSparseMatrixCSR}
    )
        compressed_indices = result.additional_info.compressed_indices_gpu_csr
        copyto!(A.nzVal, view(B, compressed_indices))
        return A
    end
end

function SMC.decompress!(
    A::CuSparseMatrixCSC,
    B::CuMatrix,
    result::SMC.StarSetColoringResult{<:CuSparseMatrixCSC},
    uplo::Symbol=:F,
)
    if uplo != :F
        throw(
            SMC.UnsupportedDecompressionError(
                "Single-triangle decompression is not supported on GPU matrices"
            ),
        )
    end
    compressed_indices = result.additional_info.compressed_indices_gpu_csc
    copyto!(A.nzVal, view(B, compressed_indices))
    return A
end

function SMC.decompress!(
    A::CuSparseMatrixCSR,
    B::CuMatrix,
    result::SMC.StarSetColoringResult{<:CuSparseMatrixCSR},
    uplo::Symbol=:F,
)
    if uplo != :F
        throw(
            SMC.UnsupportedDecompressionError(
                "Single-triangle decompression is not supported on GPU matrices"
            ),
        )
    end
    compressed_indices = result.additional_info.compressed_indices_gpu_csr
    copyto!(A.nzVal, view(B, compressed_indices))
    return A
end

end

## Abstract type

"""
    AbstractColoringResult{structure,partition,decompression}

Abstract type for the result of a coloring algorithm.

It is the supertype of the object returned by the main function [`coloring`](@ref).

# Type parameters

Combination between the type parameters of [`ColoringProblem`](@ref) and [`GreedyColoringAlgorithm`](@ref):

- `structure::Symbol`: either `:nonsymmetric` or `:symmetric`
- `partition::Symbol`: either `:column`, `:row` or `:bidirectional`
- `decompression::Symbol`: either `:direct` or `:substitution`

# Applicable methods

- [`column_colors`](@ref) and [`column_groups`](@ref) (for a `:column` or `:bidirectional` partition) 
- [`row_colors`](@ref) and [`row_groups`](@ref) (for a `:row` or `:bidirectional` partition)
- [`sparsity_pattern`](@ref)
- [`compress`](@ref), [`decompress`](@ref), [`decompress!`](@ref), [`decompress_single_color!`](@ref)

!!! warning
    Unlike the methods above, the concrete subtypes of `AbstractColoringResult` are not part of the public API and may change without notice.
"""
abstract type AbstractColoringResult{structure,partition,decompression} end

"""
    column_colors(result::AbstractColoringResult)

Return a vector `color` of integer colors, one for each column of the colored matrix.
"""
function column_colors end

"""
    row_colors(result::AbstractColoringResult)

Return a vector `color` of integer colors, one for each row of the colored matrix.
"""
function row_colors end

"""
    column_groups(result::AbstractColoringResult)

Return a vector `group` such that for every non-zero color `c`, `group[c]` contains the indices of all columns that are colored with `c`.
"""
function column_groups end

"""
    row_groups(result::AbstractColoringResult)

Return a vector `group` such that for every non-zero color `c`, `group[c]` contains the indices of all rows that are colored with `c`.
"""
function row_groups end

"""
    ncolors(result::AbstractColoringResult)

Return the number of different non-zero colors used to color the matrix.

For bidirectional partitions, this number is the sum of the number of non-zero row colors and the number of non-zero column colors.
"""
function ncolors(res::AbstractColoringResult{structure,:column}) where {structure}
    return length(column_groups(res))
end

function ncolors(res::AbstractColoringResult{structure,:row}) where {structure}
    return length(row_groups(res))
end

function ncolors(res::AbstractColoringResult{structure,:bidirectional}) where {structure}
    return length(row_groups(res)) + length(column_groups(res))
end

"""
    group_by_color(color::AbstractVector{<:Integer})

Create a color-indexed vector `group` such that `i ∈ group[c]` iff `color[i] == c` for all `c > 0`.

Assumes the colors are contiguously numbered from `0` to some `cmax`.
"""
function group_by_color(::Type{T}, color::AbstractVector) where {T<:Integer}
    if isempty(color)
        return typeof(view(T[], 1:0))[]
    end
    cmin, cmax = extrema(color)
    @assert cmin >= 0
    # Compute group sizes and offsets for a joint storage
    group_sizes = zeros(T, cmax)  # allocation 1, size cmax
    for c in color
        if c > 0
            group_sizes[c] += 1
        end
    end
    group_offsets = cumsum(group_sizes)  # allocation 2, size cmax
    # Concatenate all groups inside a single vector
    group_flat = Vector{T}(undef, sum(group_sizes))  # allocation 3, size <= n
    for (k, c) in enumerate(color)
        if c > 0
            i = group_offsets[c] - group_sizes[c] + 1
            group_flat[i] = k
            group_sizes[c] -= 1
        end
    end
    # Create views into contiguous blocks of the group vector
    group = map(1:cmax) do c
        i = 1 + (c == 1 ? 0 : group_offsets[c - 1])
        j = group_offsets[c]
        view(group_flat, i:j)
    end
    return group
end

group_by_color(color::AbstractVector) = group_by_color(Int, color)

const AbstractGroups{T} = AbstractVector{<:AbstractVector{T}}

column_colors(result::AbstractColoringResult{s,:column}) where {s} = result.color
column_groups(result::AbstractColoringResult{s,:column}) where {s} = result.group

row_colors(result::AbstractColoringResult{s,:row}) where {s} = result.color
row_groups(result::AbstractColoringResult{s,:row}) where {s} = result.group

"""
    sparsity_pattern(result::AbstractColoringResult)

Return the matrix that was initially passed to [`coloring`](@ref), without any modifications.

!!! note
    This matrix is not necessarily a `SparseMatrixCSC`, nor does it necessarily have `Bool` entries.
"""
sparsity_pattern(result::AbstractColoringResult) = result.A

## Concrete subtypes

"""
$TYPEDEF

Storage for the result of a column coloring with direct decompression.

# Fields

$TYPEDFIELDS

# See also

- [`AbstractColoringResult`](@ref)
"""
struct ColumnColoringResult{
    M<:AbstractMatrix,
    T<:Integer,
    G<:BipartiteGraph{T},
    CT<:AbstractVector{T},
    GT<:AbstractGroups{T},
    VT<:AbstractVector{T},
    A,
} <: AbstractColoringResult{:nonsymmetric,:column,:direct}
    "matrix that was colored"
    A::M
    "bipartite graph that was used for coloring"
    bg::G
    "one integer color for each column or row (depending on `partition`)"
    color::CT
    "color groups for columns or rows (depending on `partition`)"
    group::GT
    "flattened indices mapping the compressed matrix `B` to the uncompressed matrix `A` when `A isa SparseMatrixCSC`. They satisfy `nonzeros(A)[k] = vec(B)[compressed_indices[k]]`"
    compressed_indices::VT
    "optional data used for decompressing into specific matrix types"
    additional_info::A
end

function ColumnColoringResult(
    A::AbstractMatrix, bg::BipartiteGraph{T}, color::Vector{<:Integer}
) where {T<:Integer}
    group = group_by_color(T, color)
    compressed_indices = column_csc_indices(bg, color)
    return ColumnColoringResult(A, bg, color, group, compressed_indices, nothing)
end

function column_csc_indices(bg::BipartiteGraph{T}, color::Vector{<:Integer}) where {T}
    S = bg.S2
    n = size(S, 1)
    rv = rowvals(S)
    compressed_indices = zeros(T, nnz(S))
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rv[k]
            c = color[j]
            # A[i, j] = B[i, c]
            compressed_indices[k] = (c - 1) * n + i
        end
    end
    return compressed_indices
end

function column_csr_indices(bg::BipartiteGraph{T}, color::Vector{<:Integer}) where {T}
    Sᵀ = bg.S1  # CSC storage of transpose(A)
    n = size(Sᵀ, 2)
    rv = rowvals(Sᵀ)
    compressed_indices = zeros(T, nnz(Sᵀ))
    for i in axes(Sᵀ, 2)
        for k in nzrange(Sᵀ, i)
            j = rv[k]
            c = color[j]
            # A[i, j] = B[i, c]
            compressed_indices[k] = (c - 1) * n + i
        end
    end
    return compressed_indices
end

"""
$TYPEDEF

Storage for the result of a row coloring with direct decompression.

# Fields

See the docstring of [`ColumnColoringResult`](@ref).

$TYPEDFIELDS

# See also

- [`AbstractColoringResult`](@ref)
"""
struct RowColoringResult{
    M<:AbstractMatrix,
    T<:Integer,
    G<:BipartiteGraph{T},
    CT<:AbstractVector{T},
    GT<:AbstractGroups{T},
    VT<:AbstractVector{T},
    A,
} <: AbstractColoringResult{:nonsymmetric,:row,:direct}
    A::M
    bg::G
    color::CT
    group::GT
    compressed_indices::VT
    additional_info::A
end

function RowColoringResult(
    A::AbstractMatrix, bg::BipartiteGraph{T}, color::Vector{<:Integer}
) where {T<:Integer}
    group = group_by_color(T, color)
    compressed_indices = row_csc_indices(bg, color)
    return RowColoringResult(A, bg, color, group, compressed_indices, nothing)
end

function row_csc_indices(bg::BipartiteGraph{T}, color::Vector{<:Integer}) where {T}
    S = bg.S2
    C = maximum(color)  # ncolors
    rv = rowvals(S)
    compressed_indices = zeros(T, nnz(S))
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rv[k]
            c = color[i]
            # A[i, j] = B[c, j]
            compressed_indices[k] = (j - 1) * C + c
        end
    end
    return compressed_indices
end

function row_csr_indices(bg::BipartiteGraph{T}, color::Vector{<:Integer}) where {T}
    Sᵀ = bg.S1  # CSC storage of transpose(A)
    C = maximum(color)  # ncolors
    rv = rowvals(Sᵀ)
    compressed_indices = zeros(T, nnz(Sᵀ))
    for i in axes(Sᵀ, 2)
        for k in nzrange(Sᵀ, i)
            j = rv[k]
            c = color[i]
            # A[i, j] = B[c, j]
            compressed_indices[k] = (j - 1) * C + c
        end
    end
    return compressed_indices
end

"""
$TYPEDEF

Storage for the result of a symmetric coloring with direct decompression.

# Fields

See the docstring of [`ColumnColoringResult`](@ref).

$TYPEDFIELDS

# See also

- [`AbstractColoringResult`](@ref)
"""
struct StarSetColoringResult{
    M<:AbstractMatrix,
    T<:Integer,
    G<:AdjacencyGraph{T},
    CT<:AbstractVector{T},
    GT<:AbstractGroups{T},
    VT<:AbstractVector{T},
    A,
} <: AbstractColoringResult{:symmetric,:column,:direct}
    A::M
    ag::G
    color::CT
    group::GT
    compressed_indices::VT
    additional_info::A
end

function StarSetColoringResult(
    A::AbstractMatrix,
    ag::AdjacencyGraph{T},
    color::Vector{<:Integer},
    star_set::StarSet{<:Integer},
) where {T<:Integer}
    group = group_by_color(T, color)
    compressed_indices = star_csc_indices(ag, color, star_set)
    return StarSetColoringResult(A, ag, color, group, compressed_indices, nothing)
end

function star_csc_indices(
    ag::AdjacencyGraph{T}, color::Vector{<:Integer}, star_set
) where {T}
    (; star, hub) = star_set
    S = pattern(ag)
    edge_to_index = edge_indices(ag)
    n = S.n
    rvS = rowvals(S)
    compressed_indices = zeros(T, nnz(S))  # needs to be independent from the storage in the graph, in case the graph gets reused
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rvS[k]
            if i == j
                # diagonal coefficients
                c = color[i]
                compressed_indices[k] = (c - 1) * n + i
            else
                # off-diagonal coefficients
                index_ij = edge_to_index[k]
                s = star[index_ij]
                h = abs(hub[s])

                # Assign the non-hub vertex (spoke) to the correct position in spokes
                if i == h
                    # i is the hub and j is the spoke
                    c = color[i]
                    compressed_indices[k] = (c - 1) * n + j
                else  # j == h
                    # j is the hub and i is the spoke
                    c = color[j]
                    compressed_indices[k] = (c - 1) * n + i
                end
            end
        end
    end
    return compressed_indices
end

"""
$TYPEDEF

Storage for the result of a symmetric coloring with decompression by substitution.

# Fields

See the docstring of [`ColumnColoringResult`](@ref).

$TYPEDFIELDS

# See also

- [`AbstractColoringResult`](@ref)
"""
struct TreeSetColoringResult{
    M<:AbstractMatrix,T<:Integer,G<:AdjacencyGraph{T},GT<:AbstractGroups{T},R
} <: AbstractColoringResult{:symmetric,:column,:substitution}
    A::M
    ag::G
    color::Vector{T}
    group::GT
    reverse_bfs_orders::Vector{Tuple{T,T}}
    tree_edge_indices::Vector{T}
    nt::T
    diagonal_indices::Vector{T}
    diagonal_nzind::Vector{T}
    lower_triangle_offsets::Vector{T}
    upper_triangle_offsets::Vector{T}
    buffer::Vector{R}
end

function TreeSetColoringResult(
    A::AbstractMatrix,
    ag::AdjacencyGraph{T},
    color::Vector{<:Integer},
    tree_set::TreeSet{<:Integer},
    decompression_eltype::Type{R},
) where {T<:Integer,R}
    (; reverse_bfs_orders, tree_edge_indices, nt) = tree_set
    (; S, nb_self_loops) = ag
    nvertices = length(color)
    group = group_by_color(T, color)
    rv = rowvals(S)

    # Vector for the decompression of the diagonal coefficients
    diagonal_indices = Vector{T}(undef, nb_self_loops)
    diagonal_nzind = Vector{T}(undef, nb_self_loops)

    if !augmented_graph(ag)
        l = 0
        for j in axes(S, 2)
            for k in nzrange(S, j)
                i = rv[k]
                if i == j
                    l += 1
                    diagonal_indices[l] = i
                    diagonal_nzind[l] = k
                end
            end
        end
    end

    # Vectors for the decompression of the off-diagonal coefficients
    nedges = nb_edges(ag)
    lower_triangle_offsets = Vector{T}(undef, nedges)
    upper_triangle_offsets = Vector{T}(undef, nedges)

    # Index in lower_triangle_offsets and upper_triangle_offsets
    index_offsets = 0

    for k in 1:nt
        # Positions of the edges for each tree
        first = tree_edge_indices[k]
        last = tree_edge_indices[k + 1] - 1

        for pos in first:last
            (leaf, neighbor) = reverse_bfs_orders[pos]
            # Update lower_triangle_offsets and upper_triangle_offsets
            i = leaf
            j = neighbor
            col_i = view(rv, nzrange(S, i))
            col_j = view(rv, nzrange(S, j))
            index_offsets += 1

            #! format: off
            # S[i,j] is in the lower triangular part of S
            if in_triangle(i, j, :L)
                # uplo = :L or uplo = :F
                # S[i,j] is stored at index_ij = (S.colptr[j+1] - offset_L) in S.nzval
                lower_triangle_offsets[index_offsets] = length(col_j) - searchsortedfirst(col_j, i) + 1

                # uplo = :U or uplo = :F
                # S[j,i] is stored at index_ji = (S.colptr[i] + offset_U) in S.nzval
                upper_triangle_offsets[index_offsets] = searchsortedfirst(col_i, j)::Int - 1

            # S[i,j] is in the upper triangular part of S
            else
                # uplo = :U or uplo = :F
                # S[i,j] is stored at index_ij = (S.colptr[j] + offset_U) in S.nzval
                upper_triangle_offsets[index_offsets] = searchsortedfirst(col_j, i)::Int - 1

                # uplo = :L or uplo = :F
                # S[j,i] is stored at index_ji = (S.colptr[i+1] - offset_L) in S.nzval
                lower_triangle_offsets[index_offsets] = length(col_i) - searchsortedfirst(col_i, j) + 1
            end
            #! format: on
        end
    end

    # buffer holds the sum of edge values for subtrees in a tree.
    # For each vertex i, buffer[i] is the sum of edge values in the subtree rooted at i.
    buffer = Vector{R}(undef, nvertices)

    return TreeSetColoringResult(
        A,
        ag,
        color,
        group,
        reverse_bfs_orders,
        tree_edge_indices,
        nt,
        diagonal_indices,
        diagonal_nzind,
        lower_triangle_offsets,
        upper_triangle_offsets,
        buffer,
    )
end

## LinearSystemColoringResult

"""
$TYPEDEF

Storage for the result of a symmetric coloring with any decompression.

# Fields

See the docstring of [`ColumnColoringResult`](@ref).

$TYPEDFIELDS

# See also

- [`AbstractColoringResult`](@ref)
"""
struct LinearSystemColoringResult{
    M<:AbstractMatrix,T<:Integer,G<:AdjacencyGraph{T},GT<:AbstractGroups{T},R,F
} <: AbstractColoringResult{:symmetric,:column,:substitution}
    A::M
    ag::G
    color::Vector{T}
    group::GT
    strict_upper_nonzero_inds::Vector{Tuple{T,T}}
    strict_upper_nonzeros_A::Vector{R}  # TODO: adjust type
    M_factorization::F  # TODO: adjust type
end

function LinearSystemColoringResult(
    A::AbstractMatrix,
    ag::AdjacencyGraph{T},
    color::Vector{<:Integer},
    decompression_eltype::Type{R},
) where {T<:Integer,R<:Real}
    group = group_by_color(T, color)
    C = length(group)  # ncolors
    S = ag.S
    rv = rowvals(S)

    # build M such that M * strict_upper_nonzeros(A) = B
    # and solve a linear least-squares problem
    # only consider the strict upper triangle of A because of symmetry
    n = checksquare(S)
    strict_upper_nonzero_inds = Tuple{T,T}[]
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rv[k]
            (i < j) && push!(strict_upper_nonzero_inds, (i, j))
        end
    end

    # type annotated because JET was unhappy
    M::SparseMatrixCSC = spzeros(float(R), n * C, length(strict_upper_nonzero_inds))
    for (l, (i, j)) in enumerate(strict_upper_nonzero_inds)
        ci = color[i]
        cj = color[j]
        if ci > 0
            ki = (ci - 1) * n + j  # A[i, j] appears in B[j, ci]
            M[ki, l] = 1
        end
        if cj > 0
            kj = (cj - 1) * n + i  # A[i, j] appears in B[i, cj]
            M[kj, l] = 1
        end
    end
    M_factorization = factorize(M)

    strict_upper_nonzeros_A = Vector{float(R)}(undef, size(M, 2))

    return LinearSystemColoringResult(
        A,
        ag,
        color,
        group,
        strict_upper_nonzero_inds,
        strict_upper_nonzeros_A,
        M_factorization,
    )
end

## Bicoloring result

"""
    remap_colors(color::Vector{<:Integer}, num_sym_colors::Integer, m::Integer, n::Integer)

Return a tuple `(row_color, column_color, symmetric_to_row, symmetric_to_column)` such that `row_color` and `column_color` are vectors containing the renumbered colors for rows and columns.
`symmetric_to_row` and `symmetric_to_column` are vectors that map symmetric colors to row and column colors.

For all vertex indices `i` between `1` and `m` we have:

    row_color[i] = symmetric_to_row[color[n+i]]

For all vertex indices `j` between `1` and `n` we have:

    column_color[j] = symmetric_to_column[color[j]]
"""
function remap_colors(
    ::Type{T}, color::Vector{<:Integer}, num_sym_colors::Integer, m::Integer, n::Integer
) where {T<:Integer}
    # Map symmetric colors to column colors
    symmetric_to_column = zeros(T, num_sym_colors)
    column_color = zeros(T, n)

    counter = 0
    for j in 1:n
        cj = color[j]
        if cj > 0
            # First time that we encounter this column color
            if symmetric_to_column[cj] == 0
                counter += 1
                symmetric_to_column[cj] = counter
            end
            column_color[j] = symmetric_to_column[cj]
        end
    end

    # Map symmetric colors to row colors
    symmetric_to_row = zeros(T, num_sym_colors)
    row_color = zeros(T, m)

    counter = 0
    for i in (n + 1):(n + m)
        ci = color[i]
        if ci > 0
            # First time that we encounter this row color
            if symmetric_to_row[ci] == 0
                counter += 1
                symmetric_to_row[ci] = counter
            end
            row_color[i - n] = symmetric_to_row[ci]
        end
    end

    return row_color, column_color, symmetric_to_row, symmetric_to_column
end

"""
$TYPEDEF

Storage for the result of a bidirectional coloring with direct or substitution decompression, based on the symmetric coloring of a 2x2 block matrix.

# Fields

$TYPEDFIELDS

# See also

- [`AbstractColoringResult`](@ref)
"""
struct BicoloringResult{
    M<:AbstractMatrix,
    T<:Integer,
    G<:AdjacencyGraph{T},
    decompression,
    GT<:AbstractGroups{T},
    SR<:AbstractColoringResult{:symmetric,:column,decompression},
    R,
} <: AbstractColoringResult{:nonsymmetric,:bidirectional,decompression}
    "matrix that was colored"
    A::M
    "augmented adjacency graph that was used for bicoloring"
    abg::G
    "one integer color for each column"
    column_color::Vector{T}
    "one integer color for each row"
    row_color::Vector{T}
    "color groups for columns"
    column_group::GT
    "color groups for rows"
    row_group::GT
    "result for the coloring of the symmetric 2 x 2 block matrix"
    symmetric_result::SR
    "maps symmetric colors to column colors"
    symmetric_to_column::Vector{T}
    "maps symmetric colors to row colors"
    symmetric_to_row::Vector{T}
    "combination of `Br` and `Bc` (almost a concatenation up to color remapping)"
    Br_and_Bc::Matrix{R}
    "CSC storage of `A_and_noAᵀ - `colptr`"
    large_colptr::Vector{T}
    "CSC storage of `A_and_noAᵀ - `rowval`"
    large_rowval::Vector{T}
end

column_colors(result::BicoloringResult) = result.column_color
column_groups(result::BicoloringResult) = result.column_group

row_colors(result::BicoloringResult) = result.row_color
row_groups(result::BicoloringResult) = result.row_group

function BicoloringResult(
    A::AbstractMatrix,
    ag::AdjacencyGraph{T},
    symmetric_result::AbstractColoringResult{:symmetric,:column},
    row_color::Vector{T},
    column_color::Vector{T},
    symmetric_to_row::Vector{T},
    symmetric_to_column::Vector{T},
    decompression_eltype::Type{R},
) where {T,R}
    m, n = size(A)
    symmetric_color = column_colors(symmetric_result)
    num_sym_colors = maximum(symmetric_color)
    column_group = group_by_color(T, column_color)
    row_group = group_by_color(T, row_color)
    Br_and_Bc = Matrix{R}(undef, n + m, num_sym_colors)
    large_colptr = copy(ag.S.colptr)
    large_colptr[(n + 2):end] .= large_colptr[n + 1]  # last few columns are empty
    large_rowval = ag.S.rowval[1:(end ÷ 2)]  # forget the second half of nonzeros
    return BicoloringResult(
        A,
        ag,
        column_color,
        row_color,
        column_group,
        row_group,
        symmetric_result,
        symmetric_to_column,
        symmetric_to_row,
        Br_and_Bc,
        large_colptr,
        large_rowval,
    )
end

using Aqua
using Documenter
using JET
using SparseMatrixColorings
using Test

# Load package extensions to test them with JET
using Colors: Colors

include("utils.jl")

@testset verbose = true "SparseMatrixColorings" begin
    if get(ENV, "JULIA_SMC_TEST_GROUP", nothing) == "GPU"
        @testset "CUDA" begin
            using CUDA, cuSPARSE
            include("cuda.jl")
        end
    else
        @testset verbose = true "Code quality" begin
            @testset "Aqua" begin
                Aqua.test_all(SparseMatrixColorings; undocumented_names=true)
            end
            @testset "JET" begin
                JET.test_package(
                    SparseMatrixColorings; target_modules=(SparseMatrixColorings,)
                )
            end
            @testset "Doctests" begin
                Documenter.doctest(SparseMatrixColorings)
            end
        end
        @testset verbose = true "Internals" begin
            @testset "Graph" begin
                include("graph.jl")
            end
            @testset "Forest" begin
                include("forest.jl")
            end
            @testset "Order" begin
                include("order.jl")
            end
            @testset "Check" begin
                include("check.jl")
            end
            @testset "Matrices" begin
                include("matrices.jl")
            end
            @testset "Constructors" begin
                include("constructors.jl")
            end
            @testset "Result" begin
                include("result.jl")
            end
            @testset "Constant coloring" begin
                include("constant.jl")
            end
            @testset "Optimal coloring" begin
                include("optimal.jl")
            end
            @testset "ADTypes coloring algorithms" begin
                include("adtypes.jl")
            end
            @testset "Visualization" begin
                include("show_colors.jl")
            end
        end
        @testset verbose = true "Correctness" begin
            @testset "Small instances" begin
                include("small.jl")
            end
            @testset "Random instances" begin
                include("random.jl")
            end
            @testset "Structured matrices" begin
                include("structured.jl")
            end
            @testset "Instances with known colorings" begin
                include("theory.jl")
            end
            @testset "SuiteSparse" begin
                include("suitesparse.jl")
            end
        end
        @testset verbose = true "Performance" begin
            @testset "Type stability" begin
                if VERSION < v"1.12"
                    # TODO: fix JET misbehaving
                    include("type_stability.jl")
                end
            end
            @testset "Allocations" begin
                include("allocations.jl")
            end
        end
    end
end

"""
$TYPEDEF

Example coloring problem from one of our reference articles.

Used for internal testing.

# Fields

$TYPEDFIELDS
"""
struct Example{TA<:AbstractMatrix,TB<:AbstractMatrix}
    "decompressed matrix"
    A::TA
    "column-compressed matrix"
    B::TB
    "vector of colors"
    color::Vector{Int}
end

"""
    what_fig_41()

Construct an [`Example`](@ref) from Figure 4.1 of "What color is your Jacobian?", where the nonzero entries are filled with unique values.
"""
function what_fig_41()
    #! format: off
    M = sparse([
    #   1 2 3 4 5 6
        1 1 0 0 0 0  # 1
        1 1 1 0 1 1  # 2
        0 1 1 1 0 0  # 3
        0 0 1 1 0 1  # 4
        0 1 0 0 1 0  # 5
        0 1 0 1 0 1  # 6
    ])
    #! format: on
    @assert M == transpose(M)
    nonzeros(M) .= 1:length(nonzeros(M))
    A = sparse(Symmetric(M))
    color = [
        1,  # 1. green
        2,  # 2. red
        1,  # 3. green
        3,  # 4. blue
        1,  # 5. green
        1,  # 6. green
    ]
    B = hcat(
        A[:, 1] .+ A[:, 3] .+ A[:, 5] .+ A[:, 6],  # green
        A[:, 2],  # red
        A[:, 4],  # blue
    )
    return Example(A, B, color)
end

"""
    what_fig_61()

Construct an [`Example`](@ref) from Figure 6.1 of "What color is your Jacobian?", where the nonzero entries are filled with unique values.
"""
function what_fig_61()
    #! format: off
    M = sparse([
    #   1 2 3 4 5 6 7 8 9 10
        1 1 0 0 0 0 1 0 0 0  # 1
        1 1 1 0 1 0 0 0 0 0  # 2
        0 1 1 1 0 1 0 0 0 0  # 3
        0 0 1 1 0 0 0 0 0 1  # 4
        0 1 0 0 1 1 0 1 0 0  # 5
        0 0 1 0 1 1 0 0 1 0  # 6
        1 0 0 0 0 0 1 1 0 0  # 7
        0 0 0 0 1 0 1 1 1 0  # 8
        0 0 0 0 0 1 0 1 1 1  # 9
        0 0 0 1 0 0 0 0 1 1  # 10
    ])
    #! format: on
    @assert M == transpose(M)
    nonzeros(M) .= 1:length(nonzeros(M))
    A = sparse(Symmetric(M))
    color = [
        1,  # 1. red
        2,  # 2. blue
        1,  # 3. red
        2,  # 4. blue
        1,  # 5. red
        3,  # 6. green
        2,  # 7. blue
        3,  # 8. green
        2,  # 9. blue
        3,  # 10. green
    ]
    B = Matrix(
        hcat(
            A[:, 1] .+ A[:, 3] .+ A[:, 5],  # red
            A[:, 2] .+ A[:, 4] .+ A[:, 7] .+ A[:, 9],  # blue
            A[:, 6] .+ A[:, 8] .+ A[:, 10],  # green
        ),
    )
    return Example(A, B, color)
end

"""
    efficient_fig_1()

Construct an [`Example`](@ref) from Figure 1 of "Efficient computation of sparse hessians using coloring and AD", where the nonzero entries are filled with unique values.
"""
function efficient_fig_1()
    #! format: off
    M = sparse([
    #   1 2 3 4 5 6 7 8 9 10    
        1 1 0 0 0 0 1 0 0 0  # 1
        1 1 1 0 1 0 0 0 0 0  # 2
        0 1 1 1 0 1 0 0 0 0  # 3
        0 0 1 1 0 0 0 0 0 1  # 4
        0 1 0 0 1 1 0 1 0 0  # 5
        0 0 1 0 1 1 0 0 1 0  # 6
        1 0 0 0 0 0 1 1 0 0  # 7
        0 0 0 0 1 0 1 1 1 0  # 8
        0 0 0 0 0 1 0 1 1 1  # 9
        0 0 0 1 0 0 0 0 1 1  # 10
    ])
    #! format: on
    @assert M == transpose(M)
    nonzeros(M) .= 1:length(nonzeros(M))
    A = sparse(Symmetric(M))
    color = [
        1,  # 1. red
        2,  # 2. cyan
        1,  # 3. red
        3,  # 4. yellow
        1,  # 5. red
        4,  # 6. green
        3,  # 7. yellow
        5,  # 8. navy blue
        1,  # 9. red
        2,  # 10. cyan
    ]
    B = Matrix(
        hcat(
            A[:, 1] .+ A[:, 3] .+ A[:, 5] .+ A[:, 9], # red
            A[:, 2] .+ A[:, 10],  # cyan
            A[:, 4] .+ A[:, 7],  # yellow
            A[:, 6],  # green
            A[:, 8],  # navy blue
        ),
    )
    return Example(A, B, color)
end

"""
    efficient_fig_4()

Construct an [`Example`](@ref) from Figure 4 of "Efficient computation of sparse hessians using coloring and AD", where the nonzero entries are filled with unique values.
"""
function efficient_fig_4()
    #! format: off
    M = sparse([
    #   1 2 3 4 5 6 7 8 9 10    
        1 1 0 0 0 0 1 0 0 0  # 1
        1 1 1 0 1 0 0 0 0 0  # 2
        0 1 1 1 0 1 0 0 0 0  # 3
        0 0 1 1 0 0 0 0 0 1  # 4
        0 1 0 0 1 1 0 1 0 0  # 5
        0 0 1 0 1 1 0 0 1 0  # 6
        1 0 0 0 0 0 1 1 0 0  # 7
        0 0 0 0 1 0 1 1 1 0  # 8
        0 0 0 0 0 1 0 1 1 1  # 9
        0 0 0 1 0 0 0 0 1 1  # 10
    ])
    #! format: on
    @assert M == transpose(M)
    nonzeros(M) .= 1:length(nonzeros(M))
    A = sparse(Symmetric(M))
    color = [
        1,  # 1. red
        2,  # 2. cyan
        1,  # 3. red
        2,  # 4. cyan
        1,  # 5. red
        3,  # 6. yellow
        2,  # 7. cyan
        3,  # 8. yellow
        2,  # 9. cyan
        1,  # 10. red
    ]
    B = Matrix(
        hcat(
            A[:, 1] .+ A[:, 3] .+ A[:, 5] .+ A[:, 10], # red
            A[:, 2] .+ A[:, 4] .+ A[:, 7] .+ A[:, 9],  # cyan
            A[:, 6] .+ A[:, 8],  # yellow
        ),
    )
    return Example(A, B, color)
end

"""
    ConstantColoringAlgorithm{partition}  <: ADTypes.AbstractColoringAlgorithm

Coloring algorithm which always returns the same precomputed vector of colors.
Useful when the optimal coloring of a matrix can be determined a priori due to its specific structure (e.g. banded).

It is passed as an argument to the main function [`coloring`](@ref), but will only work if the associated `problem` has a `:column` or `:row` partition.

# Constructors

    ConstantColoringAlgorithm{partition}(matrix_template, color)
    ConstantColoringAlgorithm{partition,structure}(matrix_template, color)
    ConstantColoringAlgorithm(
        matrix_template, color;
        structure=:nonsymmetric, partition=:column
    )

- `partition::Symbol`: either `:row` or `:column`.
- `structure::Symbol`: either `:nonsymmetric` or `:symmetric`.
- `matrix_template::AbstractMatrix`: matrix for which the vector of colors was precomputed (the algorithm will only accept matrices of the exact same size).
- `color::Vector{<:Integer}`: vector of integer colors, one for each row or column (depending on `partition`).

!!! warning
    The constructor based on keyword arguments is type-unstable if these arguments are not compile-time constants.

We do not necessarily verify consistency between the matrix template and the vector of colors, this is the responsibility of the user.

# Example

```jldoctest
julia> using SparseMatrixColorings, LinearAlgebra

julia> matrix_template = Diagonal(ones(Bool, 5))
5×5 Diagonal{Bool, Vector{Bool}}:
 1  ⋅  ⋅  ⋅  ⋅
 ⋅  1  ⋅  ⋅  ⋅
 ⋅  ⋅  1  ⋅  ⋅
 ⋅  ⋅  ⋅  1  ⋅
 ⋅  ⋅  ⋅  ⋅  1

julia> color = ones(Int, 5)  # coloring a Diagonal is trivial
5-element Vector{Int64}:
 1
 1
 1
 1
 1

julia> problem = ColoringProblem(; structure=:nonsymmetric, partition=:column);

julia> algo = ConstantColoringAlgorithm(matrix_template, color; partition=:column);

julia> result = coloring(similar(matrix_template), problem, algo);

julia> column_colors(result)
5-element Vector{Int64}:
 1
 1
 1
 1
 1
```

# ADTypes coloring interface

`ConstantColoringAlgorithm` is a subtype of [`ADTypes.AbstractColoringAlgorithm`](@extref ADTypes.AbstractColoringAlgorithm), which means the following methods are also applicable (although they will error if the kind of coloring demanded not consistent):

- [`ADTypes.column_coloring`](@extref ADTypes.column_coloring)
- [`ADTypes.row_coloring`](@extref ADTypes.row_coloring)
- [`ADTypes.symmetric_coloring`](@extref ADTypes.symmetric_coloring)
"""
struct ConstantColoringAlgorithm{partition,structure,M<:AbstractMatrix,T<:Integer} <:
       ADTypes.AbstractColoringAlgorithm
    matrix_template::M
    color::Vector{T}

    function ConstantColoringAlgorithm{partition,structure}(
        matrix_template::AbstractMatrix, color::Vector{<:Integer}
    ) where {partition,structure}
        check_valid_problem(structure, partition)
        return new{partition,structure,typeof(matrix_template),eltype(color)}(
            matrix_template, color
        )
    end
end

function ConstantColoringAlgorithm{partition}(
    matrix_template::AbstractMatrix, color::Vector{<:Integer}
) where {partition}
    return ConstantColoringAlgorithm{partition,:nonsymmetric}(matrix_template, color)
end

function ConstantColoringAlgorithm(
    matrix_template::AbstractMatrix,
    color::Vector{<:Integer};
    structure::Symbol=:nonsymmetric,
    partition::Symbol=:column,
)
    return ConstantColoringAlgorithm{partition,structure}(matrix_template, color)
end

function check_template(algo::ConstantColoringAlgorithm, A::AbstractMatrix)
    (; matrix_template) = algo
    if size(A) != size(matrix_template)
        throw(
            DimensionMismatch(
                "`ConstantColoringAlgorithm` expected matrix of size $(size(matrix_template)) but got matrix of size $(size(A))",
            ),
        )
    end
end

function ADTypes.column_coloring(
    A::AbstractMatrix, algo::ConstantColoringAlgorithm{:column,:nonsymmetric}
)
    check_template(algo, A)
    return algo.color
end

function ADTypes.row_coloring(
    A::AbstractMatrix, algo::ConstantColoringAlgorithm{:row,:nonsymmetric}
)
    check_template(algo, A)
    return algo.color
end

function ADTypes.symmetric_coloring(
    A::AbstractMatrix, algo::ConstantColoringAlgorithm{:column,:symmetric}
)
    check_template(algo, A)
    return algo.color
end

# TODO: handle bidirectional once https://github.com/SciML/ADTypes.jl/issues/69 is done

module SparseMatrixColoringsGPUArraysExt

using GPUArrays: AbstractGPUSparseMatrix, dense_array_type
using SparseArrays: SparseMatrixCSC
import SparseMatrixColorings as SMC

SMC.matrix_versions(A::AbstractGPUSparseMatrix) = (A,)

## Compression (slow, through CPU)

function SMC.compress(
    A::AbstractGPUSparseMatrix, result::SMC.AbstractColoringResult{structure,:column}
) where {structure}
    A_cpu = SparseMatrixCSC(A)
    B_cpu = SMC.compress(A_cpu, result)
    B = dense_array_type(A)(B_cpu)
    return B
end

function SMC.compress(
    A::AbstractGPUSparseMatrix, result::SMC.AbstractColoringResult{structure,:row}
) where {structure}
    A_cpu = SparseMatrixCSC(A)
    B_cpu = SMC.compress(A_cpu, result)
    B = dense_array_type(A)(B_cpu)
    return B
end

end

using SparseMatrixColorings
using Test

@test ColoringProblem{:nonsymmetric,:column}() == ColoringProblem()
@test ColoringProblem{:symmetric,:column}() ==
    ColoringProblem(; structure=:symmetric, partition=:column)

@test_throws ArgumentError ColoringProblem(; structure=:weird, partition=:column)
@test_throws ArgumentError ColoringProblem(; structure=:symmetric, partition=:row)

@test GreedyColoringAlgorithm{:direct}() == GreedyColoringAlgorithm()
@test GreedyColoringAlgorithm{:substitution}() ==
    GreedyColoringAlgorithm(; decompression=:substitution)

@test_throws ArgumentError GreedyColoringAlgorithm(decompression=:weird)

using SparseArrays
using SparseMatrixColorings
using StableRNGs
using Test
using JuMP
using MiniZinc
using HiGHS

rng = StableRNG(0)

asymmetric_params = vcat(
    [(10, 20, p) for p in (0.0:0.1:0.5)], [(20, 10, p) for p in (0.0:0.1:0.5)]
)

algo = GreedyColoringAlgorithm()
optalgo = OptimalColoringAlgorithm(() -> MiniZinc.Optimizer{Float64}("highs"); silent=false)

# TODO: reactivate tests once https://github.com/jump-dev/MiniZinc.jl/issues/103 is fixed

@testset "Column coloring" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
    for (m, n, p) in asymmetric_params
        A = sprand(rng, m, n, p)
        result = coloring(A, problem, algo)
        @test_skip ncolors(result) >= ncolors(coloring(A, problem, optalgo))
    end
end

@testset "Row coloring" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    for (m, n, p) in asymmetric_params
        A = sprand(rng, m, n, p)
        result = coloring(A, problem, algo)
        @test_skip ncolors(result) >= ncolors(coloring(A, problem, optalgo))
    end
end

@testset "Too big" begin
    A = sprand(rng, Bool, 100, 100, 0.1)
    optalgo_timelimit = OptimalColoringAlgorithm(
        optimizer_with_attributes(HiGHS.Optimizer, "time_limit" => 10.0); # 1 second
        silent=false,
        assert_solved=false,
    )
    @test_throws AssertionError coloring(A, ColoringProblem(), optalgo_timelimit)
end

using SparseMatrixColorings: Forest, find_root!, root_union!
using Test

@testset "Constructor Forest" begin
    forest = Forest{Int}(5)
    @test forest.nt == 5
    @test length(forest.parents) == 5
    @test all(forest.parents .== 1:5)
    @test all(forest.ranks .== 0)
end

@testset "Find root" begin
    forest = Forest{Int}(5)
    @test find_root!(forest, 3) == 3
    @test find_root!(forest, 5) == 5
end

@testset "Root union" begin
    forest = Forest{Int}(5)
    root1 = find_root!(forest, 1)
    root3 = find_root!(forest, 3)
    @test root1 != root3

    root_union!(forest, root1, root3)
    @test find_root!(forest, 3) == 1
    @test forest.parents[1] == 1
    @test forest.parents[3] == 1
    @test forest.ranks[1] == 1
    @test forest.ranks[3] == 0
    @test forest.nt == 4

    root1 = find_root!(forest, 1)
    root2 = find_root!(forest, 2)
    @test root1 != root2

    root_union!(forest, root1, root2)
    @test find_root!(forest, 2) == 1
    @test forest.parents[1] == 1
    @test forest.parents[2] == 1
    @test forest.ranks[1] == 1
    @test forest.ranks[2] == 0
    @test forest.nt == 3
end

using SparseMatrixColorings
using SparseMatrixColorings: show_colors
using SparseArrays
using Colors
using Test

A = sparse([
    0 0 1 1 0 1
    1 0 0 0 1 0
    0 1 0 0 1 0
    0 1 1 0 0 0
]);
algo = GreedyColoringAlgorithm(; decompression=:direct)

@testset "$partition" for partition in (:column, :row, :bidirectional)
    problem = ColoringProblem(; structure=:nonsymmetric, partition=partition)
    result = coloring(A, problem, algo)

    if partition != :bidirectional
        B = compress(A, result)

        A_img, B_img = show_colors(result)
        @test size(A_img) == size(A)
        @test size(B_img) == size(B)
        @test A_img isa Matrix{<:Colorant}
        @test B_img isa Matrix{<:Colorant}

        scale = 3
        A_img, B_img = show_colors(result; scale=scale)
        @test size(A_img) == size(A) .* scale
        @test size(B_img) == size(B) .* scale
        @test A_img isa Matrix{<:Colorant}

        pad = 2
        border = 3
        A_img, B_img = show_colors(result; scale=scale, border=border, pad=pad)
        @test size(A_img) == size(A) .* (scale + 2border + pad) .+ pad
        @test size(B_img) == size(B) .* (scale + 2border + pad) .+ pad
        @test A_img isa Matrix{<:Colorant}

        @testset "color cycling" begin
            colorscheme = [RGB(0, 0, 0), RGB(1, 1, 1)] # 2 colors, whereas S requires 3
            A_img, _ = @test_logs (:warn,) show_colors(result; colorscheme)
            @test size(A_img) == size(A)
            @test A_img isa Matrix{<:Colorant}

            A_img, _ = show_colors(result; colorscheme, warn=false)
            @test size(A_img) == size(A)
            @test A_img isa Matrix{<:Colorant}
        end
    else
        Br, Bc = compress(A, result)

        scale = 3
        Arc_img, Ar_img, Ac_img, Br_img, Bc_img = show_colors(result; scale=scale)
        @test size(Arc_img) == size(A) .* scale
        @test size(Ar_img) == size(A) .* scale
        @test size(Ac_img) == size(A) .* scale
        @test size(Br_img) == size(Br) .* scale
        @test size(Bc_img) == size(Bc) .* scale
        @test Arc_img isa Matrix{<:Colorant}
        @test Ar_img isa Matrix{<:Colorant}
        @test Ac_img isa Matrix{<:Colorant}
        @test Br_img isa Matrix{<:Colorant}
        @test Bc_img isa Matrix{<:Colorant}
    end
end

@testset "Errors" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    result = coloring(A, problem, algo)
    @testset "scale too small" begin
        @test_throws ArgumentError show_colors(result; scale=-24)
        @test_throws ArgumentError show_colors(result; scale=0)
    end
    @testset "pad too small" begin
        @test_throws ArgumentError show_colors(result; pad=-1)
        @test_nowarn show_colors(result; pad=0)
    end
    @testset "border too small" begin
        @test_throws ArgumentError show_colors(result; border=-1)
        @test_nowarn show_colors(result; border=0)
    end
end

function proper_length_coloring(
    A::AbstractMatrix, color::AbstractVector{<:Integer}; verbose::Bool=false
)
    m, n = size(A)
    if length(color) != n
        if verbose
            @warn "$(length(color)) colors provided for $n columns."
        end
        return false
    end
    return true
end

function proper_length_bicoloring(
    A::AbstractMatrix,
    row_color::AbstractVector{<:Integer},
    column_color::AbstractVector{<:Integer};
    verbose::Bool=false,
)
    m, n = size(A)
    bool = true
    if length(row_color) != m
        if verbose
            @warn "$(length(row_color)) colors provided for $m rows."
        end
        bool = false
    end
    if length(column_color) != n
        if verbose
            @warn "$(length(column_color)) colors provided for $n columns."
        end
        bool = false
    end
    return bool
end

"""
    structurally_orthogonal_columns(
        A::AbstractMatrix, color::AbstractVector{<:Integer};
        verbose=false
    )

Return `true` if coloring the columns of the matrix `A` with the vector `color` results in a partition that is structurally orthogonal, and `false` otherwise.
    
A partition of the columns of a matrix `A` is _structurally orthogonal_ if, for every nonzero element `A[i, j]`, the group containing column `A[:, j]` has no other column with a nonzero in row `i`.

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.

# References

> [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
"""
function structurally_orthogonal_columns(
    A::AbstractMatrix, color::AbstractVector{<:Integer}; verbose::Bool=false
)
    if !proper_length_coloring(A, color; verbose)
        return false
    end
    group = group_by_color(color)
    for (c, g) in enumerate(group)
        Ag = view(A, :, g)
        nonzeros_per_row = only(eachcol(count(!iszero, Ag; dims=2)))
        max_nonzeros_per_row, i = findmax(nonzeros_per_row)
        if max_nonzeros_per_row > 1
            if verbose
                incompatible_columns = g[findall(!iszero, view(Ag, i, :))]
                @warn "In color $c, columns $incompatible_columns all have nonzeros in row $i."
            end
            return false
        end
    end
    return true
end

"""
    symmetrically_orthogonal_columns(
        A::AbstractMatrix, color::AbstractVector{<:Integer};
        verbose=false
    )

Return `true` if coloring the columns of the symmetric matrix `A` with the vector `color` results in a partition that is symmetrically orthogonal, and `false` otherwise.

A partition of the columns of a symmetric matrix `A` is _symmetrically orthogonal_ if, for every nonzero element `A[i, j]`, either of the following statements holds:

1. the group containing the column `A[:, j]` has no other column with a nonzero in row `i`
2. the group containing the column `A[:, i]` has no other column with a nonzero in row `j`

It is equivalent to a __star coloring__.

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.

# References

> [_On the Estimation of Sparse Hessian Matrices_](https://doi.org/10.1137/0716078), Powell and Toint (1979)
> [_Estimation of sparse hessian matrices and graph coloring problems_](https://doi.org/10.1007/BF02612334), Coleman and Moré (1984)
> [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
"""
function symmetrically_orthogonal_columns(
    A::AbstractMatrix, color::AbstractVector{<:Integer}; verbose::Bool=false
)
    checksquare(A)
    if !proper_length_coloring(A, color; verbose)
        return false
    end
    issymmetric(A) || return false
    group = group_by_color(color)
    for i in axes(A, 1), j in axes(A, 2)
        iszero(A[i, j]) && continue
        ci, cj = color[i], color[j]
        check = _bilateral_check(
            A; i, j, ci, cj, row_group=group, column_group=group, verbose
        )
        !check && return false
    end
    return true
end

"""
    structurally_biorthogonal(
        A::AbstractMatrix, row_color::AbstractVector{<:Integer}, column_color::AbstractVector{<:Integer};
        verbose=false
    )

Return `true` if bicoloring of the matrix `A` with the vectors `row_color` and `column_color` results in a bipartition that is structurally biorthogonal, and `false` otherwise.

A bipartition of the rows and columns of a matrix `A` is _structurally biorthogonal_ if, for every nonzero element `A[i, j]`, either of the following statements holds:

1. the group containing the column `A[:, j]` has no other column with a nonzero in row `i`
2. the group containing the row `A[i, :]` has no other row with a nonzero in column `j`

It is equivalent to a __star bicoloring__.

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.
"""
function structurally_biorthogonal(
    A::AbstractMatrix,
    row_color::AbstractVector{<:Integer},
    column_color::AbstractVector{<:Integer};
    verbose::Bool=false,
)
    if !proper_length_bicoloring(A, row_color, column_color; verbose)
        return false
    end
    row_group = group_by_color(row_color)
    column_group = group_by_color(column_color)
    for i in axes(A, 1), j in axes(A, 2)
        iszero(A[i, j]) && continue
        ci, cj = row_color[i], column_color[j]
        check = _bilateral_check(A; i, j, ci, cj, row_group, column_group, verbose)
        !check && return false
    end
    return true
end

function _bilateral_check(
    A::AbstractMatrix;
    i::Integer,
    j::Integer,
    ci::Integer,
    cj::Integer,
    row_group::AbstractVector,
    column_group::AbstractVector,
    verbose::Bool,
)
    if ci == 0 && cj == 0
        if verbose
            @warn """
                For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
                - Row color ci=$ci is neutral.
                - Column color cj=$cj is neutral.
                """
        end
        return false
    elseif ci == 0 && cj != 0
        gj = column_group[cj]
        A_gj_rowi = view(A, i, gj)
        nonzeros_gj_rowi = count(!iszero, A_gj_rowi)
        if nonzeros_gj_rowi > 1
            if verbose
                gj_incompatible_columns = gj[findall(!iszero, A_gj_rowi)]
                @warn """
                For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
                - Row color ci=$ci is neutral.
                - In column color cj=$cj, columns $gj_incompatible_columns all have nonzeros in row i=$i.
                """
            end
            return false
        end
    elseif ci != 0 && cj == 0
        gi = row_group[ci]
        A_gi_columnj = view(A, gi, j)
        nonzeros_gi_columnj = count(!iszero, A_gi_columnj)
        if nonzeros_gi_columnj > 1
            if verbose
                gi_incompatible_rows = gi[findall(!iszero, A_gi_columnj)]
                @warn """
                For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
                - In row color ci=$ci, rows $gi_incompatible_rows all have nonzeros in column j=$j.
                - Column color cj=$cj is neutral.
                """
            end
            return false
        end
    else
        gi, gj = row_group[ci], column_group[cj]
        A_gj_rowi = view(A, i, gj)
        A_gi_columnj = view(A, gi, j)
        nonzeros_gj_rowi = count(!iszero, A_gj_rowi)
        nonzeros_gi_columnj = count(!iszero, A_gi_columnj)
        if nonzeros_gj_rowi > 1 && nonzeros_gi_columnj > 1
            if verbose
                gj_incompatible_columns = gj[findall(!iszero, A_gj_rowi)]
                gi_incompatible_rows = gi[findall(!iszero, A_gi_columnj)]
                @warn """
                For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
                - In row color ci=$ci, rows $gi_incompatible_rows all have nonzeros in column j=$j.
                - In column color cj=$cj, columns $gj_incompatible_columns all have nonzeros in row i=$i.
                """
            end
            return false
        end
    end
    return true
end

"""
    directly_recoverable_columns(
        A::AbstractMatrix, color::AbstractVector{<:Integer}
        verbose=false
    )

Return `true` if coloring the columns of the symmetric matrix `A` with the vector `color` results in a column-compressed representation that preserves every unique value, thus making direct recovery possible.

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.

# References

> [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
"""
function directly_recoverable_columns(
    A::AbstractMatrix, color::AbstractVector{<:Integer}; verbose::Bool=false
)
    if !proper_length_coloring(A, color; verbose)
        return false
    end
    group = group_by_color(color)
    B = if isempty(group)
        similar(A, size(A, 1), 0)
    else
        stack(group; dims=2) do g
            dropdims(sum(A[:, g]; dims=2); dims=2)
        end
    end
    A_unique = Set(unique(A))
    B_unique = Set(unique(B))
    if !issubset(A_unique, push!(B_unique, zero(eltype(B))))
        if verbose
            @warn "Coefficients $(sort(collect(setdiff(A_unique, B_unique)))) are not directly recoverable."
            return false
        end
        return false
    end
    return true
end

"""
    substitutable_columns(
        A::AbstractMatrix, rank_nonzeros::AbstractMatrix, color::AbstractVector{<:Integer};
        verbose=false
    )

Return `true` if coloring the columns of the symmetric matrix `A` with the vector `color` results in a partition that is substitutable, and `false` otherwise.
For all nonzeros `A[i, j]`, `rank_nonzeros[i, j]` provides its rank of recovery.

A partition of the columns of a symmetric matrix `A` is _substitutable_ if, for every nonzero element `A[i, j]`, either of the following statements holds:

1. the group containing the column `A[:, j]` has all nonzeros in row `i` ordered before `A[i, j]`
2. the group containing the column `A[:, i]` has all nonzeros in row `j` ordered before `A[i, j]`

It is equivalent to an __acyclic coloring__.

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.

# References

> [_On the Estimation of Sparse Hessian Matrices_](https://doi.org/10.1137/0716078), Powell and Toint (1979)
> [_The Cyclic Coloring Problem and Estimation of Sparse Hessian Matrices_](https://doi.org/10.1137/0607026), Coleman and Cai (1986)
> [_What Color Is Your Jacobian? Graph Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
"""
function substitutable_columns(
    A::AbstractMatrix,
    rank_nonzeros::AbstractMatrix,
    color::AbstractVector{<:Integer};
    verbose::Bool=false,
)
    checksquare(A)
    if !proper_length_coloring(A, color; verbose)
        return false
    end
    issymmetric(A) || return false
    group = group_by_color(color)
    for i in axes(A, 1), j in axes(A, 2)
        iszero(A[i, j]) && continue
        ci, cj = color[i], color[j]
        check = _substitutable_check(
            A, rank_nonzeros; i, j, ci, cj, row_group=group, column_group=group, verbose
        )
        !check && return false
    end
    return true
end

"""
    substitutable_bidirectional(
        A::AbstractMatrix, rank_nonzeros::AbstractMatrix, row_color::AbstractVector{<:Integer}, column_color::AbstractVector{<:Integer};
        verbose=false
    )

Return `true` if bicoloring of the matrix `A` with the vectors `row_color` and `column_color` results in a bipartition that is substitutable, and `false` otherwise.
For all nonzeros `A[i, j]`, `rank_nonzeros[i, j]` provides its rank of recovery.

A bipartition of the rows and columns of a matrix `A` is _substitutable_ if, for every nonzero element `A[i, j]`, either of the following statements holds:

1. the group containing the column `A[:, j]` has all nonzeros in row `i` ordered before `A[i, j]`
2. the group containing the row `A[i, :]` has all nonzeros in column `j` ordered before `A[i, j]`

It is equivalent to an __acyclic bicoloring__.

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.
"""
function substitutable_bidirectional(
    A::AbstractMatrix,
    rank_nonzeros::AbstractMatrix,
    row_color::AbstractVector{<:Integer},
    column_color::AbstractVector{<:Integer};
    verbose::Bool=false,
)
    if !proper_length_bicoloring(A, row_color, column_color; verbose)
        return false
    end
    row_group = group_by_color(row_color)
    column_group = group_by_color(column_color)
    for i in axes(A, 1), j in axes(A, 2)
        iszero(A[i, j]) && continue
        ci, cj = row_color[i], column_color[j]
        check = _substitutable_check(
            A, rank_nonzeros; i, j, ci, cj, row_group, column_group, verbose
        )
        !check && return false
    end
    return true
end

function _substitutable_check(
    A::AbstractMatrix,
    rank_nonzeros::AbstractMatrix;
    i::Integer,
    j::Integer,
    ci::Integer,
    cj::Integer,
    row_group::AbstractVector,
    column_group::AbstractVector,
    verbose::Bool,
)
    order_ij = rank_nonzeros[i, j]
    k_row = 0
    k_column = 0
    if ci != 0
        for k in row_group[ci]
            (k == i) && continue
            if !iszero(A[k, j])
                order_kj = rank_nonzeros[k, j]
                @assert !iszero(order_kj)
                if order_kj > order_ij
                    k_row = k
                end
            end
        end
    end
    if cj != 0
        for k in column_group[cj]
            (k == j) && continue
            if !iszero(A[i, k])
                order_ik = rank_nonzeros[i, k]
                @assert !iszero(order_ik)
                if order_ik > order_ij
                    k_column = k
                end
            end
        end
    end
    if ci == 0 && cj == 0
        if verbose
            @warn """
            For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
            - Row color ci=$ci is neutral.
            - Column color cj=$cj is neutral.
            """
        end
        return false
    elseif ci == 0 && !iszero(k_column)
        if verbose
            @warn """
            For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
            - Row color ci=$ci is neutral.
            - For the column $k_column in column color cj=$cj, A[$i, $k_column] is ordered after A[$i, $j].
            """
        end
        return false
    elseif cj == 0 && !iszero(k_row)
        if verbose
            @warn """
            For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
            - For the row $k_row in row color ci=$ci, A[$k_row, $j] is ordered after A[$i, $j].
            - Column color cj=$cj is neutral.
            """
        end
        return false
    elseif !iszero(k_row) && !iszero(k_column)
        if verbose
            @warn """
            For coefficient (i=$i, j=$j) with colors (ci=$ci, cj=$cj):
            - For the row $k_row in row color ci=$ci, A[$k_row, $j] is ordered after A[$i, $j].
            - For the column $k_column in column color cj=$cj, A[$i, $k_column] is ordered after A[$i, $j].
            """
        end
        return false
    end
    return true
end

"""
    valid_dynamic_order(g::AdjacencyGraph, π::AbstractVector{<:Integer}, order::DynamicDegreeBasedOrder)
    valid_dynamic_order(bg::AdjacencyGraph, ::Val{side}, π::AbstractVector{<:Integer}, order::DynamicDegreeBasedOrder)

Check that a permutation `π` corresponds to a valid application of a [`DynamicDegreeBasedOrder`](@ref).

This is done by checking, for each ordered vertex, that its back- or forward-degree was the smallest or largest among the remaining vertices (the specifics depend on the order parameters).

!!! warning
    This function is not coded with efficiency in mind, it is designed for small-scale tests.
"""
function valid_dynamic_order(
    g::AdjacencyGraph,
    π::AbstractVector{<:Integer},
    ::DynamicDegreeBasedOrder{degtype,direction},
) where {degtype,direction}
    length(π) != nb_vertices(g) && return false
    length(unique(π)) != nb_vertices(g) && return false
    for i in eachindex(π)
        vi = π[i]
        yet_to_be_ordered = direction == :low2high ? π[i:end] : π[begin:i]
        considered_for_degree = degtype == :back ? π[begin:(i - 1)] : π[(i + 1):end]
        di = degree_in_subset(g, vi, considered_for_degree)
        considered_for_degree_switched = copy(considered_for_degree)
        for vj in yet_to_be_ordered
            replace!(considered_for_degree_switched, vj => vi)
            dj = degree_in_subset(g, vj, considered_for_degree_switched)
            replace!(considered_for_degree_switched, vi => vj)
            if direction == :low2high
                dj > di && return false
            else
                dj < di && return false
            end
        end
    end
    return true
end

function valid_dynamic_order(
    g::BipartiteGraph,
    ::Val{side},
    π::AbstractVector{<:Integer},
    ::DynamicDegreeBasedOrder{degtype,direction},
) where {side,degtype,direction}
    length(π) != nb_vertices(g, Val(side)) && return false
    length(unique(π)) != nb_vertices(g, Val(side)) && return false
    for i in eachindex(π)
        vi = π[i]
        yet_to_be_ordered = direction == :low2high ? π[i:end] : π[begin:i]
        considered_for_degree = degtype == :back ? π[begin:(i - 1)] : π[(i + 1):end]
        di = degree_dist2_in_subset(g, Val(side), vi, considered_for_degree)
        considered_for_degree_switched = copy(considered_for_degree)
        for vj in yet_to_be_ordered
            replace!(considered_for_degree_switched, vj => vi)
            dj = degree_dist2_in_subset(g, Val(side), vj, considered_for_degree_switched)
            replace!(considered_for_degree_switched, vi => vj)
            if direction == :low2high
                dj > di && return false
            else
                dj < di && return false
            end
        end
    end
    return true
end

"""
    rank_nonzeros_from_trees(result::TreeSetColoringResult)
    rank_nonzeros_from_trees(result::BicoloringResult)

Construct a sparse matrix `rank_nonzeros` that assigns a unique recovery rank
to each nonzero coefficient associated with an acyclic coloring or bicoloring.

For every nonzero entry `result.A[i, j]`, `rank_nonzeros[i, j]` stores a strictly positive
integer representing the order in which this coefficient is recovered during the decompression.
A larger value means the coefficient is recovered later.

This ranking is used to test substitutability (acyclicity) of colorings:
for a given nonzero `result.A[i, j]`, the ranks allow one to check whether all competing
nonzeros in the same row or column (within a color group) are recovered before it.
"""
function rank_nonzeros_from_trees end

function rank_nonzeros_from_trees(result::TreeSetColoringResult)
    (; A, ag, reverse_bfs_orders, diagonal_indices, tree_edge_indices, nt) = result
    (; S) = ag
    m, n = size(A)
    nnzS = nnz(S)
    nzval = zeros(Int, nnzS)
    rank_nonzeros = SparseMatrixCSC(n, n, S.colptr, S.rowval, nzval)
    counter = 0
    for i in diagonal_indices
        counter += 1
        rank_nonzeros[i, i] = counter
    end
    for k in 1:nt
        first = tree_edge_indices[k]
        last = tree_edge_indices[k + 1] - 1
        for pos in first:last
            (i, j) = reverse_bfs_orders[pos]
            counter += 1
            rank_nonzeros[i, j] = counter
            rank_nonzeros[j, i] = counter
        end
    end
    return rank_nonzeros
end

function rank_nonzeros_from_trees(result::BicoloringResult)
    (; A, abg, row_color, column_color, symmetric_result, large_colptr, large_rowval) =
        result
    @assert symmetric_result isa TreeSetColoringResult
    (; ag, reverse_bfs_orders, tree_edge_indices, nt) = symmetric_result
    (; S) = ag
    m, n = size(A)
    nnzA = nnz(S) ÷ 2
    nzval = zeros(Int, nnzA)
    colptr = large_colptr[1:(n + 1)]
    rowval = large_rowval[1:nnzA]
    rowval .-= n
    rank_nonzeros = SparseMatrixCSC(m, n, colptr, rowval, nzval)
    counter = 0
    for k in 1:nt
        first = tree_edge_indices[k]
        last = tree_edge_indices[k + 1] - 1
        for pos in first:last
            (i, j) = reverse_bfs_orders[pos]
            counter += 1
            if i > j
                rank_nonzeros[i - n, j] = counter
            else
                rank_nonzeros[j - n, i] = counter
            end
        end
    end
    return rank_nonzeros
end

"""
    OptimalColoringAlgorithm

Coloring algorithm that relies on mathematical programming with [JuMP](https://jump.dev/) to find an optimal coloring.

!!! warning
    This algorithm is only available when JuMP is loaded. If you encounter a method error, run `import JuMP` in your REPL and try again.
    It only works for nonsymmetric, unidirectional colorings problems.

!!! danger
    The coloring problem is NP-hard, so it is unreasonable to expect an optimal solution in reasonable time for large instances.

# Constructor

    OptimalColoringAlgorithm(optimizer; silent::Bool=true, assert_solved::Bool=true)

The `optimizer` argument can be any JuMP-compatible optimizer.
However, the problem formulation is best suited to CP-SAT optimizers like [MiniZinc](https://github.com/jump-dev/MiniZinc.jl).
You can use [`optimizer_with_attributes`](https://jump.dev/JuMP.jl/stable/api/JuMP/#optimizer_with_attributes) to set solver-specific parameters.

# Keyword arguments

- `silent`: whether to suppress solver output
- `assert_solved`: whether to check that the solver found an optimal solution (as opposed to running out of time for example)
"""
struct OptimalColoringAlgorithm{O} <: ADTypes.AbstractColoringAlgorithm
    optimizer::O
    silent::Bool
    assert_solved::Bool
end

function OptimalColoringAlgorithm(optimizer; silent::Bool=true, assert_solved::Bool=true)
    return OptimalColoringAlgorithm(optimizer, silent, assert_solved)
end

function check_valid_problem(structure::Symbol, partition::Symbol)
    valid = (
        (structure == :nonsymmetric && partition in (:column, :row, :bidirectional)) ||
        (structure == :symmetric && partition == :column)
    )
    if !valid
        throw(
            ArgumentError(
                "The combination `($(repr(structure)), $(repr(partition)))` is not supported by `ColoringProblem`.",
            ),
        )
    end
end

function check_valid_algorithm(decompression::Symbol)
    valid = decompression in (:direct, :substitution)
    if !valid
        throw(
            ArgumentError(
                "The setting `decompression=$(repr(decompression))` is not supported by `GreedyColoringAlgorithm`.",
            ),
        )
    end
end

"""
    ColoringProblem{structure,partition}

Selector type for the coloring problem to solve, enabling multiple dispatch.

It is passed as an argument to the main function [`coloring`](@ref).

# Constructors

    ColoringProblem{structure,partition}()
    ColoringProblem(; structure=:nonsymmetric, partition=:column)

- `structure::Symbol`: either `:nonsymmetric` or `:symmetric`
- `partition::Symbol`: either `:column`, `:row` or `:bidirectional`

!!! warning
    The second constructor (based on keyword arguments) is type-unstable.

#  Link to automatic differentiation

Matrix coloring is often used in automatic differentiation, and here is the translation guide:

| matrix   | mode    | `structure`     | `partition`      | implemented |
| -------- | ------- | --------------- | ---------------- | ----------- |
| Jacobian | forward | `:nonsymmetric` | `:column`        | yes         |
| Jacobian | reverse | `:nonsymmetric` | `:row`           | yes         |
| Jacobian | mixed   | `:nonsymmetric` | `:bidirectional` | yes         |
| Hessian  | -       | `:symmetric`    | `:column`        | yes         |
| Hessian  | -       | `:symmetric`    | `:row`           | no          |
"""
struct ColoringProblem{structure,partition} end

function ColoringProblem(; structure::Symbol=:nonsymmetric, partition::Symbol=:column)
    check_valid_problem(structure, partition)
    return ColoringProblem{structure,partition}()
end

"""
    GreedyColoringAlgorithm{decompression} <: ADTypes.AbstractColoringAlgorithm

Greedy coloring algorithm for sparse matrices which colors columns or rows one after the other, following a configurable order.

It is passed as an argument to the main function [`coloring`](@ref).

# Constructors

    GreedyColoringAlgorithm{decompression}(order=NaturalOrder(); postprocessing=false)
    GreedyColoringAlgorithm(order=NaturalOrder(); postprocessing=false, decompression=:direct)

- `order::Union{AbstractOrder,Tuple}`: the order in which the columns or rows are colored, which can impact the number of colors. Can also be a tuple of different orders to try out, from which the best order (the one with the lowest total number of colors) will be used.
- `postprocessing::Bool`: whether or not the coloring will be refined by assigning the neutral color `0` to some vertices.
- `decompression::Symbol`: either `:direct` or `:substitution`. Usually `:substitution` leads to fewer colors, at the cost of a more expensive coloring (and decompression). When `:substitution` is not applicable, it falls back on `:direct` decompression.

!!! warning
    The second constructor (based on keyword arguments) is type-unstable.

# ADTypes coloring interface

`GreedyColoringAlgorithm` is a subtype of [`ADTypes.AbstractColoringAlgorithm`](@extref ADTypes.AbstractColoringAlgorithm), which means the following methods are also applicable:

- [`ADTypes.column_coloring`](@extref ADTypes.column_coloring)
- [`ADTypes.row_coloring`](@extref ADTypes.row_coloring)
- [`ADTypes.symmetric_coloring`](@extref ADTypes.symmetric_coloring)

See their respective docstrings for details.

# See also

- [`AbstractOrder`](@ref)
- [`decompress`](@ref)
"""
struct GreedyColoringAlgorithm{decompression,N,O<:NTuple{N,AbstractOrder}} <:
       ADTypes.AbstractColoringAlgorithm
    orders::O
    postprocessing::Bool

    function GreedyColoringAlgorithm{decompression}(
        order_or_orders::Union{AbstractOrder,Tuple}=NaturalOrder();
        postprocessing::Bool=false,
    ) where {decompression}
        check_valid_algorithm(decompression)
        if order_or_orders isa AbstractOrder
            orders = (order_or_orders,)
        else
            orders = order_or_orders
        end
        return new{decompression,length(orders),typeof(orders)}(orders, postprocessing)
    end
end

function GreedyColoringAlgorithm(
    order_or_orders::Union{AbstractOrder,Tuple}=NaturalOrder();
    postprocessing::Bool=false,
    decompression::Symbol=:direct,
)
    return GreedyColoringAlgorithm{decompression}(order_or_orders; postprocessing)
end

## Coloring

abstract type WithOrWithoutResult end
struct WithResult <: WithOrWithoutResult end
struct WithoutResult <: WithOrWithoutResult end

"""
    coloring(
        S::AbstractMatrix,
        problem::ColoringProblem,
        algo::GreedyColoringAlgorithm;
        [decompression_eltype=Float64, symmetric_pattern=false]
    )

Solve a [`ColoringProblem`](@ref) on the matrix `S` with a [`GreedyColoringAlgorithm`](@ref) and return an [`AbstractColoringResult`](@ref).

The result can be used to [`compress`](@ref) and [`decompress`](@ref) a matrix `A` with the same sparsity pattern as `S`.
If `eltype(A) == decompression_eltype`, decompression might be faster.

For a `:nonsymmetric` problem (and only then), setting `symmetric_pattern=true` indicates that the pattern of nonzeros is symmetric.
This condition is weaker than the symmetry of actual values, so it can happen for some Jacobians.
Specifying it allows faster construction of the bipartite graph.

# Example

```jldoctest
julia> using SparseMatrixColorings, SparseArrays

julia> S = sparse([
           0 0 1 1 0 1
           1 0 0 0 1 0
           0 1 0 0 1 0
           0 1 1 0 0 0
       ]);

julia> problem = ColoringProblem(; structure=:nonsymmetric, partition=:column);

julia> algo = GreedyColoringAlgorithm(; decompression=:direct);

julia> result = coloring(S, problem, algo);

julia> column_colors(result)
6-element Vector{Int64}:
 1
 1
 2
 1
 2
 3

julia> collect.(column_groups(result))
3-element Vector{Vector{Int64}}:
 [1, 2, 4]
 [3, 5]
 [6]
```

# See also

- [`ColoringProblem`](@ref)
- [`GreedyColoringAlgorithm`](@ref)
- [`AbstractColoringResult`](@ref)
- [`compress`](@ref)
- [`decompress`](@ref)
"""
function coloring(
    A::AbstractMatrix,
    problem::ColoringProblem,
    algo::GreedyColoringAlgorithm;
    decompression_eltype::Type{R}=Float64,
    symmetric_pattern::Bool=false,
) where {R}
    return _coloring(WithResult(), A, problem, algo, R, symmetric_pattern)
end

"""
    fast_coloring(
        S::AbstractMatrix,
        problem::ColoringProblem,
        algo::GreedyColoringAlgorithm;
        [symmetric_pattern=false]
    )

Solve a [`ColoringProblem`](@ref) on the matrix `S` with a [`GreedyColoringAlgorithm`](@ref) and return

- a single color vector for `:column` and `:row` problems
- a tuple of color vectors for `:bidirectional` problems

This function is very similar to [`coloring`](@ref), but it skips the computation of an [`AbstractColoringResult`](@ref) to speed things up.

# See also

- [`coloring`](@ref)
"""
function fast_coloring(
    A::AbstractMatrix,
    problem::ColoringProblem,
    algo::GreedyColoringAlgorithm;
    symmetric_pattern::Bool=false,
)
    return _coloring(WithoutResult(), A, problem, algo, Float64, symmetric_pattern)
end

function _coloring(
    speed_setting::WithOrWithoutResult,
    A::AbstractMatrix,
    ::ColoringProblem{:nonsymmetric,:column},
    algo::GreedyColoringAlgorithm,
    decompression_eltype::Type,
    symmetric_pattern::Bool;
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
)
    symmetric_pattern = symmetric_pattern || A isa Union{Symmetric,Hermitian}
    bg = BipartiteGraph(A; symmetric_pattern)
    color_by_order = map(algo.orders) do order
        vertices_in_order = vertices(bg, Val(2), order)
        return partial_distance2_coloring(bg, Val(2), vertices_in_order; forced_colors)
    end
    color = argmin(maximum, color_by_order)
    if speed_setting isa WithResult
        return ColumnColoringResult(A, bg, color)
    else
        return color
    end
end

function _coloring(
    speed_setting::WithOrWithoutResult,
    A::AbstractMatrix,
    ::ColoringProblem{:nonsymmetric,:row},
    algo::GreedyColoringAlgorithm,
    decompression_eltype::Type,
    symmetric_pattern::Bool;
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
)
    symmetric_pattern = symmetric_pattern || A isa Union{Symmetric,Hermitian}
    bg = BipartiteGraph(A; symmetric_pattern)
    color_by_order = map(algo.orders) do order
        vertices_in_order = vertices(bg, Val(1), order)
        return partial_distance2_coloring(bg, Val(1), vertices_in_order; forced_colors)
    end
    color = argmin(maximum, color_by_order)
    if speed_setting isa WithResult
        return RowColoringResult(A, bg, color)
    else
        return color
    end
end

function _coloring(
    speed_setting::WithOrWithoutResult,
    A::AbstractMatrix,
    ::ColoringProblem{:symmetric,:column},
    algo::GreedyColoringAlgorithm{:direct},
    decompression_eltype::Type,
    symmetric_pattern::Bool;
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
)
    ag = AdjacencyGraph(A; augmented_graph=false)
    color_and_star_set_by_order = map(algo.orders) do order
        vertices_in_order = vertices(ag, order)
        return star_coloring(ag, vertices_in_order, algo.postprocessing; forced_colors)
    end
    color, star_set = argmin(maximum ∘ first, color_and_star_set_by_order)
    if speed_setting isa WithResult
        return StarSetColoringResult(A, ag, color, star_set)
    else
        return color
    end
end

function _coloring(
    speed_setting::WithOrWithoutResult,
    A::AbstractMatrix,
    ::ColoringProblem{:symmetric,:column},
    algo::GreedyColoringAlgorithm{:substitution},
    decompression_eltype::Type{R},
    symmetric_pattern::Bool,
) where {R}
    ag = AdjacencyGraph(A; augmented_graph=false)
    color_and_tree_set_by_order = map(algo.orders) do order
        vertices_in_order = vertices(ag, order)
        return acyclic_coloring(ag, vertices_in_order, algo.postprocessing)
    end
    # if `color` is empty, `maximum` will fail but `color_and_tree_set_by_order`
    # is also one so we can just add a special case for this
    if length(color_and_tree_set_by_order) == 1
        color, tree_set = only(color_and_tree_set_by_order)
    else
        color, tree_set = argmin(maximum ∘ first, color_and_tree_set_by_order)
    end
    if speed_setting isa WithResult
        return TreeSetColoringResult(A, ag, color, tree_set, R)
    else
        return color
    end
end

function _coloring(
    speed_setting::WithOrWithoutResult,
    A::AbstractMatrix,
    ::ColoringProblem{:nonsymmetric,:bidirectional},
    algo::GreedyColoringAlgorithm{:direct},
    decompression_eltype::Type{R},
    symmetric_pattern::Bool;
    forced_colors::Union{AbstractVector{<:Integer},Nothing}=nothing,
) where {R}
    A_and_Aᵀ, edge_to_index = bidirectional_pattern(A; symmetric_pattern)
    ag = AdjacencyGraph(A_and_Aᵀ, edge_to_index, 0; augmented_graph=true)
    outputs_by_order = map(algo.orders) do order
        vertices_in_order = vertices(ag, order)
        _color, _star_set = star_coloring(
            ag, vertices_in_order, algo.postprocessing; forced_colors
        )
        (_row_color, _column_color, _symmetric_to_row, _symmetric_to_column) = remap_colors(
            eltype(ag), _color, maximum(_color), size(A)...
        )
        return (
            _color,
            _star_set,
            _row_color,
            _column_color,
            _symmetric_to_row,
            _symmetric_to_column,
        )
    end
    (color, star_set, row_color, column_color, symmetric_to_row, symmetric_to_column) = argmin(
        t -> maximum(t[3]) + maximum(t[4]), outputs_by_order
    )  # can't use ncolors without computing the full result
    if speed_setting isa WithResult
        symmetric_result = StarSetColoringResult(A_and_Aᵀ, ag, color, star_set)
        return BicoloringResult(
            A,
            ag,
            symmetric_result,
            row_color,
            column_color,
            symmetric_to_row,
            symmetric_to_column,
            R,
        )
    else
        return row_color, column_color
    end
end

function _coloring(
    speed_setting::WithOrWithoutResult,
    A::AbstractMatrix,
    ::ColoringProblem{:nonsymmetric,:bidirectional},
    algo::GreedyColoringAlgorithm{:substitution},
    decompression_eltype::Type{R},
    symmetric_pattern::Bool,
) where {R}
    A_and_Aᵀ, edge_to_index = bidirectional_pattern(A; symmetric_pattern)
    ag = AdjacencyGraph(A_and_Aᵀ, edge_to_index, 0; augmented_graph=true)
    outputs_by_order = map(algo.orders) do order
        vertices_in_order = vertices(ag, order)
        _color, _tree_set = acyclic_coloring(ag, vertices_in_order, algo.postprocessing)
        (_row_color, _column_color, _symmetric_to_row, _symmetric_to_column) = remap_colors(
            eltype(ag), _color, maximum(_color), size(A)...
        )
        return (
            _color,
            _tree_set,
            _row_color,
            _column_color,
            _symmetric_to_row,
            _symmetric_to_column,
        )
    end
    (color, tree_set, row_color, column_color, symmetric_to_row, symmetric_to_column) = argmin(
        t -> maximum(t[3]) + maximum(t[4]), outputs_by_order
    )  # can't use ncolors without computing the full result
    if speed_setting isa WithResult
        symmetric_result = TreeSetColoringResult(A_and_Aᵀ, ag, color, tree_set, R)
        return BicoloringResult(
            A,
            ag,
            symmetric_result,
            row_color,
            column_color,
            symmetric_to_row,
            symmetric_to_column,
            R,
        )
    else
        return row_color, column_color
    end
end

## ADTypes interface

function ADTypes.column_coloring(A::AbstractMatrix, algo::GreedyColoringAlgorithm)
    return fast_coloring(A, ColoringProblem{:nonsymmetric,:column}(), algo)
end

function ADTypes.row_coloring(A::AbstractMatrix, algo::GreedyColoringAlgorithm)
    return fast_coloring(A, ColoringProblem{:nonsymmetric,:row}(), algo)
end

function ADTypes.symmetric_coloring(A::AbstractMatrix, algo::GreedyColoringAlgorithm)
    return fast_coloring(A, ColoringProblem{:symmetric,:column}(), algo)
end

## Standard graph

"""
    SparsityPatternCSC{Ti<:Integer}

Store a sparse matrix (in CSC) without its values, keeping only the pattern of nonzeros.

# Fields

Copied from `SparseMatrixCSC`:

- `m::Int`: number of rows
- `n::Int`: number of columns
- `colptr::Vector{Ti}`: column `j` is in `colptr[j]:(colptr[j+1]-1)`
- `rowval::Vector{Ti}`: row indices of stored values
"""
struct SparsityPatternCSC{Ti<:Integer} <: AbstractMatrix{Bool}
    m::Int
    n::Int
    colptr::Vector{Ti}
    rowval::Vector{Ti}
end

SparsityPatternCSC(A::SparseMatrixCSC) = SparsityPatternCSC(A.m, A.n, A.colptr, A.rowval)

SparseArrays.indtype(::SparsityPatternCSC{T}) where {T} = T
Base.size(S::SparsityPatternCSC) = (S.m, S.n)
Base.size(S::SparsityPatternCSC, d::Integer) = d::Integer <= 2 ? size(S)[d] : 1
Base.axes(S::SparsityPatternCSC, d::Integer) = Base.OneTo(size(S, d))

SparseArrays.nnz(S::SparsityPatternCSC) = length(S.rowval)
SparseArrays.rowvals(S::SparsityPatternCSC) = S.rowval
SparseArrays.nzrange(S::SparsityPatternCSC, j::Integer) = S.colptr[j]:(S.colptr[j + 1] - 1)

# Needed if using `coloring(::SparsityPatternCSC, ...)`
function Base.similar(A::SparsityPatternCSC, ::Type{T}) where {T}
    return SparseArrays.SparseMatrixCSC(A.m, A.n, A.colptr, A.rowval, similar(A.rowval, T))
end

"""
    transpose(S::SparsityPatternCSC)

Return a [`SparsityPatternCSC`](@ref) corresponding to the transpose of `S`.
"""
function Base.transpose(S::SparsityPatternCSC{T}) where {T}
    m, n = size(S)
    nnzA = nnz(S)
    A_colptr = S.colptr
    A_rowval = S.rowval

    # Allocate storage for the column pointers and row indices of B = Aᵀ
    B_colptr = zeros(T, m + 1)
    B_rowval = Vector{T}(undef, nnzA)

    # Count the number of non-zeros for each row of A.
    # It corresponds to the number of non-zeros for each column of B = Aᵀ.
    for k in 1:nnzA
        i = A_rowval[k]
        B_colptr[i] += 1
    end

    # Compute the cumulative sum to determine the starting positions of rows in B_rowval
    counter = 1
    for col in 1:m
        nnz_col = B_colptr[col]
        B_colptr[col] = counter
        counter += nnz_col
    end
    B_colptr[m + 1] = counter

    # Store the row indices for each column of B = Aᵀ
    for j in 1:n
        for index in A_colptr[j]:(A_colptr[j + 1] - 1)
            i = A_rowval[index]

            # Update B_rowval for the non-zero B[j,i].
            # It corresponds to the non-zero A[i,j].
            pos = B_colptr[i]
            B_rowval[pos] = j
            B_colptr[i] += 1
        end
    end

    # Fix offsets of B_colptr to restore correct starting positions
    for col in m:-1:2
        B_colptr[col] = B_colptr[col - 1]
    end
    B_colptr[1] = 1

    return SparsityPatternCSC{T}(n, m, B_colptr, B_rowval)
end

# copied from SparseArrays.jl
function Base.getindex(S::SparsityPatternCSC, i0::Integer, i1::Integer)
    r1 = Int(S.colptr[i1])
    r2 = Int(S.colptr[i1 + 1] - 1)
    (r1 > r2) && return false
    r1 = searchsortedfirst(rowvals(S), i0, r1, r2, Base.Order.Forward)
    return ((r1 > r2) || (rowvals(S)[r1] != i0)) ? false : true
end

"""
    bidirectional_pattern(A::AbstractMatrix; symmetric_pattern::Bool)

Return a [`SparsityPatternCSC`](@ref) corresponding to the matrix `[0 Aᵀ; A 0]`, with a minimum of allocations.
"""
function bidirectional_pattern(A::AbstractMatrix; symmetric_pattern::Bool)
    return bidirectional_pattern(SparsityPatternCSC(SparseMatrixCSC(A)); symmetric_pattern)
end

function bidirectional_pattern(S::SparsityPatternCSC{T}; symmetric_pattern::Bool) where {T}
    m, n = size(S)
    p = m + n
    nnzS = nnz(S)
    rowval = Vector{T}(undef, 2 * nnzS)
    colptr = zeros(T, p + 1)
    edge_to_index = Vector{T}(undef, 2 * nnzS)

    # Update rowval and colptr for the block A
    for i in 1:nnzS
        rowval[i] = S.rowval[i] + n
        edge_to_index[i] = i
    end
    for j in 1:n
        colptr[j] = S.colptr[j]
    end

    # Update rowval and colptr for the block Aᵀ
    if symmetric_pattern
        # Use colptr[n+1:n+m] to store the offsets during the update of edge_to_index
        offsets = colptr

        # We use the sparsity pattern of A for Aᵀ
        for k in 1:nnzS
            r = S.rowval[k]
            rowval[nnzS + k] = r
            pos = S.colptr[r] + offsets[n + r]
            edge_to_index[nnzS + pos] = edge_to_index[k]
            offsets[n + r] += 1
        end
        # m and n are identical because symmetric_pattern is true
        for j in 1:m
            colptr[n + j] = nnzS + S.colptr[j]
        end
        colptr[p + 1] = 2 * nnzS + 1
    else
        # We need to determine the sparsity pattern of Aᵀ
        # We adapt the code of transpose(SparsityPatternCSC) in graph.jl
        for k in 1:nnzS
            i = S.rowval[k]
            colptr[n + i] += 1
        end

        counter = 1
        for col in (n + 1):p
            nnz_col = colptr[col]
            colptr[col] = nnzS + counter
            counter += nnz_col
        end

        for j in 1:n
            for index in S.colptr[j]:(S.colptr[j + 1] - 1)
                i = S.rowval[index]
                pos = colptr[n + i]
                rowval[pos] = j
                edge_to_index[pos] = edge_to_index[index]
                colptr[n + i] += 1
            end
        end

        colptr[p + 1] = nnzS + counter
        for col in p:-1:(n + 2)
            colptr[col] = colptr[col - 1]
        end
        colptr[n + 1] = nnzS + 1
    end

    # Create the SparsityPatternCSC of the augmented adjacency matrix
    S_and_Sᵀ = SparsityPatternCSC{T}(p, p, colptr, rowval)
    return S_and_Sᵀ, edge_to_index
end

function build_edge_to_index(S::SparsityPatternCSC{T}) where {T}
    # edge_to_index gives an index for each edge
    edge_to_index = Vector{T}(undef, nnz(S))
    offsets = zeros(T, S.n)
    nb_self_loops = 0
    counter = 0
    rvS = rowvals(S)
    for j in axes(S, 2)
        for k in nzrange(S, j)
            i = rvS[k]
            if i > j
                counter += 1
                edge_to_index[k] = counter
                k2 = S.colptr[i] + offsets[i]
                edge_to_index[k2] = counter
                offsets[i] += 1
            elseif i == j
                # this should never be used, make sure it errors
                edge_to_index[k] = 0
                nb_self_loops += 1
            end
        end
    end
    return edge_to_index, nb_self_loops
end

## Adjacency graph

"""
    AdjacencyGraph{T,augmented_graph}

Undirected graph without self-loops representing the nonzeros of a symmetric matrix (typically a Hessian matrix).

The adjacency graph of a symmetric matrix `A ∈ ℝ^{n × n}` is `G(A) = (V, E)` where

- `V = 1:n` is the set of rows or columns `i`/`j`
- `(i, j) ∈ E` whenever `A[i, j] ≠ 0` and `i ≠ j`

# Constructors

    AdjacencyGraph(A::SparseMatrixCSC; augmented_graph::Bool=false)

# Fields

- `S::SparsityPatternCSC{T}`: Underlying sparsity pattern, which represents an augmented graph whenever `augmented_graph` is `true`. Here, "augmented graph" means the sparsity pattern of the augmented matrix `H = [0 Jᵀ; J 0]`.
- `edge_to_index::Vector{T}`: A vector mapping each nonzero of `S` to a unique edge index (ignoring diagonal and accounting for symmetry, so that `(i, j)` and `(j, i)` get the same index)

# References

> [_What Color Is Your Jacobian? SparsityPatternCSC Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
"""
struct AdjacencyGraph{T<:Integer,augmented_graph}
    S::SparsityPatternCSC{T}
    edge_to_index::Vector{T}
    nb_self_loops::Int
end

Base.eltype(::AdjacencyGraph{T}) where {T} = T

function AdjacencyGraph(
    S::SparsityPatternCSC{T},
    edge_to_index::Vector{T},
    nb_self_loops::Int;
    augmented_graph::Bool=false,
) where {T}
    return AdjacencyGraph{T,augmented_graph}(S, edge_to_index, nb_self_loops)
end

function AdjacencyGraph(S::SparsityPatternCSC; augmented_graph::Bool=false)
    edge_to_index, nb_self_loops = build_edge_to_index(S)
    return AdjacencyGraph(S, edge_to_index, nb_self_loops; augmented_graph)
end

function AdjacencyGraph(A::SparseMatrixCSC; augmented_graph::Bool=false)
    return AdjacencyGraph(SparsityPatternCSC(A); augmented_graph)
end

function AdjacencyGraph(A::AbstractMatrix; augmented_graph::Bool=false)
    return AdjacencyGraph(SparseMatrixCSC(A); augmented_graph)
end

pattern(g::AdjacencyGraph) = g.S
edge_indices(g::AdjacencyGraph) = g.edge_to_index
nb_vertices(g::AdjacencyGraph) = pattern(g).n
vertices(g::AdjacencyGraph) = 1:nb_vertices(g)
augmented_graph(::AdjacencyGraph{T,ag}) where {T,ag} = ag

function neighbors(g::AdjacencyGraph, v::Integer)
    S = pattern(g)
    neighbors_v = view(rowvals(S), nzrange(S, v))
    return neighbors_v
end

function neighbors_with_edge_indices(g::AdjacencyGraph, v::Integer)
    S = pattern(g)
    range_v = nzrange(S, v)
    neighbors_v = view(rowvals(S), range_v)
    edges_indices_v = view(edge_indices(g), range_v)
    return zip(neighbors_v, edges_indices_v)
end

degree(g::AdjacencyGraph{T,true}, v::Integer) where {T} = g.S.colptr[v + 1] - g.S.colptr[v]

function degree(g::AdjacencyGraph{T,false}, v::Integer) where {T}
    neigh = neighbors(g, v)
    has_selfloop = insorted(v, neigh)
    return g.S.colptr[v + 1] - g.S.colptr[v] - has_selfloop
end

nb_edges(g::AdjacencyGraph) = (nnz(g.S) - g.nb_self_loops) ÷ 2

maximum_degree(g::AdjacencyGraph) = maximum(Base.Fix1(degree, g), vertices(g))
minimum_degree(g::AdjacencyGraph) = minimum(Base.Fix1(degree, g), vertices(g))

function has_neighbor(g::AdjacencyGraph, v::Integer, u::Integer)
    for w in neighbors(g, v)
        augmented_graph(g) || (v == w && continue)
        if w == u
            return true
        end
    end
    return false
end

function degree_in_subset(g::AdjacencyGraph, v::Integer, subset::AbstractVector{<:Integer})
    d = 0
    for u in subset
        if has_neighbor(g, v, u)
            d += 1
        end
    end
    return d
end

## Bipartite graph

"""
    BipartiteGraph{T}

Undirected bipartite graph representing the nonzeros of a non-symmetric matrix (typically a Jacobian matrix).

The bipartite graph of a matrix `A ∈ ℝ^{m × n}` is `Gb(A) = (V₁, V₂, E)` where

- `V₁ = 1:m` is the set of rows `i`
- `V₂ = 1:n` is the set of columns `j`
- `(i, j) ∈ E` whenever `A[i, j] ≠ 0`

A `BipartiteGraph` has two sets of vertices, one for the rows of `A` (which we call side `1`) and one for the columns (which we call side `2`).

# Constructors

    BipartiteGraph(A::SparseMatrixCSC; symmetric_pattern::Bool=false)

When `symmetric_pattern` is `true`, this construction is more efficient.

# Fields

- `S1::SparsityPatternCSC{T}`: maps vertices on side `1` to their neighbors
- `S2::SparsityPatternCSC{T}`: maps vertices on side `2` to their neighbors

# References

> [_What Color Is Your Jacobian? SparsityPatternCSC Coloring for Computing Derivatives_](https://epubs.siam.org/doi/10.1137/S0036144504444711), Gebremedhin et al. (2005)
"""
struct BipartiteGraph{T<:Integer}
    S1::SparsityPatternCSC{T}
    S2::SparsityPatternCSC{T}
end

Base.eltype(::BipartiteGraph{T}) where {T} = T

function BipartiteGraph(A::AbstractMatrix; symmetric_pattern::Bool=false)
    return BipartiteGraph(SparseMatrixCSC(A); symmetric_pattern)
end

function BipartiteGraph(A::SparseMatrixCSC; symmetric_pattern::Bool=false)
    S2 = SparsityPatternCSC(A)  # columns to rows
    if symmetric_pattern
        checksquare(A)  # proxy for checking full symmetry
        S1 = S2
    else
        S1 = transpose(S2)  # rows to columns
    end
    return BipartiteGraph(S1, S2)
end

pattern(bg::BipartiteGraph, ::Val{1}) = bg.S1
pattern(bg::BipartiteGraph, ::Val{2}) = bg.S2

nb_vertices(bg::BipartiteGraph, ::Val{side}) where {side} = pattern(bg, Val(side)).n

nb_edges(bg::BipartiteGraph) = nnz(pattern(bg, Val(1)))

"""
    vertices(bg::BipartiteGraph, Val(side))

Return the list of vertices of `bg` from the specified `side` as a range `1:n`.
"""
vertices(bg::BipartiteGraph, ::Val{side}) where {side} = 1:nb_vertices(bg, Val(side))

"""
    neighbors(bg::BipartiteGraph, Val(side), v::Integer)

Return the neighbors of `v` (a vertex from the specified `side`, `1` or `2`), in the graph `bg`.
"""
function neighbors(bg::BipartiteGraph, ::Val{side}, v::Integer) where {side}
    S = pattern(bg, Val(side))
    return view(rowvals(S), nzrange(S, v))
end

function neighbors_dist2(bg::BipartiteGraph{T}, ::Val{side}, v::Integer) where {T,side}
    # TODO: make more efficient
    other_side = 3 - side
    neigh = Set{T}()
    for u in neighbors(bg, Val(side), v)
        for w in neighbors(bg, Val(other_side), u)
            w != v && push!(neigh, w)
        end
    end
    return neigh
end

function degree(bg::BipartiteGraph, ::Val{side}, v::Integer) where {side}
    return length(neighbors(bg, Val(side), v))
end

function maximum_degree(bg::BipartiteGraph, ::Val{side}) where {side}
    return maximum(v -> degree(bg, Val(side), v), vertices(bg, Val(side)))
end

function minimum_degree(bg::BipartiteGraph, ::Val{side}) where {side}
    return minimum(v -> degree(bg, Val(side), v), vertices(bg, Val(side)))
end

function degree_dist2(bg::BipartiteGraph{T}, ::Val{side}, v::Integer) where {T,side}
    return length(neighbors_dist2(bg, Val(side), v))
end

function has_neighbor_dist2(
    bg::BipartiteGraph, ::Val{side}, v::Integer, u::Integer
) where {side}
    other_side = 3 - side
    for w1 in neighbors(bg, Val(side), v)
        for w2 in neighbors(bg, Val(other_side), w1)
            if w2 == u
                return true
            end
        end
    end
    return false
end

function degree_dist2_in_subset(
    bg::BipartiteGraph, ::Val{side}, v::Integer, subset::AbstractVector{<:Integer}
) where {side}
    d = 0
    for u in subset
        if has_neighbor_dist2(bg, Val(side), v, u)
            d += 1
        end
    end
    return d
end

using CSV
using DataFrames
using LinearAlgebra
using MatrixDepot
using SparseArrays
using SparseMatrixColorings
using SparseMatrixColorings:
    AdjacencyGraph,
    BipartiteGraph,
    degree,
    minimum_degree,
    maximum_degree,
    nb_vertices,
    nb_edges,
    neighbors,
    partial_distance2_coloring,
    star_coloring,
    vertices
using Test

nbunique(x) = length(unique(x))

_N(args...) = vertices(args..., NaturalOrder())
_LF(args...) = vertices(args..., LargestFirst())
_SL(args...) = vertices(args..., SmallestLast(; reproduce_colpack=true))
_ID(args...) = vertices(args..., IncidenceDegree(; reproduce_colpack=true))
_DLF(args...) = vertices(args..., DynamicLargestFirst(; reproduce_colpack=true))

## Distance-2 coloring

#=
Comparison with Tables VI and VII of the ColPack paper
=#

colpack_table_6_7 = CSV.read(
    joinpath(@__DIR__, "reference", "colpack_table_6_7.csv"), DataFrame
)

@testset verbose = true "Distance-2 coloring (ColPack paper)" begin
    @testset "$(row[:name])" for row in eachrow(colpack_table_6_7)
        original_mat = matrixdepot("$(row[:group])/$(row[:name])")
        mat = dropzeros(original_mat)
        bg = BipartiteGraph(mat)
        @testset "Graph features" begin
            @test nb_vertices(bg, Val(1)) == row[:V1]
            @test nb_vertices(bg, Val(2)) == row[:V2]
            @test nb_edges(bg) == row[:E]
            @test maximum_degree(bg, Val(1)) == row[:Δ1]
            @test maximum_degree(bg, Val(2)) == row[:Δ2]
        end
        @testset "Natural" begin
            @test nbunique(partial_distance2_coloring(bg, Val(1), _N(bg, Val(1)))) ==
                row[:N1]
            @test nbunique(partial_distance2_coloring(bg, Val(2), _N(bg, Val(2)))) ==
                row[:N2]
        end
        yield()
        @testset "LargestFirst" begin
            @test nbunique(partial_distance2_coloring(bg, Val(1), _LF(bg, Val(1)))) ==
                row[:LF1]
            @test nbunique(partial_distance2_coloring(bg, Val(2), _LF(bg, Val(2)))) ==
                row[:LF2]
        end
        yield()
        if row[:name] == "af23560"
            # orders differ for this one, not sure why
            continue
        end
        if row[:E] > 200_000
            # just to spare computational resources, but the larger tests pass too
            continue
        end
        @testset "SmallestLast" begin
            @test nbunique(partial_distance2_coloring(bg, Val(1), _SL(bg, Val(1)))) ==
                row[:SL1]
            @test nbunique(partial_distance2_coloring(bg, Val(2), _SL(bg, Val(2)))) ==
                row[:SL2]
        end
        yield()
        @testset "IncidenceDegree" begin
            @test nbunique(partial_distance2_coloring(bg, Val(1), _ID(bg, Val(1)))) ==
                row[:ID1]
            @test nbunique(partial_distance2_coloring(bg, Val(2), _ID(bg, Val(2)))) ==
                row[:ID2]
        end
        yield()
        @testset "DynamicLargestFirst" begin
            @test nbunique(partial_distance2_coloring(bg, Val(1), _DLF(bg, Val(1)))) ==
                row[:DLF1]
            @test nbunique(partial_distance2_coloring(bg, Val(2), _DLF(bg, Val(2)))) ==
                row[:DLF2]
        end
        yield()
    end
end;

#=
Comparison with Tables 3.1 and 3.2 of "What color is your Jacobian?"
=#

what_table_31_32 = CSV.read(
    joinpath(@__DIR__, "reference", "what_table_31_32.csv"), DataFrame
)

@testset "Distance-2 coloring (survey paper)" begin
    @testset "$(row[:name])" for row in eachrow(what_table_31_32)
        ismissing(row[:group]) && continue
        original_mat = matrixdepot("$(row[:group])/$(row[:name])")
        mat = original_mat  # no dropzeros
        bg = BipartiteGraph(mat)
        @test nb_vertices(bg, Val(1)) == row[:m]
        @test nb_vertices(bg, Val(2)) == row[:n]
        @test nb_edges(bg) == row[:nnz]
        @test minimum_degree(bg, Val(1)) == row[:ρmin]
        @test maximum_degree(bg, Val(1)) == row[:ρmax]
        @test minimum_degree(bg, Val(2)) == row[:κmin]
        @test maximum_degree(bg, Val(2)) == row[:κmax]
        vertices_in_order = vertices(bg, Val(2), NaturalOrder())
        color_Nb = partial_distance2_coloring(bg, Val(2), vertices_in_order)
        if length(unique(color_Nb)) == row[:K]
            @test length(unique(color_Nb)) == row[:K]
        else
            @test_broken length(unique(color_Nb)) == row[:K]
        end
        yield()
    end
end;

## Star coloring

what_table_41_42 = CSV.read(
    joinpath(@__DIR__, "reference", "what_table_41_42.csv"), DataFrame
)

@testset "Star coloring (survey paper)" begin
    @testset "$(row[:name])" for row in eachrow(what_table_41_42)
        ismissing(row[:group]) && continue
        original_mat = matrixdepot("$(row[:group])/$(row[:name])")
        mat = dropzeros(sparse(original_mat))
        ag = AdjacencyGraph(mat)
        bg = BipartiteGraph(mat)
        @test nb_vertices(ag) == row[:V]
        @test nb_edges(ag) == row[:E]
        @test maximum_degree(ag) == row[:Δ]
        @test minimum_degree(ag) == row[:δ]
        postprocessing = false
        vertices_in_order = vertices(ag, NaturalOrder())
        color_N, _ = star_coloring(ag, vertices_in_order, postprocessing)
        @test_skip row[:KS1] <= length(unique(color_N)) <= row[:KS2]  # TODO: find better
        yield()
    end
end;

"""
    AbstractOrder

Abstract supertype for the vertex order used inside [`GreedyColoringAlgorithm`](@ref).

In this algorithm, the rows and columns of a matrix form a graph, and the vertices are colored one after the other in a greedy fashion.
Depending on how the vertices are ordered, the number of colors necessary may vary.

# Options

- [`NaturalOrder`](@ref)
- [`RandomOrder`](@ref)
- [`LargestFirst`](@ref)
- [`IncidenceDegree`](@ref) (experimental)
- [`SmallestLast`](@ref) (experimental)
- [`DynamicLargestFirst`](@ref) (experimental)
- [`PerfectEliminationOrder`](@ref)
"""
abstract type AbstractOrder end

"""
    NaturalOrder()

Instance of [`AbstractOrder`](@ref) which sorts vertices using their index in the provided graph.
"""
struct NaturalOrder <: AbstractOrder end

function vertices(g::AdjacencyGraph, ::NaturalOrder)
    return vertices(g)
end

function vertices(bg::BipartiteGraph, ::Val{side}, ::NaturalOrder) where {side}
    return vertices(bg, Val(side))
end

"""
    RandomOrder(rng=default_rng(), seed=nothing)

Instance of [`AbstractOrder`](@ref) which sorts vertices using a random permutation, generated from `rng` with a given `seed`.

- If `seed = nothing`, the `rng` will never be re-seeded. Therefore, two consecutive calls to `vertices(g, order)` will give different results.
- Otherwise, the `rng` will be re-seeded before each sample. Therefore, two consecutive calls to `vertices(g, order)` will give the same result.

!!! warning
    Do not use a seed with the `default_rng()`, otherwise you will affect the global state of your program.
    If you need reproducibility, create a new `rng` specifically for your `RandomOrder`.
    The package [StableRNGs.jl](https://github.com/JuliaRandom/StableRNGs.jl) offers random number generators whose behavior is stable across Julia versions.
"""
struct RandomOrder{R<:AbstractRNG,S} <: AbstractOrder
    rng::R
    seed::S
end

RandomOrder(rng::AbstractRNG) = RandomOrder(rng, nothing)
RandomOrder() = RandomOrder(default_rng())

function vertices(g::AdjacencyGraph, order::RandomOrder)
    (; rng, seed) = order
    if isnothing(seed)
        return randperm(rng, nb_vertices(g))
    else
        return randperm(Random.seed!(rng, seed), nb_vertices(g))
    end
end

function vertices(bg::BipartiteGraph, ::Val{side}, order::RandomOrder) where {side}
    (; rng, seed) = order
    if isnothing(seed)
        return randperm(rng, nb_vertices(bg, Val(side)))
    else
        return randperm(Random.seed!(rng, seed), nb_vertices(bg, Val(side)))
    end
end

"""
    LargestFirst()

Instance of [`AbstractOrder`](@ref) which sorts vertices using their degree in the provided graph: the largest degree comes first.
"""
struct LargestFirst <: AbstractOrder end

function vertices(g::AdjacencyGraph, ::LargestFirst)
    degrees = map(Base.Fix1(degree, g), vertices(g))
    criterion(v) = degrees[v]
    return sort(vertices(g); by=criterion, rev=true)
end

function vertices(bg::BipartiteGraph{T}, ::Val{side}, ::LargestFirst) where {T,side}
    other_side = 3 - side
    n = nb_vertices(bg, Val(side))
    visited = zeros(T, n)  # necessary for distance-2 neighborhoods
    degrees_dist2 = zeros(T, n)
    for v in vertices(bg, Val(side))
        for u in neighbors(bg, Val(side), v)
            for w in neighbors(bg, Val(other_side), u)
                if w != v && visited[w] != v
                    degrees_dist2[v] += 1
                    visited[w] = v  # avoid double counting
                end
            end
        end
    end
    # Recycle the vector visited to store the ordering
    visited .= 1:n
    criterion(v) = degrees_dist2[v]
    return sort!(visited; by=criterion, rev=true)
end

"""
    DynamicDegreeBasedOrder{degtype,direction}(; reproduce_colpack=false)

Instance of [`AbstractOrder`](@ref) which sorts vertices using a dynamically computed degree.

This order works by assigning vertices to buckets based on their dynamic degree, and then updating buckets iteratively by transfering vertices between them.

# Type parameters

- `degtype::Symbol`: can be `:forward` (for the forward degree) or `:back` (for the back degree)
- `direction::Symbol`: can be `:low2high` (if the order is defined from lowest to highest, i.e. `1` to `n`) or `:high2low` (if the order is defined from highest to lowest, i.e. `n` to `1`)

# Concrete variants

- [`IncidenceDegree`](@ref)
- [`SmallestLast`](@ref)
- [`DynamicLargestFirst`](@ref)

# Settings

- `reproduce_colpack::Bool`: whether to manage the buckets in the exact same way as the original ColPack implementation.
  - When `reproduce_colpack=true`, we always append and remove vertices at the end of a bucket (unilateral).
  - When `reproduce_colpack=false` (the default), we can append and remove vertices either at the start or at the end of a bucket (bilateral).

Allowing modifications on both sides of a bucket enables storage optimization, with a single fixed-size vector for all buckets instead of one dynamically-sized vector per bucket.
As a result, the default setting `reproduce_colpack=false` is slightly more memory-efficient.

# References

- [_ColPack: Software for graph coloring and related problems in scientific computing_](https://dl.acm.org/doi/10.1145/2513109.2513110), Gebremedhin et al. (2013), Section 5
"""
struct DynamicDegreeBasedOrder{degtype,direction,reproduce_colpack} <: AbstractOrder end

function DynamicDegreeBasedOrder{degtype,direction}(;
    reproduce_colpack::Bool=false
) where {degtype,direction}
    return DynamicDegreeBasedOrder{degtype,direction,reproduce_colpack}()
end

abstract type AbstractDegreeBuckets{T} end

struct DegreeBucketsColPack{T} <: AbstractDegreeBuckets{T}
    degrees::Vector{T}
    buckets::Vector{Vector{T}}
    positions::Vector{T}
end

struct DegreeBucketsSMC{T} <: AbstractDegreeBuckets{T}
    degrees::Vector{T}
    bucket_storage::Vector{T}
    bucket_low::Vector{T}
    bucket_high::Vector{T}
    positions::Vector{T}
end

function DegreeBucketsColPack(::Type{T}, degrees::Vector{T}, dmax::Integer) where {T}
    # number of vertices per degree class
    deg_count = zeros(T, dmax + 1)
    for d in degrees
        deg_count[d + 1] += 1
    end
    # one vector per bucket
    buckets = [Vector{T}(undef, deg_count[d + 1]) for d in 0:dmax]
    positions = similar(degrees, T)
    # assign each vertex to the correct local position inside its bucket
    for v in eachindex(positions, degrees)
        d = degrees[v]
        positions[v] = length(buckets[d + 1]) - deg_count[d + 1] + 1
        buckets[d + 1][positions[v]] = v
        deg_count[d + 1] -= 1
    end
    return DegreeBucketsColPack(degrees, buckets, positions)
end

function DegreeBucketsSMC(::Type{T}, degrees::Vector{T}, dmax::Integer) where {T}
    # number of vertices per degree class
    deg_count = zeros(T, dmax + 1)
    for d in degrees
        deg_count[d + 1] += 1
    end
    # bucket limits
    bucket_high = accumulate(+, deg_count)
    bucket_low = similar(bucket_high)
    bucket_low[1] = 1
    bucket_low[2:end] .= @view(bucket_high[1:(end - 1)]) .+ 1
    # assign each vertex to the correct global position inside its bucket
    bucket_storage = similar(degrees, T)
    positions = similar(degrees, T)
    for v in eachindex(positions, degrees)
        d = degrees[v]
        positions[v] = bucket_high[d + 1] - deg_count[d + 1] + 1
        bucket_storage[positions[v]] = v
        deg_count[d + 1] -= 1
    end
    return DegreeBucketsSMC(degrees, bucket_storage, bucket_low, bucket_high, positions)
end

function nonempty_bucket(db::DegreeBucketsSMC, d::Integer)
    return db.bucket_high[d + 1] >= db.bucket_low[d + 1]
end
function nonempty_bucket(db::DegreeBucketsColPack, d::Integer)
    return !isempty(db.buckets[d + 1])
end

function degree_increasing(; degtype, direction)
    increasing =
        (degtype == :back && direction == :low2high) ||
        (degtype == :forward && direction == :high2low)
    return increasing
end

function pop_next_candidate!(db::AbstractDegreeBuckets; degree_range::OrdinalRange)
    (; degrees) = db
    # degree_range is used to avoid going through the empty parts of 0:dmax
    candidate_degree = -1
    for d in degree_range
        if nonempty_bucket(db, d)
            candidate_degree = d
            break
        end
    end
    if db isa DegreeBucketsColPack
        (; buckets) = db
        bucket = buckets[candidate_degree + 1]
        candidate = pop!(bucket)
    else
        (; bucket_storage, bucket_high) = db
        high = bucket_high[candidate_degree + 1]
        candidate = bucket_storage[high]
        bucket_high[candidate_degree + 1] -= 1
    end
    # mark as ordered
    degrees[candidate] = -1
    # returning candidate degree is useful to update degree_range
    return candidate, candidate_degree
end

function update_bucket!(
    db::DegreeBucketsSMC, v::Integer, d::Integer; degtype::Symbol, direction::Symbol
)
    (; degrees, bucket_storage, bucket_low, bucket_high, positions) = db
    p = positions[v]
    # select previous or next bucket for the move
    if degree_increasing(; degtype, direction)
        high = bucket_high[d + 1]
        # move the vertex w located at the end of the current bucket to v's position
        w = bucket_storage[high]
        bucket_storage[p] = w
        positions[w] = p
        # shrink current bucket from the right
        # morally we put v at the end and then ignore it
        bucket_high[d + 1] -= 1
        # move v to the beginning of the next bucket (!= ColPack)
        d_new = d + 1
        low_new = bucket_low[d_new + 1]
        bucket_storage[low_new - 1] = v
        # grow next bucket to the left
        bucket_low[d_new + 1] -= 1
        # update v's stats
        degrees[v] = d_new
        positions[v] = low_new - 1
    else
        low = bucket_low[d + 1]
        # move the vertex w located at the start of the current bucket to v's position (!= ColPack)
        w = bucket_storage[low]
        bucket_storage[p] = w
        positions[w] = p
        # shrink current bucket from the left
        # morally we put v at the start and then ignore it
        bucket_low[d + 1] += 1
        # move v to the end of the previous bucket
        d_new = d - 1
        high_new = bucket_high[d_new + 1]
        bucket_storage[high_new + 1] = v
        # grow previous bucket to the right
        bucket_high[d_new + 1] += 1
        # update v's stats
        degrees[v] = d_new
        positions[v] = high_new + 1
    end
    return nothing
end

function update_bucket!(
    db::DegreeBucketsColPack, v::Integer, d::Integer; degtype::Symbol, direction::Symbol
)
    (; degrees, buckets, positions) = db
    p = positions[v]
    bucket = buckets[d + 1]
    # select previous or next bucket for the move
    d_new = degree_increasing(; degtype, direction) ? d + 1 : d - 1
    bucket_new = buckets[d_new + 1]
    # put v at the end of its bucket by swapping
    w = bucket[end]
    bucket[p] = w
    bucket[end] = v
    positions[w] = p
    positions[v] = length(bucket)
    # move v from the old bucket to the new one
    pop!(bucket)
    push!(bucket_new, v)
    degrees[v] = d_new
    positions[v] = length(bucket_new)
    return nothing
end

function vertices(
    g::AdjacencyGraph{T}, ::DynamicDegreeBasedOrder{degtype,direction,reproduce_colpack}
) where {T<:Integer,degtype,direction,reproduce_colpack}
    degrees = T[degree(g, v) for v in vertices(g)]
    dmax = maximum(degrees)
    if degree_increasing(; degtype, direction)
        fill!(degrees, zero(T))
    end
    db = if reproduce_colpack
        DegreeBucketsColPack(T, degrees, dmax)
    else
        DegreeBucketsSMC(T, degrees, dmax)
    end
    nv = nb_vertices(g)
    π = Vector{T}(undef, nv)
    index_π = (direction == :low2high) ? (1:nv) : reverse(1:nv)
    degree_range = (direction == :low2high) ? reverse(0:dmax) : (0:dmax)
    for index in index_π
        u, du = pop_next_candidate!(db; degree_range)

        π[index] = u
        for v in neighbors(g, u)
            augmented_graph(g) || (u == v && continue)
            dv = degrees[v]
            dv == -1 && continue
            update_bucket!(db, v, dv; degtype, direction)
        end
        # no need to look much further than du next time
        degree_range = if direction == :low2high
            reverse(0:min(du + 1, dmax))
        else
            max(du - 1, 0):dmax
        end
    end
    return π
end

function vertices(
    g::BipartiteGraph{T},
    ::Val{side},
    ::DynamicDegreeBasedOrder{degtype,direction,reproduce_colpack},
) where {T<:Integer,side,degtype,direction,reproduce_colpack}
    other_side = 3 - side
    # compute dist-2 degrees in an optimized way
    n = nb_vertices(g, Val(side))
    degrees = zeros(T, n)
    visited = zeros(T, n)
    for v in vertices(g, Val(side))
        for w1 in neighbors(g, Val(side), v)
            for w2 in neighbors(g, Val(other_side), w1)
                if w2 != v && visited[w2] != v
                    degrees[v] += 1
                    visited[w2] = v
                end
            end
        end
    end
    dmax = maximum(degrees)
    if degree_increasing(; degtype, direction)
        fill!(degrees, zero(T))
    end
    db = if reproduce_colpack
        DegreeBucketsColPack(T, degrees, dmax)
    else
        DegreeBucketsSMC(T, degrees, dmax)
    end
    π = Vector{T}(undef, n)
    index_π = (direction == :low2high) ? (1:n) : (n:-1:1)
    degree_range = (direction == :low2high) ? reverse(0:dmax) : (0:dmax)
    for index in index_π
        u, du = pop_next_candidate!(db; degree_range)
        π[index] = u
        for w in neighbors(g, Val(side), u)
            for v in neighbors(g, Val(other_side), w)
                if v != u && visited[v] != -u
                    # Use -u such that we don't need to fill "visited" with 0 after the computation of the dist-2 degrees
                    visited[v] = -u
                    dv = degrees[v]
                    dv == -1 && continue
                    update_bucket!(db, v, dv; degtype, direction)
                end
            end
        end
        # no need to look much further than du next time
        degree_range = if direction == :low2high
            reverse(0:min(du + 1, dmax))
        else
            max(du - 1, 0):dmax
        end
    end
    return π
end

"""
    IncidenceDegree(; reproduce_colpack=false)

Instance of [`AbstractOrder`](@ref) which sorts vertices from lowest to highest using the dynamic back degree.

# See also

- [`DynamicDegreeBasedOrder`](@ref)
"""
function IncidenceDegree(; reproduce_colpack::Bool=false)
    return DynamicDegreeBasedOrder{:back,:low2high,reproduce_colpack}()
end

"""
    SmallestLast(; reproduce_colpack=false)

Instance of [`AbstractOrder`](@ref) which sorts vertices from highest to lowest using the dynamic back degree.

# See also

- [`DynamicDegreeBasedOrder`](@ref)
"""
function SmallestLast(; reproduce_colpack::Bool=false)
    return DynamicDegreeBasedOrder{:back,:high2low,reproduce_colpack}()
end

"""
    DynamicLargestFirst(; reproduce_colpack=false)

Instance of [`AbstractOrder`](@ref) which sorts vertices from lowest to highest using the dynamic forward degree.

# See also
    
- [`DynamicDegreeBasedOrder`](@ref)
"""
function DynamicLargestFirst(; reproduce_colpack::Bool=false)
    return DynamicDegreeBasedOrder{:forward,:low2high,reproduce_colpack}()
end

"""
    PerfectEliminationOrder(elimination_algorithm=CliqueTrees.MCS())

Instance of [`AbstractOrder`](@ref) which computes a perfect elimination ordering when the underlying graph is [chordal](https://en.wikipedia.org/wiki/Chordal_graph). For non-chordal graphs, it computes a suboptimal ordering.

The `elimination_algorithm` must be an instance of `CliqueTrees.EliminationAlgorithm`.

!!! warning
    This order can only be applied for symmetric or bidirectional coloring problems. Furthermore, its theoretical guarantees only hold for decompression by substitution.

!!! danger
    This order is implemented as a package extension and requires loading [CliqueTrees.jl](https://github.com/AlgebraicJulia/CliqueTrees.jl).

# References

- [Simple Linear-Time Algorithms to Test Chordality of Graphs, Test Acyclicity of Hypergraphs, and Selectively Reduce Acyclic Hypergraphs](https://epubs.siam.org/doi/10.1137/0213035), Tarjan and Yannakakis (1984)
"""
struct PerfectEliminationOrder{E} <: AbstractOrder
    elimination_algorithm::E
end

function all_orders()
    return [
        NaturalOrder(),
        RandomOrder(),
        LargestFirst(),
        SmallestLast(),
        SmallestLast(; reproduce_colpack=true),
        IncidenceDegree(),
        IncidenceDegree(; reproduce_colpack=true),
        DynamicLargestFirst(),
        DynamicLargestFirst(; reproduce_colpack=true),
        DynamicDegreeBasedOrder{:forward,:high2low}(),
        DynamicDegreeBasedOrder{:forward,:high2low}(; reproduce_colpack=true),
    ]
end

using ArrayInterface: ArrayInterface
using BandedMatrices: BandedMatrix, brand
using BlockBandedMatrices: BandedBlockBandedMatrix, BlockBandedMatrix
using LinearAlgebra
using SparseArrays
using SparseMatrixColorings
using Test

@testset "Diagonal" begin
    for n in (1, 2, 10, 100)
        A = Diagonal(rand(n))
        test_structured_coloring_decompression(A)
    end
end;

@testset "Bidiagonal" begin
    for n in (2, 10, 100)
        A1 = Bidiagonal(rand(n), rand(n - 1), :U)
        A2 = Bidiagonal(rand(n), rand(n - 1), :L)
        test_structured_coloring_decompression(A1)
        test_structured_coloring_decompression(A2)
    end
end;

@testset "Tridiagonal" begin
    for n in (2, 10, 100)
        A = Tridiagonal(rand(n - 1), rand(n), rand(n - 1))
        test_structured_coloring_decompression(A)
    end
end;

@testset "BandedMatrices" begin
    @testset for (m, n) in [(10, 20), (20, 10)], l in 0:5, u in 0:5
        A = brand(m, n, l, u)
        test_structured_coloring_decompression(A)
    end
end;

@testset "BlockBandedMatrices" begin
    for (mb, nb) in [(10, 20), (20, 10)], lb in 0:3, ub in 0:3, _ in 1:10
        rows = rand(1:5, mb)
        cols = rand(1:5, nb)
        A = BlockBandedMatrix{Float64}(rand(sum(rows), sum(cols)), rows, cols, (lb, ub))
        test_structured_coloring_decompression(A)
    end
end;

@testset "BandedBlockBandedMatrices" begin
    for (mb, nb) in [(10, 20), (20, 10)], lb in 0:3, ub in 0:3, _ in 1:10
        rows = rand(5:10, mb)
        cols = rand(5:10, nb)
        λ = rand(0:5)
        μ = rand(0:5)
        A = BandedBlockBandedMatrix{Float64}(
            rand(sum(rows), sum(cols)), rows, cols, (lb, ub), (λ, μ)
        )
        test_structured_coloring_decompression(A)
    end
end;

# See https://github.com/JuliaDiff/SparseMatrixColorings.jl/pull/299
@testset "SparsityPatternCSC $T" for T in [Int, Float32]
    S = sparse(T[
        0 0 1 1 0 1
        1 0 0 0 1 0
        0 1 0 0 1 0
        0 1 1 0 0 0
    ])
    P = SparseMatrixColorings.SparsityPatternCSC(S)
    problem = ColoringProblem()
    algo = GreedyColoringAlgorithm()
    result = coloring(P, problem, algo)
    B = compress(S, result)
    @test decompress(B, result) isa SparseMatrixCSC{T,Int}
end;

module SparseMatrixColoringsJuMPExt

using ADTypes: ADTypes
using JuMP:
    Model,
    assert_is_solved_and_feasible,
    optimize!,
    primal_status,
    set_silent,
    set_start_value,
    value,
    @variable,
    @constraint,
    @objective
using JuMP
import MathOptInterface as MOI
using SparseMatrixColorings:
    BipartiteGraph, OptimalColoringAlgorithm, nb_vertices, neighbors, pattern, vertices

function optimal_distance2_coloring(
    bg::BipartiteGraph,
    ::Val{side},
    optimizer::O;
    silent::Bool=true,
    assert_solved::Bool=true,
) where {side,O}
    other_side = 3 - side
    n = nb_vertices(bg, Val(side))
    model = Model(optimizer)
    silent && set_silent(model)
    # one variable per vertex to color, removing some renumbering symmetries
    @variable(model, 1 <= color[i=1:n] <= i, Int)
    # one variable to count the number of distinct colors
    @variable(model, ncolors, Int)
    @constraint(model, [ncolors; color] in MOI.CountDistinct(n + 1))
    # distance-2 coloring: neighbors of the same vertex must have distinct colors
    for i in vertices(bg, Val(other_side))
        neigh = neighbors(bg, Val(other_side), i)
        @constraint(model, color[neigh] in MOI.AllDifferent(length(neigh)))
    end
    # minimize the number of distinct colors (can't use maximum because they are not necessarily numbered contiguously)
    @objective(model, Min, ncolors)
    # actual solving step where time is spent
    optimize!(model)
    if assert_solved
        # assert feasibility and optimality
        assert_is_solved_and_feasible(model)
    else
        # only assert feasibility
        @assert primal_status(model) == MOI.FEASIBLE_POINT
    end
    # native solver solutions are floating point numbers
    color_int = round.(Int, value.(color))
    # remap to 1:cmax in case they are not contiguous
    true_ncolors = 0
    remap = fill(0, maximum(color_int))
    for c in color_int
        if remap[c] == 0
            true_ncolors += 1
            remap[c] = true_ncolors
        end
    end
    return remap[color_int]
end

function ADTypes.column_coloring(A::AbstractMatrix, algo::OptimalColoringAlgorithm)
    bg = BipartiteGraph(A)
    return optimal_distance2_coloring(
        bg, Val(2), algo.optimizer; algo.silent, algo.assert_solved
    )
end

function ADTypes.row_coloring(A::AbstractMatrix, algo::OptimalColoringAlgorithm)
    bg = BipartiteGraph(A)
    return optimal_distance2_coloring(
        bg, Val(1), algo.optimizer; algo.silent, algo.assert_solved
    )
end

end

using Chairmarks
using LinearAlgebra
using SparseArrays
using SparseMatrixColorings
using SparseMatrixColorings: BipartiteGraph, partial_distance2_coloring!
using StableRNGs
using Test

rng = StableRNG(63)

function test_noallocs_distance2_coloring(n)
    bench = @be (;
        bg=BipartiteGraph(sprand(rng, n, n, 5 / n)),
        color=Vector{Int}(undef, n),
        forbidden_colors=Vector{Int}(undef, n),
    ) partial_distance2_coloring!(_.color, _.forbidden_colors, _.bg, Val(1), 1:n) evals = 1
    @test minimum(bench).allocs == 0
end

@testset "Distance-2 coloring" begin
    test_noallocs_distance2_coloring(1000)
end

function test_noallocs_sparse_decompression(
    n::Integer; structure::Symbol, partition::Symbol, decompression::Symbol
)
    A = sparse(Symmetric(sprand(rng, n, n, 5 / n)))
    result = coloring(
        A, ColoringProblem(; structure, partition), GreedyColoringAlgorithm(; decompression)
    )

    if partition == :bidirectional
        Br, Bc = compress(A, result)
        @testset "Full decompression" begin
            bench1_full = @be similar(A) decompress!(_, Br, Bc, result) evals = 1
            bench2_full = @be similar(Matrix(A)) decompress!(_, Br, Bc, result) evals = 1
            @test minimum(bench1_full).allocs == 0
            @test_broken minimum(bench2_full).allocs == 0
        end
    else
        B = compress(A, result)
        @testset "Full decompression" begin
            bench1_full = @be similar(A) decompress!(_, B, result) evals = 1
            bench2_full = @be similar(Matrix(A)) decompress!(_, B, result) evals = 1
            @test minimum(bench1_full).allocs == 0
            @test minimum(bench2_full).allocs == 0
        end
        @testset "Single-color decompression" begin
            if decompression == :direct
                b = if partition == :column
                    B[:, 1]
                else
                    B[1, :]
                end
                bench1_singlecolor = @be similar(A) decompress_single_color!(
                    _, b, 1, result
                ) evals = 1
                bench2_singlecolor = @be similar(Matrix(A)) decompress_single_color!(
                    _, b, 1, result
                ) evals = 1
                @test minimum(bench1_singlecolor).allocs == 0
                @test minimum(bench2_singlecolor).allocs == 0
            end
        end
        @testset "Triangle decompression" begin
            if structure == :symmetric
                bench1_triangle = @be similar(triu(A)) decompress!(_, B, result, :U) evals =
                    1
                bench2_triangle = @be similar(Matrix(A)) decompress!(_, B, result, :U) evals =
                    1
                @test minimum(bench1_triangle).allocs == 0
                @test minimum(bench2_triangle).allocs == 0
            end
        end
        @testset "Single-color triangle decompression" begin
            if structure == :symmetric && decompression == :direct
                b = B[:, 1]
                bench1_singlecolor_triangle = @be similar(triu(A)) decompress_single_color!(
                    _, b, 1, result, :U
                ) evals = 1
                bench2_singlecolor_triangle = @be similar(Matrix(A)) decompress_single_color!(
                    _, b, 1, result, :U
                ) evals = 1
                @test minimum(bench1_singlecolor_triangle).allocs == 0
                @test minimum(bench2_singlecolor_triangle).allocs == 0
            end
        end
    end
end

function test_noallocs_structured_decompression(
    n::Integer; structure::Symbol, partition::Symbol, decompression::Symbol
)
    @testset "$(nameof(typeof(A)))" for A in [
        Diagonal(rand(n)),
        Bidiagonal(rand(n), rand(n - 1), 'U'),
        Bidiagonal(rand(n), rand(n - 1), 'L'),
        Tridiagonal(rand(n - 1), rand(n), rand(n - 1)),
    ]
        result = coloring(
            A,
            ColoringProblem(; structure, partition),
            GreedyColoringAlgorithm(; decompression),
        )
        B = compress(A, result)
        bench = @be similar(A) decompress!(_, B, result) evals = 1
        @test minimum(bench).allocs == 0
    end
end

@testset "Sparse decompression" begin
    @testset "$structure - $partition - $decompression" for (
        structure, partition, decompression
    ) in [
        (:nonsymmetric, :column, :direct),
        (:nonsymmetric, :row, :direct),
        (:symmetric, :column, :direct),
        (:symmetric, :column, :substitution),
        (:nonsymmetric, :bidirectional, :direct),
        (:nonsymmetric, :bidirectional, :substitution),
    ]
        test_noallocs_sparse_decompression(1000; structure, partition, decompression)
    end
end

@testset "Structured decompression" begin
    @testset "$structure - $partition - $decompression" for (
        structure, partition, decompression
    ) in [
        (:nonsymmetric, :column, :direct), (:nonsymmetric, :row, :direct)
    ]
        test_noallocs_structured_decompression(1000; structure, partition, decompression)
    end
end

@testset "Single precision" begin
    n, p = 10_000, 0.001
    A64 = sparse(Symmetric(sprand(rng, Float32, 100, 100, 0.1)))
    A32 = convert(SparseMatrixCSC{Float32,Int32}, A64)
    @testset "$structure - $partition - $decompression" for (
        structure, partition, decompression
    ) in [
        (:nonsymmetric, :column, :direct),
        (:nonsymmetric, :row, :direct),
        (:symmetric, :column, :direct),
        (:symmetric, :column, :substitution),
        (:nonsymmetric, :bidirectional, :direct),
        (:nonsymmetric, :bidirectional, :substitution),
    ]
        @testset for order in
                     (NaturalOrder(), RandomOrder(), LargestFirst(), DynamicLargestFirst())
            problem = ColoringProblem(; structure, partition)
            algo = GreedyColoringAlgorithm(order; decompression)
            b64 = @b fast_coloring(A64, problem, algo)
            b32 = @b fast_coloring(A32, problem, algo)
            # check that we allocate no more than 50% + epsilon with Int32
            @test b32.bytes < 0.7 * b64.bytes
        end
    end
end;

## Forest

"""
$TYPEDEF

Structure that provides fast union-find operations for constructing a forest during acyclic coloring and bicoloring.

# Fields

$TYPEDFIELDS
"""
mutable struct Forest{T<:Integer}
    "current number of distinct trees in the forest"
    nt::T
    "vector storing the index of a parent in the tree for each edge, used in union-find operations"
    parents::Vector{T}
    "vector approximating the depth of each tree to optimize path compression"
    ranks::Vector{T}
end

function Forest{T}(n::Integer) where {T<:Integer}
    nt = T(n)
    parents = collect(Base.OneTo(T(n)))
    ranks = zeros(T, T(n))
    return Forest{T}(nt, parents, ranks)
end

function _find_root!(parents::Vector{<:Integer}, index_edge::Integer)
    p = parents[index_edge]
    if parents[p] != p
        parents[index_edge] = p = _find_root!(parents, p)
    end
    return p
end

function find_root!(forest::Forest{<:Integer}, index_edge::Integer)
    return _find_root!(forest.parents, index_edge)
end

function root_union!(
    forest::Forest{T}, index_edge1::Integer, index_edge2::Integer
) where {T<:Integer}
    parents = forest.parents
    rks = forest.ranks
    rank1 = rks[index_edge1]
    rank2 = rks[index_edge2]

    if rank1 < rank2
        index_edge1, index_edge2 = index_edge2, index_edge1
    elseif rank1 == rank2
        rks[index_edge1] += one(T)
    end
    parents[index_edge2] = index_edge1
    forest.nt -= one(T)
    return nothing
end

const TransposeOrAdjoint{T,M} = Union{Transpose{T,M},Adjoint{T,M}}

"""
    matrix_versions(A::AbstractMatrix)

Return various versions of the same matrix:

- dense and sparse
- transpose and adjoint

Used for internal testing.
"""
function matrix_versions(A::AbstractMatrix)
    A_dense = Matrix(A)
    A_sparse = sparse(A)
    versions = [
        A_dense,
        transpose(Matrix(transpose(A_dense))),
        adjoint(Matrix(adjoint(A_dense))),
        A_sparse,
        transpose(sparse(transpose(A_sparse))),
        adjoint(sparse(adjoint(A_sparse))),
    ]
    if issymmetric(A)
        lower_triangles = [
            Matrix(LowerTriangular(A_dense)), sparse(LowerTriangular(A_sparse))
        ]
        upper_triangles = [
            Matrix(UpperTriangular(A_dense)), sparse(UpperTriangular(A_sparse))
        ]
        symmetric_versions = vcat(
            Symmetric.(versions),
            Hermitian.(versions),
            Symmetric.(lower_triangles, :L),
            Symmetric.(upper_triangles, :U),
        )
        append!(versions, symmetric_versions)
    end
    return versions
end

"""
    respectful_similar(A::AbstractMatrix)
    respectful_similar(A::AbstractMatrix, ::Type{T})

Like `Base.similar` but returns a transpose or adjoint when `A` is a transpose or adjoint.
"""
respectful_similar(A::AbstractMatrix) = respectful_similar(A, eltype(A))

respectful_similar(A::AbstractMatrix, ::Type{T}) where {T} = similar(A, T)

function respectful_similar(A::Transpose, ::Type{T}) where {T}
    return transpose(respectful_similar(parent(A), T))
end

function respectful_similar(A::Adjoint, ::Type{T}) where {T}
    return adjoint(respectful_similar(parent(A), T))
end

function respectful_similar(A::Union{Symmetric,Hermitian}, ::Type{T}) where {T}
    return respectful_similar(sparse(A), T)
end

"""
    compatible_pattern(A::AbstractMatrix, bg::BipartiteGraph)
    compatible_pattern(A::AbstractMatrix, ag::AdjacencyGraph, uplo::Symbol)

Perform a coarse compatibility check between the sparsity pattern of `A`
and the reference sparsity pattern encoded in a graph structure.

This function only checks necessary conditions for the two sparsity patterns to match.
In particular, it may return `true` even if the patterns are not identical.

When A is a `SparseMatrixCSC`, additional checks on the sparsity structure are performed.

# Return value
- `true`  : the sparsity patterns are potentially compatible
- `false` : the sparsity patterns are definitely incompatible
"""
compatible_pattern(A::AbstractMatrix, bg::BipartiteGraph) = size(A) == size(bg.S2)
function compatible_pattern(A::SparseMatrixCSC, bg::BipartiteGraph)
    return size(A) == size(bg.S2) && nnz(A) == nnz(bg.S2)
end

function compatible_pattern(A::AbstractMatrix, ag::AdjacencyGraph, uplo::Symbol)
    return size(A) == size(ag.S)
end

function compatible_pattern(A::SparseMatrixCSC, ag::AdjacencyGraph, uplo::Symbol)
    nnzS = (uplo == :L || uplo == :U) ? (nb_edges(ag) + ag.nb_self_loops) : nnz(ag.S)
    return size(A) == size(ag.S) && nnz(A) == nnzS
end

function check_compatible_pattern(A::AbstractMatrix, bg::BipartiteGraph)
    if !compatible_pattern(A, bg)
        throw(DimensionMismatch("`A` and `bg.S2` must have the same sparsity pattern."))
    end
end

function check_compatible_pattern(A::AbstractMatrix, ag::AdjacencyGraph, uplo::Symbol)
    if !compatible_pattern(A, ag, uplo)
        if uplo == :L
            throw(
                DimensionMismatch(
                    "`A` and `tril(ag.S)` must have the same sparsity pattern."
                ),
            )
        elseif uplo == :U
            throw(
                DimensionMismatch(
                    "`A` and `triu(ag.S)` must have the same sparsity pattern."
                ),
            )
        else  # uplo == :F
            throw(DimensionMismatch("`A` and `ag.S` must have the same sparsity pattern."))
        end
    end
end

using CliqueTrees: CliqueTrees
using BandedMatrices
using LinearAlgebra
using SparseArrays
using SparseMatrixColorings
using SparseMatrixColorings:
    AdjacencyGraph,
    BipartiteGraph,
    LargestFirst,
    NaturalOrder,
    RandomOrder,
    PerfectEliminationOrder,
    degree_dist2,
    nb_vertices,
    valid_dynamic_order,
    vertices
using Random
using StableRNGs
using Test

rng = StableRNG(63)

@testset "NaturalOrder" begin
    A = sprand(rng, Bool, 5, 5, 0.5)
    ag = AdjacencyGraph(A)
    @test vertices(ag, NaturalOrder()) == 1:5

    A = sprand(rng, Bool, 5, 4, 0.5)
    bg = BipartiteGraph(A)
    @test vertices(bg, Val(1), NaturalOrder()) == 1:5

    A = sprand(rng, Bool, 5, 4, 0.5)
    bg = BipartiteGraph(A)
    @test vertices(bg, Val(2), NaturalOrder()) == 1:4
end;

@testset "RandomOrder" begin
    A = sparse(Symmetric(sprand(rng, Bool, 10, 10, 0.5)))
    ag = AdjacencyGraph(A)
    @test sort(vertices(ag, RandomOrder(rng))) == 1:10
    @test sort(vertices(ag, RandomOrder())) == 1:10

    A = sprand(rng, Bool, 10, 8, 0.5)
    bg = BipartiteGraph(A)
    @test sort(vertices(bg, Val(1), RandomOrder(rng))) == 1:10
    @test sort(vertices(bg, Val(1), RandomOrder())) == 1:10

    A = sprand(rng, Bool, 10, 8, 0.5)
    bg = BipartiteGraph(A)
    @test sort(vertices(bg, Val(2), RandomOrder(rng))) == 1:8
    @test sort(vertices(bg, Val(2), RandomOrder())) == 1:8

    order = RandomOrder()
    @test order.rng === Random.default_rng()
    @test isnothing(order.seed)

    order = RandomOrder(StableRNG(0), 6)
    @test order.seed == 6
    @test vertices(ag, order) == vertices(ag, order)
    @test vertices(bg, Val(2), order) == vertices(bg, Val(2), order)
end;

@testset "LargestFirst" begin
    A = sparse([
        0 1 0 0
        1 0 1 1
        0 1 0 1
        0 1 1 0
    ])
    ag = AdjacencyGraph(A)
    @test vertices(ag, LargestFirst()) == [2, 3, 4, 1]

    A = sparse([
        1 1 0 0
        0 1 1 1
        0 0 1 0
        0 0 0 0
        1 0 1 0
    ])
    bg = BipartiteGraph(A)

    for side in (1, 2)
        true_order = sort(
            vertices(bg, Val(side)); by=v -> degree_dist2(bg, Val(side), v), rev=true
        )
        @test vertices(bg, Val(side), LargestFirst()) == true_order
    end
end;

@testset "Dynamic degree-based orders" begin
    @testset "$order" for order in [
        SmallestLast(),
        SmallestLast(; reproduce_colpack=true),
        IncidenceDegree(),
        IncidenceDegree(; reproduce_colpack=true),
        DynamicLargestFirst(),
        DynamicLargestFirst(; reproduce_colpack=true),
        DynamicDegreeBasedOrder{:forward,:high2low}(),
        DynamicDegreeBasedOrder{:forward,:high2low}(; reproduce_colpack=true),
    ]
        @testset "AdjacencyGraph" begin
            for (n, p) in Iterators.product(20:20:100, 0.0:0.1:0.2)
                yield()
                A = sparse(Symmetric(sprand(rng, Bool, n, n, p)))
                g = AdjacencyGraph(A)
                π = vertices(g, order)
                @test valid_dynamic_order(g, π, order)
            end
        end
        @testset "BipartiteGraph" begin
            for (n, p) in Iterators.product(20:20:100, 0.0:0.1:0.2)
                m = rand((n ÷ 2, n * 2))
                A = sprand(rng, Bool, m, n, p)
                g = BipartiteGraph(A)
                π1 = vertices(g, Val(1), order)
                π2 = vertices(g, Val(2), order)
                @test valid_dynamic_order(g, Val(1), π1, order)
                @test valid_dynamic_order(g, Val(2), π2, order)
                @test !valid_dynamic_order(g, Val(1), π2, order)
            end
        end
    end
end;

@testset "PerfectEliminationOrder" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    substitution_algo = GreedyColoringAlgorithm(
        PerfectEliminationOrder(); decompression=:substitution
    )

    # band graphs
    for (n, m) in ((800, 80), (400, 40), (200, 20), (100, 10))
        perm = randperm(rng, n)
        matrix = permute!(sparse(Symmetric(brand(n, n, m, 0), :L)), perm, perm)
        π = vertices(AdjacencyGraph(matrix), PerfectEliminationOrder())
        @test isperm(π)
        @test ncolors(coloring(matrix, problem, substitution_algo)) == m + 1
    end

    # random graphs
    for (n, p) in Iterators.product(20:20:100, 0.0:0.1:0.2)
        matrix = sparse(Symmetric(sprand(rng, Bool, n, n, p)))
        π = vertices(AdjacencyGraph(matrix), PerfectEliminationOrder())
        @test isperm(π)
    end
end

@testset "Multiple orders" begin
    # I used brute force to find examples where LargestFirst is *strictly* better than NaturalOrder, just to check that the best order is indeed selected when multiple orders are provided
    @testset "Column coloring" begin
        A = [
            0 0 1 1
            0 1 0 1
            0 0 1 1
            1 1 0 0
        ]
        problem = ColoringProblem{:nonsymmetric,:column}()
        algo = GreedyColoringAlgorithm(NaturalOrder())
        better_algo = GreedyColoringAlgorithm((NaturalOrder(), LargestFirst()))
        @test ncolors(coloring(A, problem, better_algo)) <
            ncolors(coloring(A, problem, algo))
    end
    @testset "Row coloring" begin
        A = [
            1 0 0 0
            0 0 1 0
            0 1 1 1
            1 0 0 1
        ]
        problem = ColoringProblem{:nonsymmetric,:row}()
        algo = GreedyColoringAlgorithm(NaturalOrder())
        better_algo = GreedyColoringAlgorithm((NaturalOrder(), LargestFirst()))
        @test ncolors(coloring(A, problem, better_algo)) <
            ncolors(coloring(A, problem, algo))
    end
    @testset "Star coloring" begin
        A = [
            0 1 0 1 1
            1 1 0 1 0
            0 0 1 0 1
            1 1 0 1 0
            1 0 1 0 0
        ]
        problem = ColoringProblem{:symmetric,:column}()
        algo = GreedyColoringAlgorithm(NaturalOrder())
        better_algo = GreedyColoringAlgorithm((NaturalOrder(), LargestFirst()))
        @test ncolors(coloring(A, problem, better_algo)) <
            ncolors(coloring(A, problem, algo))
    end
    @testset "Acyclic coloring" begin
        A = [
            1 0 0 0 0 1 0
            0 0 0 1 0 0 0
            0 0 0 1 0 0 0
            0 1 1 1 0 1 1
            0 0 0 0 0 0 1
            1 0 0 1 0 0 1
            0 0 0 1 1 1 1
        ]
        problem = ColoringProblem{:symmetric,:column}()
        algo = GreedyColoringAlgorithm{:substitution}(NaturalOrder())
        better_algo = GreedyColoringAlgorithm{:substitution}((
            NaturalOrder(), LargestFirst()
        ))
        @test ncolors(coloring(A, problem, better_algo)) <
            ncolors(coloring(A, problem, algo))
    end
    @testset "Star bicoloring" begin
        A = [
            0 1 0 0 0
            1 0 1 0 0
            0 1 0 0 1
            0 0 0 0 0
            0 0 1 0 1
        ]
        problem = ColoringProblem{:nonsymmetric,:bidirectional}()
        algo = GreedyColoringAlgorithm(NaturalOrder())
        better_algo = GreedyColoringAlgorithm((NaturalOrder(), LargestFirst()))
        @test ncolors(coloring(A, problem, better_algo)) <
            ncolors(coloring(A, problem, algo))
    end
    @testset "Acyclic bicoloring" begin
        A = [
            0 1 0 1 1 0 1 0 1
            1 0 0 0 0 0 0 0 1
            0 0 0 0 0 0 0 0 0
            1 0 0 1 1 0 1 0 0
            1 0 0 1 0 0 0 0 0
            0 0 0 0 0 0 0 0 0
            1 0 0 1 0 0 0 0 0
            0 0 0 0 0 0 0 0 0
            1 1 0 0 0 0 0 0 0
        ]
        problem = ColoringProblem{:nonsymmetric,:bidirectional}()
        algo = GreedyColoringAlgorithm{:substitution}(NaturalOrder())
        better_algo = GreedyColoringAlgorithm{:substitution}((
            NaturalOrder(), LargestFirst()
        ))
        @test ncolors(coloring(A, problem, better_algo)) <
            ncolors(coloring(A, problem, algo))
    end
end

"""
    SparseMatrixColorings

$README

## Exports

$EXPORTS
"""
module SparseMatrixColorings

using ADTypes: ADTypes
using Base.Iterators: Iterators
using DocStringExtensions: README, EXPORTS, SIGNATURES, TYPEDEF, TYPEDFIELDS
using LinearAlgebra:
    Adjoint,
    Diagonal,
    Hermitian,
    LowerTriangular,
    Symmetric,
    Transpose,
    UpperTriangular,
    adjoint,
    checksquare,
    factorize,
    issymmetric,
    ldiv!,
    parent,
    transpose
using PrecompileTools: @compile_workload
using Random: Random, AbstractRNG, default_rng, randperm
using SparseArrays:
    SparseArrays,
    SparseMatrixCSC,
    dropzeros,
    dropzeros!,
    ftranspose!,
    nnz,
    nonzeros,
    nzrange,
    rowvals,
    sparse,
    sprand,
    spzeros

include("graph.jl")
include("forest.jl")
include("order.jl")
include("coloring.jl")
include("postprocessing.jl")
include("result.jl")
include("matrices.jl")
include("interface.jl")
include("constant.jl")
include("adtypes.jl")
include("decompression.jl")
include("check.jl")
include("examples.jl")
include("show_colors.jl")
include("optimal.jl")

include("precompile.jl")

export NaturalOrder, RandomOrder, LargestFirst
export DynamicDegreeBasedOrder, SmallestLast, IncidenceDegree, DynamicLargestFirst
export PerfectEliminationOrder
export ColoringProblem, GreedyColoringAlgorithm, AbstractColoringResult
export ConstantColoringAlgorithm
export OptimalColoringAlgorithm
export coloring, fast_coloring
export column_colors, row_colors, ncolors
export column_groups, row_groups
export sparsity_pattern
export compress, decompress, decompress!, decompress_single_color!

end

using ArrayInterface: ArrayInterface
using BandedMatrices: BandedMatrix
using Base: promote_eltype
using BlockBandedMatrices: BlockBandedMatrix
using LinearAlgebra
using SparseMatrixColorings
using SparseMatrixColorings:
    AdjacencyGraph,
    LinearSystemColoringResult,
    directly_recoverable_columns,
    matrix_versions,
    respectful_similar,
    structurally_orthogonal_columns,
    symmetrically_orthogonal_columns,
    structurally_biorthogonal,
    substitutable_columns,
    substitutable_bidirectional,
    rank_nonzeros_from_trees
using Test

const _ALL_ORDERS = (
    NaturalOrder(), LargestFirst(), SmallestLast(), IncidenceDegree(), DynamicLargestFirst()
)

function test_coloring_decompression(
    A0::AbstractMatrix,
    problem::ColoringProblem{structure,partition},
    algo::GreedyColoringAlgorithm{decompression};
    B0=nothing,
    color0=nothing,
    test_fast=false,
    gpu=false,
) where {structure,partition,decompression}
    color_vec = Vector{Int}[]
    @testset "$(typeof(A))" for A in matrix_versions(A0)
        yield()

        if structure == :nonsymmetric && issymmetric(A)
            result = coloring(
                A, problem, algo; decompression_eltype=Float32, symmetric_pattern=true
            )
        else
            result = coloring(A, problem, algo; decompression_eltype=Float64)
        end
        color = if partition == :column
            column_colors(result)
        elseif partition == :row
            row_colors(result)
        end
        push!(color_vec, color)

        B = compress(A, result)

        @testset "Coherence" begin
            if partition == :column
                @test ncolors(result) == size(B, 2)
            elseif partition == :row
                @test ncolors(result) == size(B, 1)
            end
            if test_fast
                @test color == fast_coloring(A, problem, algo; symmetric_pattern=false)
            end
        end

        @testset "Reference" begin
            @test sparsity_pattern(result) === A  # identity of objects
            !isnothing(color0) && @test color == color0
            !isnothing(B0) && @test B == B0
        end

        @testset "Full decompression" begin
            @test decompress(B, result) ≈ A0
            @test decompress(B, result) ≈ A0  # check result wasn't modified
            @test decompress!(respectful_similar(A, eltype(B)), B, result) ≈ A0
            @test decompress!(respectful_similar(A, eltype(B)), B, result) ≈ A0
        end

        if gpu
            continue
        end

        @testset "Recoverability" begin
            if decompression == :direct
                if structure == :nonsymmetric
                    if partition == :column
                        @test structurally_orthogonal_columns(A0, color)
                        @test directly_recoverable_columns(A0, color)
                    elseif partition == :row
                        @test structurally_orthogonal_columns(transpose(A0), color)
                        @test directly_recoverable_columns(transpose(A0), color)
                    end
                else
                    # structure == :symmetric
                    if partition == :column
                        @test symmetrically_orthogonal_columns(A0, color)
                        @test directly_recoverable_columns(A0, color)
                    end
                end
            end
        end

        @testset "Substitutable" begin
            if decompression == :substitution
                if structure == :symmetric
                    rank_nonzeros = rank_nonzeros_from_trees(result)
                    @test substitutable_columns(A0, rank_nonzeros, color)
                end
            end
        end

        @testset "Single-color decompression" begin
            if decompression == :direct  # TODO: implement for :substitution too
                A2 = respectful_similar(A, eltype(B))
                A2 .= zero(eltype(A2))
                for c in unique(color)
                    c == 0 && continue
                    if partition == :column
                        decompress_single_color!(A2, B[:, c], c, result)
                    elseif partition == :row
                        decompress_single_color!(A2, B[c, :], c, result)
                    end
                end
                @test A2 ≈ A0
            end
        end

        @testset "Triangle decompression" begin
            if structure == :symmetric
                A3upper = respectful_similar(triu(A), eltype(B))
                A3lower = respectful_similar(tril(A), eltype(B))
                A3both = respectful_similar(A, eltype(B))
                A3upper .= zero(eltype(A))
                A3lower .= zero(eltype(A))
                A3both .= zero(eltype(A))

                decompress!(A3upper, B, result, :U)
                decompress!(A3lower, B, result, :L)
                decompress!(A3both, B, result, :F)

                @test A3upper ≈ triu(A0)
                @test A3lower ≈ tril(A0)
                @test A3both ≈ A0
            end
        end

        @testset "Single-color triangle decompression" begin
            if structure == :symmetric && decompression == :direct
                A4upper = respectful_similar(triu(A), eltype(B))
                A4lower = respectful_similar(tril(A), eltype(B))
                A4both = respectful_similar(A, eltype(B))
                A4upper .= zero(eltype(A))
                A4lower .= zero(eltype(A))
                A4both .= zero(eltype(A))

                for c in unique(color)
                    c == 0 && continue
                    decompress_single_color!(A4upper, B[:, c], c, result, :U)
                    decompress_single_color!(A4lower, B[:, c], c, result, :L)
                    decompress_single_color!(A4both, B[:, c], c, result, :F)
                end

                @test A4upper ≈ triu(A0)
                @test A4lower ≈ tril(A0)
                @test A4both ≈ A0
            end
        end

        @testset "Linear system decompression" begin
            if structure == :symmetric && count(!iszero, A) > 0  # sparse factorization cannot handle empty matrices
                ag = AdjacencyGraph(A)
                linresult = LinearSystemColoringResult(A, ag, color, Float64)
                @test sparsity_pattern(result) === A  # identity of objects
                @test decompress(float.(B), linresult) ≈ A0
                @test decompress!(
                    respectful_similar(A, float(eltype(B))), float.(B), linresult
                ) ≈ A0
            end
        end
    end

    @testset "Coherence between all colorings" begin
        @test all(color_vec .== Ref(color_vec[1]))
        if !all(color_vec .== Ref(color_vec[1]))
            @show color_vec
        end
    end

    @testset "More orders is better" begin
        more_orders = (algo.orders..., _ALL_ORDERS...)
        better_algo = GreedyColoringAlgorithm{decompression}(
            more_orders; algo.postprocessing
        )
        all_algos = [
            GreedyColoringAlgorithm{decompression}(order; algo.postprocessing) for
            order in more_orders
        ]
        result = coloring(A0, problem, algo)
        better_result = coloring(A0, problem, better_algo)
        all_results = [coloring(A0, problem, _algo) for _algo in all_algos]
        @test ncolors(better_result) <= ncolors(result)
        @test ncolors(better_result) == minimum(ncolors, all_results)
    end
end

function test_bicoloring_decompression(
    A0::AbstractMatrix,
    problem::ColoringProblem{:nonsymmetric,:bidirectional},
    algo::GreedyColoringAlgorithm{decompression};
    test_fast=false,
) where {decompression}
    @testset "$(typeof(A))" for A in matrix_versions(A0)
        yield()
        if issymmetric(A)
            result = coloring(
                A, problem, algo; decompression_eltype=Float32, symmetric_pattern=true
            )
        else
            result = coloring(A, problem, algo; decompression_eltype=Float64)
        end
        Br, Bc = compress(A, result)
        row_color, column_color = row_colors(result), column_colors(result)

        @testset "Coherence" begin
            @test size(Br, 1) == length(unique(row_color[row_color .> 0]))
            @test size(Bc, 2) == length(unique(column_color[column_color .> 0]))
            @test ncolors(result) == size(Br, 1) + size(Bc, 2)
            if test_fast
                @test (row_color, column_color) ==
                    fast_coloring(A, problem, algo; symmetric_pattern=false)
            end
        end

        @testset "Full decompression" begin
            @test decompress(Br, Bc, result) ≈ A0
            @test decompress(Br, Bc, result) ≈ A0  # check result wasn't modified
            @test decompress!(
                respectful_similar(A, promote_eltype(Br, Bc)), Br, Bc, result
            ) ≈ A0
            @test decompress!(
                respectful_similar(A, promote_eltype(Br, Bc)), Br, Bc, result
            ) ≈ A0
        end

        if decompression == :direct
            @testset "Recoverability" begin
                @test structurally_biorthogonal(A0, row_color, column_color)
            end
        end

        if decompression == :substitution
            @testset "Substitutable" begin
                rank_nonzeros = rank_nonzeros_from_trees(result)
                @test substitutable_bidirectional(
                    A0, rank_nonzeros, row_color, column_color
                )
            end
        end
    end

    @testset "More orders is better" begin
        more_orders = (algo.orders..., _ALL_ORDERS...)
        better_algo = GreedyColoringAlgorithm{decompression}(
            more_orders; algo.postprocessing
        )
        all_algos = [
            GreedyColoringAlgorithm{decompression}(order; algo.postprocessing) for
            order in more_orders
        ]
        result = coloring(A0, problem, algo)
        better_result = coloring(A0, problem, better_algo)
        all_results = [coloring(A0, problem, _algo) for _algo in all_algos]
        @test ncolors(better_result) <= ncolors(result)
        @test ncolors(better_result) == minimum(ncolors, all_results)
    end
end

function test_structured_coloring_decompression(A::AbstractMatrix)
    column_problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
    row_problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    algo = GreedyColoringAlgorithm()

    # Column
    result = coloring(A, column_problem, algo)
    color = column_colors(result)
    B = compress(A, result)
    D = decompress(B, result)
    @test D == A
    @test nameof(typeof(D)) == nameof(typeof(A))
    @test structurally_orthogonal_columns(A, color)
    if VERSION >= v"1.10" || A isa Union{Diagonal,Bidiagonal,Tridiagonal}
        # banded matrices not supported by ArrayInterface on Julia 1.6
        # @test color == ArrayInterface.matrix_colors(A)  # TODO: uncomment
    end

    # Row
    result = coloring(A, row_problem, algo)
    B = compress(A, result)
    D = decompress(B, result)
    @test D == A
    @test nameof(typeof(D)) == nameof(typeof(A))
end

#=
Visualize colored matrices using the Julia Images ecosystem.
Colors.jl is nearly the most light-weight dependency to achieve this. 

This code is written prioritizing maintainability over performance

How it works
≡≡≡≡≡≡≡≡≡≡≡≡
- First, the outer `show_colors` function gets called, which
    - handles argument errors
    - eagerly promotes color types in `promote_colors` to support transparency
    - allocates an output buffer in `allocate_output`
- The allocated output is a matrix filled with the background color
- An internal `show_color!` function is called on the allocated output
    - for each non-zero entry in the coloring, the output is filled in
=#
module SparseMatrixColoringsColorsExt

using SparseMatrixColorings:
    SparseMatrixColorings,
    AbstractColoringResult,
    sparsity_pattern,
    column_colors,
    row_colors,
    ncolors,
    compress
using Colors: Colorant, RGB, RGBA, distinguishable_colors

# update docstring in src/images.jl when changing this default
const DEFAULT_BACKGROUND_COLOR = RGBA(0, 0, 0, 0)
const DEFAULT_BORDER_COLOR = RGB(0, 0, 0)
const DEFAULT_SCALE = 1
const DEFAULT_BORDER = 0
const DEFAULT_PAD = 0

## Top-level function that handles argument errors, eagerly promotes types and allocates output buffer

function SparseMatrixColorings.show_colors(
    res::AbstractColoringResult;
    colorscheme=nothing,
    background_color::Colorant=DEFAULT_BACKGROUND_COLOR, # color used for zero matrix entries and pad
    border_color::Colorant=DEFAULT_BORDER_COLOR, # color used for zero matrix entries and pad
    scale::Int=DEFAULT_SCALE, # scale size of matrix entries to `scale × scale` pixels
    border::Int=DEFAULT_BORDER,  # border around matrix entries
    pad::Int=DEFAULT_PAD, # pad between matrix entries
    warn::Bool=true,
)
    scale < 1 && throw(ArgumentError("`scale` has to be ≥ 1."))
    border < 0 && throw(ArgumentError("`border` has to be ≥ 0."))
    pad < 0 && throw(ArgumentError("`pad` has to be ≥ 0."))

    if !isnothing(colorscheme)
        if warn && ncolors(res) > length(colorscheme)
            @warn "`show_colors` will reuse colors since the provided `colorscheme` has $(length(colorscheme)) colors and the matrix needs $(ncolors(res)). You can turn off this warning via the keyword argument `warn = false`, or choose a larger `colorscheme` from ColorSchemes.jl."
        end
        colorscheme, background_color, border_color = promote_colors(
            colorscheme, background_color, border_color
        )
    else
        # Sample n distinguishable colors, excluding the background and border color
        colorscheme = distinguishable_colors(
            ncolors(res),
            [convert(RGB, background_color), convert(RGB, border_color)];
            dropseed=true,
        )
    end
    outs = allocate_outputs(res, background_color, border_color, scale, border, pad)
    return show_colors!(outs..., res, colorscheme, scale, border, pad)
end

function promote_colors(colorscheme, background_color, border_color)
    # eagerly promote colors to same type
    T = promote_type(eltype(colorscheme), typeof(background_color), typeof(border_color))
    colorscheme = convert.(T, colorscheme)
    background_color = convert(T, background_color)
    border_color = convert(T, border_color)
    return colorscheme, background_color, border_color
end

# Given a CartesianIndex I of an entry in the original matrix, 
# this function returns the corresponding area in the output image as CartesianIndices.
function matrix_entry_area(I::CartesianIndex, scale, border, pad)
    stencil = CartesianIndices((1:scale, 1:scale))
    return CartesianIndex(1, 1) * (border + pad) +
           (I - CartesianIndex(1, 1)) * (scale + 2border + pad) .+ stencil
end

function matrix_entry_plus_border_area(I::CartesianIndex, scale, border, pad)
    stencil = CartesianIndices((1:(scale + 2border), 1:(scale + 2border)))
    return CartesianIndex(1, 1) * pad +
           (I - CartesianIndex(1, 1)) * (scale + 2border + pad) .+ stencil
end

function allocate_outputs(
    res::Union{AbstractColoringResult{s,:column},AbstractColoringResult{s,:row}},
    background_color::Colorant,
    border_color::Colorant,
    scale::Int,
    border::Int,
    pad::Int,
) where {s}
    A = sparsity_pattern(res)
    B = compress(A, res)
    Base.require_one_based_indexing(A)
    Base.require_one_based_indexing(B)
    hA, wA = size(A) .* (scale + 2border + pad) .+ (pad)
    hB, wB = size(B) .* (scale + 2border + pad) .+ (pad)
    A_img = fill(background_color, hA, wA)
    B_img = fill(background_color, hB, wB)
    for I in CartesianIndices(A)
        if !iszero(A[I])
            area = matrix_entry_area(I, scale, border, pad)
            barea = matrix_entry_plus_border_area(I, scale, border, pad)
            A_img[barea] .= border_color
            A_img[area] .= background_color
        end
    end
    for I in CartesianIndices(B)
        if !iszero(B[I])
            area = matrix_entry_area(I, scale, border, pad)
            barea = matrix_entry_plus_border_area(I, scale, border, pad)
            B_img[barea] .= border_color
            B_img[area] .= background_color
        end
    end
    return A_img, B_img
end

function allocate_outputs(
    res::AbstractColoringResult{s,:bidirectional},
    background_color::Colorant,
    border_color::Colorant,
    scale::Int,
    border::Int,
    pad::Int,
) where {s}
    A = sparsity_pattern(res)
    Br, Bc = compress(A, res)
    Base.require_one_based_indexing(A)
    Base.require_one_based_indexing(Br)
    Base.require_one_based_indexing(Bc)
    hA, wA = size(A) .* (scale + 2border + pad) .+ (pad)
    hBr, wBr = size(Br) .* (scale + 2border + pad) .+ (pad)
    hBc, wBc = size(Bc) .* (scale + 2border + pad) .+ (pad)
    Arc_img = fill(background_color, hA, wA)
    Ar_img = fill(background_color, hA, wA)
    Ac_img = fill(background_color, hA, wA)
    Br_img = fill(background_color, hBr, wBr)
    Bc_img = fill(background_color, hBc, wBc)
    for I in CartesianIndices(A)
        if !iszero(A[I])
            area = matrix_entry_area(I, scale, border, pad)
            barea = matrix_entry_plus_border_area(I, scale, border, pad)
            Arc_img[barea] .= border_color
            Ar_img[barea] .= border_color
            Ac_img[barea] .= border_color
            Arc_img[area] .= background_color
            Ar_img[area] .= background_color
            Ac_img[area] .= background_color
        end
    end
    for I in CartesianIndices(Br)
        if !iszero(Br[I])
            area = matrix_entry_area(I, scale, border, pad)
            barea = matrix_entry_plus_border_area(I, scale, border, pad)
            Br_img[barea] .= border_color
            Br_img[area] .= background_color
        end
    end
    for I in CartesianIndices(Bc)
        if !iszero(Bc[I])
            area = matrix_entry_area(I, scale, border, pad)
            barea = matrix_entry_plus_border_area(I, scale, border, pad)
            Bc_img[barea] .= border_color
            Bc_img[area] .= background_color
        end
    end
    return Arc_img, Ar_img, Ac_img, Br_img, Bc_img
end

## Implementations for different AbstractColoringResult types start here

function show_colors!(
    A_img::AbstractMatrix{<:Colorant},
    B_img::AbstractMatrix{<:Colorant},
    res::AbstractColoringResult{s,:column},
    colorscheme,
    scale::Int,
    border::Int,
    pad::Int,
) where {s}
    # cycle color indices if necessary
    A_color_indices = mod1.(column_colors(res), length(colorscheme))
    B_color_indices = mod1.(1:ncolors(res), length(colorscheme))
    A_colors = colorscheme[A_color_indices]
    B_colors = colorscheme[B_color_indices]
    A = sparsity_pattern(res)
    B = compress(A, res)
    for I in CartesianIndices(A)
        if !iszero(A[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            if column_colors(res)[c] > 0
                A_img[area] .= A_colors[c]
            end
        end
    end
    for I in CartesianIndices(B)
        if !iszero(B[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            B_img[area] .= B_colors[c]
        end
    end
    return A_img, B_img
end

function show_colors!(
    A_img::AbstractMatrix{<:Colorant},
    B_img::AbstractMatrix{<:Colorant},
    res::AbstractColoringResult{s,:row},
    colorscheme,
    scale::Int,
    border::Int,
    pad::Int,
) where {s}
    # cycle color indices if necessary
    A_color_indices = mod1.(row_colors(res), length(colorscheme))
    B_color_indices = mod1.(1:ncolors(res), length(colorscheme))
    A_colors = colorscheme[A_color_indices]
    B_colors = colorscheme[B_color_indices]
    A = sparsity_pattern(res)
    B = compress(A, res)
    for I in CartesianIndices(A)
        if !iszero(A[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            if row_colors(res)[r] > 0
                A_img[area] .= A_colors[r]
            end
        end
    end
    for I in CartesianIndices(B)
        if !iszero(B[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            B_img[area] .= B_colors[r]
        end
    end
    return A_img, B_img
end

mytriu(area) = [area[i, j] for i in axes(area, 1) for j in axes(area, 2) if i < j]
mytril(area) = [area[i, j] for i in axes(area, 1) for j in axes(area, 2) if i > j]

function show_colors!(
    Arc_img::AbstractMatrix{<:Colorant},
    Ar_img::AbstractMatrix{<:Colorant},
    Ac_img::AbstractMatrix{<:Colorant},
    Br_img::AbstractMatrix{<:Colorant},
    Bc_img::AbstractMatrix{<:Colorant},
    res::AbstractColoringResult{s,:bidirectional},
    colorscheme,
    scale::Int,
    border::Int,
    pad::Int,
) where {s}
    scale < 3 && throw(ArgumentError("`scale` has to be ≥ 3 to visualize bicoloring"))
    # cycle color indices if necessary
    row_shift = maximum(column_colors(res))
    A_ccolor_indices = mod1.(column_colors(res), length(colorscheme))
    A_rcolor_indices = mod1.(row_shift .+ row_colors(res), length(colorscheme))
    B_ccolor_indices = mod1.(1:maximum(column_colors(res)), length(colorscheme))
    B_rcolor_indices =
        mod1.((row_shift + 1):(row_shift + maximum(row_colors(res))), length(colorscheme))
    A_ccolors = colorscheme[A_ccolor_indices]
    A_rcolors = colorscheme[A_rcolor_indices]
    B_ccolors = colorscheme[B_ccolor_indices]
    B_rcolors = colorscheme[B_rcolor_indices]
    A = sparsity_pattern(res)
    Br, Bc = compress(A, res)
    for I in CartesianIndices(A)
        if !iszero(A[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            if column_colors(res)[c] > 0
                Arc_img[mytriu(area)] .= A_ccolors[c]
                Ac_img[area] .= A_ccolors[c]
            end
            if row_colors(res)[r] > 0
                Arc_img[mytril(area)] .= A_rcolors[r]
                Ar_img[area] .= A_rcolors[r]
            end
        end
    end
    for I in CartesianIndices(Br)
        if !iszero(Br[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            Br_img[area] .= B_rcolors[r]
        end
    end
    for I in CartesianIndices(Bc)
        if !iszero(Bc[I])
            r, c = Tuple(I)
            area = matrix_entry_area(I, scale, border, pad)
            Bc_img[area] .= B_ccolors[c]
        end
    end
    return Arc_img, Ar_img, Ac_img, Br_img, Bc_img
end

end # module

using LinearAlgebra
using SparseArrays
using SparseMatrixColorings:
    BipartiteGraph,
    AdjacencyGraph,
    matrix_versions,
    respectful_similar,
    compatible_pattern,
    check_compatible_pattern
using StableRNGs
using Test

rng = StableRNG(63)

@testset "Matrix versions" begin
    A0_dense = rand(3, 4)
    A0_sparse = sprand(rng, 10, 20, 0.3)
    @test all(==(A0_dense), matrix_versions(A0_dense))
    @test all(==(A0_sparse), matrix_versions(A0_sparse))
end

same_view(::AbstractMatrix, ::AbstractMatrix) = false
same_view(::Matrix, ::Matrix) = true
same_view(::SparseMatrixCSC, ::SparseMatrixCSC) = true
same_view(::Transpose, ::Transpose) = true
same_view(::Adjoint, ::Adjoint) = true

@testset "Respectful similar" begin
    A0_dense = rand(3, 4)
    A0_sparse = sprand(rng, 10, 20, 0.3)
    @test all(matrix_versions(A0_dense)) do A
        B = respectful_similar(A)
        size(B) == size(A) && same_view(A, B)
    end
    @test all(matrix_versions(A0_sparse)) do A
        B = respectful_similar(A)
        size(B) == size(A) && same_view(A, B)
    end
end

@testset "Compatible sparsity pattern -- BipartiteGraph" begin
    S = sparse([
        0 1 1
        0 1 0
        1 1 0
    ])

    A1 = copy(S)
    A2 = copy(S)
    A2[1, 1] = 1

    bg1 = BipartiteGraph(A1)
    bg2 = BipartiteGraph(A2)
    @test compatible_pattern(S, bg1)
    @test !compatible_pattern(S, bg2)
    @test compatible_pattern(Matrix(S), bg1)

    @test_throws DimensionMismatch check_compatible_pattern(S, bg2)
end

@testset "Compatible sparsity pattern -- AdjacencyGraph" begin
    S = sparse([
        1 0 1
        0 1 1
        1 1 0
    ])

    A1 = copy(S)
    A2 = copy(S)
    A2[3, 3] = 1

    ag1 = AdjacencyGraph(A1)
    ag2 = AdjacencyGraph(A2)
    for (op, uplo) in ((tril, :L), (triu, :U), (identity, :F))
        @test compatible_pattern(op(S), ag1, uplo)
        @test !compatible_pattern(op(S), ag2, uplo)
        @test compatible_pattern(Matrix(op(S)), ag1, uplo)

        @test_throws DimensionMismatch check_compatible_pattern(op(S), ag2, uplo)
    end
end

using SparseArrays
using SparseMatrixColorings
using SparseMatrixColorings:
    structurally_orthogonal_columns,
    symmetrically_orthogonal_columns,
    directly_recoverable_columns,
    what_fig_41,
    what_fig_61,
    efficient_fig_1,
    efficient_fig_4
using StableRNGs
using Test

@testset "Column coloring & decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    A0 = sparse([
        1 0 2
        0 3 4
        5 0 0
    ])
    B0 = [
        1 2
        3 4
        5 0
    ]
    color0 = [1, 1, 2]
    @test structurally_orthogonal_columns(A0, color0)
    @test directly_recoverable_columns(A0, color0)
    test_coloring_decompression(A0, problem, algo; B0, color0, test_fast=true)
end;

@testset "Row coloring & decompression" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
    algo = GreedyColoringAlgorithm(; decompression=:direct)
    A0 = sparse([
        1 0 3
        0 2 0
        4 5 0
    ])
    B0 = [
        1 2 3
        4 5 0
    ]
    color0 = [1, 1, 2]
    @test structurally_orthogonal_columns(transpose(A0), color0)
    @test directly_recoverable_columns(transpose(A0), color0)
    test_coloring_decompression(A0, problem, algo; B0, color0, test_fast=true)
end;

@testset "Symmetric coloring & direct decompression" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; decompression=:direct)

    @testset "Fig 4.1 from 'What color is your Jacobian'" begin
        example = what_fig_41()
        A0, B0, color0 = example.A, example.B, example.color
        @test symmetrically_orthogonal_columns(A0, color0)
        @test directly_recoverable_columns(A0, color0)
        test_coloring_decompression(A0, problem, algo; B0, color0, test_fast=true)
    end

    @testset "Fig 1 from 'Efficient computation of sparse hessians using coloring and AD'" begin
        example = efficient_fig_1()
        A0, B0, color0 = example.A, example.B, example.color
        @test symmetrically_orthogonal_columns(A0, color0)
        @test directly_recoverable_columns(A0, color0)
        test_coloring_decompression(A0, problem, algo; B0, color0, test_fast=true)
    end
end;

@testset "Symmetric coloring & substitution decompression" begin
    problem = ColoringProblem(; structure=:symmetric, partition=:column)
    algo = GreedyColoringAlgorithm(; decompression=:substitution)

    @testset "Fig 6.1 from 'What color is your Jacobian'" begin
        example = what_fig_61()
        A0, B0, color0 = example.A, example.B, example.color
        # our coloring doesn't give the color0 from the example, but that's okay
        test_coloring_decompression(A0, problem, algo; test_fast=true)
    end

    @testset "Fig 4 from 'Efficient computation of sparse hessians using coloring and AD'" begin
        example = efficient_fig_4()
        A0, B0, color0 = example.A, example.B, example.color
        test_coloring_decompression(A0, problem, algo; B0, color0, test_fast=true)
    end
end;

@testset "Bidirectional coloring" begin
    problem = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
    order = RandomOrder(StableRNG(0), 0)

    @testset "Anti-diagonal" begin
        A = sparse([0 0 0 1; 0 0 1 0; 0 1 0 0; 1 0 0 0])

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:direct}(; postprocessing=false)
        )
        @test ncolors(result) == 2

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:direct}(; postprocessing=true)
        )
        @test ncolors(result) == 1

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:substitution}(; postprocessing=false)
        )
        @test ncolors(result) == 2

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:substitution}(; postprocessing=true)
        )
        @test ncolors(result) == 1
    end

    @testset "Triangle" begin
        A = sparse([1 1 0; 0 1 1; 1 0 1])

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:direct}(; postprocessing=true)
        )
        @test ncolors(result) == 3

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:substitution}(; postprocessing=true)
        )
        @test ncolors(result) == 3
    end

    @testset "Rectangle" begin
        A = spzeros(Bool, 10, 20)
        A[:, 1] .= 1
        A[:, end] .= 1
        A[1, :] .= 1
        A[end, :] .= 1

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:direct}(order; postprocessing=false)
        )
        @test ncolors(result) == 6  # two more than necessary
        result = coloring(
            A, problem, GreedyColoringAlgorithm{:direct}(order; postprocessing=true)
        )
        @test ncolors(result) == 4  # optimal number

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:substitution}(order; postprocessing=false)
        )
        @test ncolors(result) == 6  # two more than necessary
        result = coloring(
            A, problem, GreedyColoringAlgorithm{:substitution}(order; postprocessing=true)
        )
        @test ncolors(result) == 4  # optimal number
    end

    @testset "Arrowhead" begin
        A = spzeros(Bool, 10, 10)
        for i in axes(A, 1)
            A[1, i] = 1
            A[i, 1] = 1
            A[i, i] = 1
        end

        result = coloring(
            A, problem, GreedyColoringAlgorithm{:direct}(order; postprocessing=true)
        )
        @test ncolors(coloring(A, problem, GreedyColoringAlgorithm{:substitution}(order))) <
            ncolors(coloring(A, problem, GreedyColoringAlgorithm{:direct}(order)))

        @test ncolors(
            coloring(
                A,
                problem,
                GreedyColoringAlgorithm{:substitution}(order; postprocessing=true),
            ),
        ) < ncolors(
            coloring(
                A, problem, GreedyColoringAlgorithm{:direct}(order; postprocessing=true)
            ),
        )

        test_bicoloring_decompression(
            A,
            problem,
            GreedyColoringAlgorithm{:direct}(order; postprocessing=true);
            test_fast=true,
        )

        test_bicoloring_decompression(
            A,
            problem,
            GreedyColoringAlgorithm{:substitution}(order; postprocessing=true);
            test_fast=true,
        )
    end
end;

module SparseMatrixColoringsCliqueTreesExt

import CliqueTrees: permutation, EliminationAlgorithm, MCS
import SparseArrays: SparseMatrixCSC, rowvals, nnz
import SparseMatrixColorings:
    AdjacencyGraph, BipartiteGraph, PerfectEliminationOrder, pattern, vertices

PerfectEliminationOrder() = PerfectEliminationOrder(MCS())

function vertices(g::AdjacencyGraph{T}, order::PerfectEliminationOrder) where {T}
    S = pattern(g)

    # construct matrix with sparsity pattern S
    M = SparseMatrixCSC{Bool,T}(size(S)..., S.colptr, rowvals(S), ones(Bool, nnz(S)))

    # construct a perfect elimination order
    # self-loops are ignored
    order, _ = permutation(M; alg=order.elimination_algorithm)

    return reverse!(order)
end

end # module

# Tutorial

Here we give a brief introduction to the contents of the package, see the [API reference](@ref) for more details.

```@example tutorial
using SparseMatrixColorings
using LinearAlgebra
using SparseArrays
using StableRNGs
using SparseMatrixColorings: show_colors # hide
using Images # hide

scale=15 # hide
pad=3 # hide
border=2 # hide
nothing # hide
```

## Coloring problems and algorithms

SparseMatrixColorings.jl is based on the combination of a coloring problem and a coloring algorithm, which will be passed to the [`coloring`](@ref) function.

The problem defines what you want to solve. It is always a [`ColoringProblem`](@ref), and you can select options such as

- the structure of the matrix (`:nonsymmetric` or `:symmetric`)
- the type of partition you want (`:column`, `:row` or `:bidirectional`).

```@example tutorial
problem = ColoringProblem()
```

The algorithm defines how you want to solve it. It can be either a [`GreedyColoringAlgorithm`](@ref) or a [`ConstantColoringAlgorithm`](@ref). For `GreedyColoringAlgorithm`, you can select options such as

- the order in which vertices are processed (a subtype of [`AbstractOrder`](@ref SparseMatrixColorings.AbstractOrder) , or a tuple of such objects)
- the type of decompression you want (`:direct` or `:substitution`)

```@example tutorial
algo = GreedyColoringAlgorithm()
```

## Coloring results

The [`coloring`](@ref) function takes a matrix, a problem and an algorithm, to return a result subtyping [`AbstractColoringResult`](@ref).

```@example tutorial
S = sparse([
    0 0 1 1 0 1
    1 0 0 0 1 0
    0 1 0 0 1 0
    0 1 1 0 0 0
])

result = coloring(S, problem, algo)
```

The detailed type and fields of that result are _not part of the public API_.
To access its contents, you can use the following getters:

- [`sparsity_pattern`](@ref) for the matrix initially provided to `coloring`
- [`ncolors`](@ref) for the total number of distinct colors
- [`row_colors`](@ref), [`column_colors`](@ref) for vectors of integer colors (depending on the partition)
- [`row_groups`](@ref), [`column_groups`](@ref) for vector of row or column indices grouped by color (depending on the partition)

Here, we have a column coloring, so we can try the following:

```@example tutorial
column_colors(result)
```

```@example tutorial
column_groups(result)
```

```@example tutorial
ncolors(result)
```

## Compression and decompression

The functions [`compress`](@ref) and [`decompress`](@ref) efficiently store and retrieve compressed representations of sparse matrices, using the coloring result as a starting point.

Compression sums all columns or rows with the same color:

```@example tutorial
M = sparse([
    0 0 4 6 0 9
    1 0 0 0 7 0
    0 2 0 0 8 0
    0 3 5 0 0 0
])

B = compress(M, result)
```

Decompression recovers the original matrix from its compressed version:

```@example tutorial
C = decompress(B, result)
```

The functions [`decompress!`](@ref) and [`decompress_single_color!`](@ref) are in-place variants of [`decompress`](@ref).

```@example tutorial
D = [
    10 14 18
    11 15 0
    12 16 0
    13 17 0
]

decompress!(C, D, result)
```

```@example tutorial
nonzeros(C) .= -1
decompress_single_color!(C, D[:, 2], 2, result)
```

## Unidirectional variants

We now illustrate the variants of colorings available, on the following matrix:

```@example tutorial
S = sparse(Symmetric(sprand(StableRNG(0), Bool, 10, 10, 0.4)))
```

We start with unidirectional colorings, where only rows or columns are colored and the matrix is not assumed to be symmetric.

### Column coloring

```@example tutorial
problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
algo = GreedyColoringAlgorithm(; decompression=:direct)
result = coloring(S, problem, algo)
nothing # hide
```

```@example tutorial
ncolors(result), column_colors(result)
```

Here is the colored matrix

```@example tutorial
A_img, B_img = show_colors(result; scale, pad, border) # hide
A_img # hide
```

and its columnwise compression

```@example tutorial
B_img # hide
```

### Row coloring

```@example tutorial
problem = ColoringProblem(; structure=:nonsymmetric, partition=:row)
algo = GreedyColoringAlgorithm(; decompression=:direct)
result = coloring(S, problem, algo)
nothing # hide
```

```@example tutorial
ncolors(result), row_colors(result)
```

Here is the colored matrix

```@example tutorial
A_img, B_img = show_colors(result; scale, pad, border) # hide
A_img # hide
```

and its rowwise compression

```@example tutorial
B_img # hide
```

## Symmetric variants

We continue with unidirectional symmetric colorings, where coloring rows is equivalent to coloring columns.
Symmetry is leveraged to possibly reduce the number of necessary colors.

### Star coloring

Star coloring is the algorithm used for symmetric matrices with direct decompression.

```@example tutorial
problem = ColoringProblem(; structure=:symmetric, partition=:column)
algo = GreedyColoringAlgorithm(; decompression=:direct)
result = coloring(S, problem, algo)
nothing # hide
```

```@example tutorial
ncolors(result), column_colors(result)
```

Here is the colored matrix

```@example tutorial
A_img, B_img = show_colors(result; scale, pad, border) # hide
A_img # hide
```

and its columnwise compression

```@example tutorial
B_img # hide
```

### Acyclic coloring

Acyclic coloring is the algorithm used for symmetric matrices with decompression by substitution.

```@example tutorial
problem = ColoringProblem(; structure=:symmetric, partition=:column)
algo = GreedyColoringAlgorithm(; decompression=:substitution)
result = coloring(S, problem, algo)
nothing # hide
```

```@example tutorial
ncolors(result), column_colors(result)
```

Here is the colored matrix

```@example tutorial
A_img, B_img = show_colors(result; scale, pad, border) # hide
A_img # hide
```

and its columnwise compression

```@example tutorial
B_img # hide
```

## Bidirectional variants

We finish with bidirectional colorings, where both rows and columns are colored and the matrix is not assumed to be symmetric.

Bicoloring is most relevant for matrices with dense rows and columns, which is why we consider the following test case:

```@example tutorial
S_bi = copy(S)
S_bi[:, 1] .= true
S_bi[1, :] .= true
S_bi
```

With our implementations, bidirectional coloring works better using a [`RandomOrder`](@ref).

### Star bicoloring

```@example tutorial
problem = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
algo = GreedyColoringAlgorithm(RandomOrder(StableRNG(0), 0); decompression=:direct)
result = coloring(S_bi, problem, algo)
nothing # hide
```

```@example tutorial
ncolors(result), column_colors(result)
```

Here is the colored matrix

```@example tutorial
Arc_img, _, _, Br_img, Bc_img = show_colors(result; scale, pad, border) # hide
Arc_img # hide
```

its columnwise compression

```@example tutorial
Bc_img # hide
```

and rowwise compression

```@example tutorial
Br_img # hide
```

Both are necessary to reconstruct the original.

#### Acyclic bicoloring

```@example tutorial
problem = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
algo = GreedyColoringAlgorithm(RandomOrder(StableRNG(0), 0); decompression=:substitution)
result = coloring(S_bi, problem, algo)
nothing # hide
```

```@example tutorial
ncolors(result), column_colors(result)
```

Here is the colored matrix

```@example tutorial
Arc_img, _, _, Br_img, Bc_img = show_colors(result; scale=20, pad, border) # hide
Arc_img # hide
```

its columnwise compression

```@example tutorial
Bc_img # hide
```

and rowwise compression

```@example tutorial
Br_img # hide
```

Both are necessary to reconstruct the original.

# Visualization

SparseMatrixColorings provides some internal utilities for visualization of matrix colorings via the un-exported function [`SparseMatrixColorings.show_colors`](@ref).

!!! warning
    This function makes use of the [JuliaImages](https://juliaimages.org) ecosystem.
    Using it requires loading at least [Colors.jl](https://github.com/JuliaGraphics/Colors.jl).
    We recommend loading the full [Images.jl](https://github.com/JuliaImages/Images.jl) package for convenience, which includes Colors.jl.

```@example img
using ColorSchemes
using Images
using SparseArrays
using SparseMatrixColorings
using SparseMatrixColorings: show_colors
using StableRNGs
```

## Basic usage

To obtain a visualization, simply call `show_colors` on a coloring result. It returns a tuple of outputs, corresponding to the matrix and its compression(s):

```@example img
S = sparse([
    0 0 1 1 0 1
    1 0 0 0 1 0
    0 1 0 0 1 0
    0 1 1 0 0 0
]);

problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
algo = GreedyColoringAlgorithm(; decompression=:direct)
result = coloring(S, problem, algo)

A_img, B_img = show_colors(result; scale=3)
```

The colors on the original matrix look like this:

```@example img
A_img
```

And its column compression looks like that:

```@example img
B_img
```

!!! tip "Terminal support"
    Loading [ImageInTerminal.jl](https://github.com/JuliaImages/ImageInTerminal.jl) will allow you to show the output of `show_colors` within your terminal.
    If you use VSCode's Julia REPL, the matrix will be displayed in the plot tab.

## Customization

The visualization can be customized via keyword arguments.
The size of the matrix entries is defined by `scale`, while gaps between them are dictated by `pad`.
We recommend using the [ColorSchemes.jl](https://github.com/JuliaGraphics/ColorSchemes.jl) catalogue to customize the `colorscheme`.
Finally, a background color can be passed via the `background` keyword argument. To obtain transparent backgrounds, use the `RGBA` type.

We demonstrate this on a bidirectional coloring.

```@example img; continue = true
S = sparse([
    1 1 1 1 1 1 1 1 1
    1 0 0 0 0 0 0 0 1
    1 0 0 0 0 0 0 0 1
    1 0 0 0 0 0 0 0 1
    1 0 0 0 0 0 0 0 1
    1 1 1 1 1 1 1 1 1
])

problem_bi = ColoringProblem(; structure=:nonsymmetric, partition=:bidirectional)
algo_bi = GreedyColoringAlgorithm(RandomOrder(StableRNG(0)); postprocessing=true, decompression=:direct)
result_bi = coloring(S, problem_bi, algo_bi)

Arc_img, Ar_img, Ac_img, Br_img, Bc_img = show_colors(
    result_bi;
    colorscheme=ColorSchemes.progress,
    background_color=RGB(1, 1, 1),  # white
    scale=10,
    border=1,
    pad=2
)
```

In the bidirectional case, columns and rows can both get colors:

```@example img
Ar_img
```

```@example img
Ac_img
```

Together, this yields:

```@example img
Arc_img
```

And there are two associated compression results, one by row and one by column:

```@example img
Br_img
```

```@example img
Bc_img
```

## Working with large matrices

Let's demonstrate visualization of a larger random matrix:

```@example img
S = sprand(50, 50, 0.1) # sample sparse matrix

problem = ColoringProblem(; structure=:nonsymmetric, partition=:column)
algo = GreedyColoringAlgorithm(; decompression=:direct)
result = coloring(S, problem, algo)
show_colors(result; scale=5, pad=1)[1]
```

Instead of the default `distinguishable_colors` from Colors.jl, one can subsample a continuous colorscheme from ColorSchemes.jl:

```@example img
ncolors = maximum(column_colors(result)) # for partition=:column
colorscheme = get(ColorSchemes.rainbow, range(0.0, 1.0, length=ncolors))
show_colors(result; colorscheme=colorscheme, scale=5, pad=1)[1]
```

## Saving images

The resulting image can be saved to a variety of formats, like PNG.
The `scale` and `pad` parameters determine the number of pixels, and thus the size of the file.

```julia
A_img, _ = show_colors(result, scale=5)
save("coloring.png", A_img)
```

Refer to the JuliaImages [documentation on saving](https://juliaimages.org/stable/function_reference/#ref_io) for more information.

# Internals

```@meta
CollapsedDocStrings = true
CurrentModule = SparseMatrixColorings
```

The docstrings on this page describe internals, they are not part of the public API.

## Graph storage

```@docs
SparseMatrixColorings.SparsityPatternCSC
SparseMatrixColorings.AdjacencyGraph
SparseMatrixColorings.BipartiteGraph
SparseMatrixColorings.vertices
SparseMatrixColorings.neighbors
transpose
SparseMatrixColorings.bidirectional_pattern
```

## Low-level coloring

```@docs
SparseMatrixColorings.partial_distance2_coloring
SparseMatrixColorings.star_coloring
SparseMatrixColorings.acyclic_coloring
SparseMatrixColorings.group_by_color
SparseMatrixColorings.Forest
SparseMatrixColorings.StarSet
SparseMatrixColorings.TreeSet
```

## Concrete coloring results

```@docs
SparseMatrixColorings.ColumnColoringResult
SparseMatrixColorings.RowColoringResult
SparseMatrixColorings.StarSetColoringResult
SparseMatrixColorings.TreeSetColoringResult
SparseMatrixColorings.LinearSystemColoringResult
SparseMatrixColorings.BicoloringResult
SparseMatrixColorings.remap_colors
SparseMatrixColorings.decompress_csc!
```

## Testing

```@docs
SparseMatrixColorings.directly_recoverable_columns
SparseMatrixColorings.symmetrically_orthogonal_columns
SparseMatrixColorings.structurally_orthogonal_columns
SparseMatrixColorings.structurally_biorthogonal
SparseMatrixColorings.substitutable_columns
SparseMatrixColorings.substitutable_bidirectional
SparseMatrixColorings.rank_nonzeros_from_trees
SparseMatrixColorings.valid_dynamic_order
```

## Matrix handling

```@docs
SparseMatrixColorings.respectful_similar
SparseMatrixColorings.matrix_versions
SparseMatrixColorings.compatible_pattern
```

## Visualization

```@docs
SparseMatrixColorings.show_colors
```

## Examples

```@docs
SparseMatrixColorings.Example
SparseMatrixColorings.what_fig_41
SparseMatrixColorings.what_fig_61
SparseMatrixColorings.efficient_fig_1
SparseMatrixColorings.efficient_fig_4
```

# API reference

```@meta
CollapsedDocStrings = true
CurrentModule = SparseMatrixColorings
```

The docstrings on this page define the public API of the package.

```@docs
SparseMatrixColorings
```

## Main function

```@docs
coloring
fast_coloring
ColoringProblem
```

## Coloring algorithms

```@docs
GreedyColoringAlgorithm
ConstantColoringAlgorithm
OptimalColoringAlgorithm
```

## Result analysis

```@docs
AbstractColoringResult
column_colors
row_colors
ncolors
column_groups
row_groups
sparsity_pattern
```

## Decompression

```@docs
compress
decompress
decompress!
decompress_single_color!
```

## Orders

```@docs
AbstractOrder
NaturalOrder
RandomOrder
LargestFirst
SmallestLast
IncidenceDegree
DynamicLargestFirst
DynamicDegreeBasedOrder
PerfectEliminationOrder
```
